2006-12-30  Casey Marshall  <csm@gnu.org>

	* gnu/java/security/x509/X509Certificate.java (serialVersionUID):
	new constant.
	(extensions): parameterize.
	(getExtendedKeyUsage): parameterize return type.
	(getSubjectAlternativeNames): parameterize return type; handle changes
	to `SubjectAlternativeNames' class.
	(getIssuerAlternativeNames): parameterize return type; handle changes
	to `IssuerAlternativeNames' class.
	(getCriticalExtensionOIDs, getNonCriticalExtensionOIDs): parameterize
	return type.
	* gnu/java/security/x509/ext/CertificatePolicies.java
	(policies, policyQualifierInfos): parameterize.
	* gnu/java/security/x509/ext/ExtendedKeyUsage.java (purposeIds): 
	parameterize.
	* gnu/java/security/x509/ext/Extension.java (<init>): add support
	for NameConstraints extension.
	* gnu/java/security/x509/ext/GeneralName.java: new class.
	* gnu/java/security/x509/ext/GeneralNames.java (names): parameterize;
	retrofit to use the GeneralName class. 
	* gnu/java/security/x509/ext/GeneralSubtree.java: new class.
	* gnu/java/security/x509/ext/IssuerAlternativeNames.java (getNames):
	change return type to GeneralName parameterized list.
	* gnu/java/security/x509/ext/NameConstraints.java: new class.
	* gnu/java/security/x509/ext/SubjectAlternativeNames.java (getNames):
	change return type to GeneralName parameterized list.
	* java/security/cert/X509CertSelector.java: re-sorted methods.
	(makeName): new method.
	(addPathToName, addPathToName, getPathToNames, getPolicy,
	getSubjectAlternativeNames, setPathToNames, setPolicy): implemented.
	(keyPurposeSet, altNames, policy): parametized.
	(pathToNames): new field.

2006-12-29  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/text/DateFormatSymbols:
	(DateFormatSymbols()): Update documentation.
	(DateFormatSymbols(Locale)): Likewise.
	(getInstance()): Implemented.
	(getInstance(Locale)): Partially implemented.
	* java/util/Calendar.java:
	(SHORT, LONG, ALL_STYLES): New constants.
	(getDisplayName(int,int,Locale)); Implemented.
	(getDisplayNames(int,int,Locale)): Likewise.
	
2006-12-28  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/util/Arrays.java:
	(copyOf(boolean[],int)): Implemented.
	(copyOfRange(boolean[],int,int)): Likewise.
	(copyOf(byte[],int)): Likewise.
	(copyOfRange(byte[],int,int)): Likewise.
	(copyOf(char[],int)): Likewise.
	(copyOfRange(char[],int,int)): Likewise.
	(copyOf(double[],int)): Likewise.
	(copyOfRange(double[],int,int)): Likewise.
	(copyOf(float[],int)): Likewise.
	(copyOfRange(float[],int,int)): Likewise.
	(copyOf(int[],int)): Likewise.
	(copyOfRange(int[],int,int)): Likewise.
	(copyOf(long[],int)): Likewise.
	(copyOfRange(long[],int,int)): Likewise.
	(copyOf(short[],int)): Likewise.
	(copyOfRange(short[],int,int)): Likewise.
	(copyOf(T[],int)): Likewise.
	(copyOfRange(T[],int,int)): Likewise.
	(copyOf(U[],int,Class<? extends T>)): Likewise.
	(copyOfRange(U[],int,int,Class<? extends T>)):
	Likewise.
	* java/util/Collections.java:
	(asLifoQueue(Deque<T>)): Implemented.
	(newSetFromMap(Map<E>)): Likewise.
	(MapSet): New class for newSetFromMap.
	(LIFOQueue): New class for asLifoQueue.
	
2006-12-28  Jeroen Frijters  <jeroen@frijters.net>

	* javax/net/ssl/SSLServerSocketFactory.java:
	(getDefault): Return inoperative factory instead of throwing error
	(as per spec).
	(ErrorServerSocketFactory): New class.
	* javax/net/ssl/SSLSocketFactory.java:
	(getDefault): Return inoperative factory instead of throwing error
	(as per spec).
	(ErrorSocketFactory): New class.

2006-12-28  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/util/AbstractMap.java:
	(SimpleImmutableEntry): Document and add
	serialVersionUID.
	(SimpleEntry): Likewise, and fix JAPI errors.
	* java/util/TreeMap.java:
	(entrySet()): Return navigableSet instead.
	(headMap(K, boolean)): Implemented.
	(subMap(K, boolean, K, boolean)): Likewise.
	(tailMap(K, boolean)): Likewise.
	(highestLessThan(K,boolean)): Likewise.
	(lowestGreaterThan(K,boolean,boolean)): Likewise.
	(SubMap.ceilingEntry(K)): Likewise.
	(SubMap.ceilingKey(K)): Likewise.
	(SubMap.descendingKeySet()): Likewise.
	(SubMap.descendingMap()): Likewise.
	(SubMap.entrySet()): Return navigableSet instead.
	(SubMap.firstEntry()): Implemented.
	(SubMap.floorEntry(K)): Likewise.
	(SubMap.floorKey(K)): Likewise.
	(SubMap.headMap(K,boolean)): Likewise.
	(SubMap.higherEntry(K)): Likewise.
	(SubMap.higherKey(K)): Likewise.
	(SubMap.lastEntry()): Likewise.
	(SubMap.lowerEntry(K)): Likewise.
	(SubMap.lowerKey(K)): Likewise.
	(SubMap.navigableKeySet()): Likewise.
	(SubMap.pollFirstEntry()): Likewise.
	(SubMap.pollLastEntry()): Likewise.
	(SubMap.subMap(K,boolean,K,boolean)): Likewise.
	(SubMap.tailMap(K,boolean)): Likewise.
	(SubMap.KeySet): New class for keySet().
	(SubMap.NavigableKeySet): New class for navigableKeySet().
	(SubMap.EntrySet): New class for entrySet().
	(SubMap.NavigableEntrySet): Likewise.
	(ceilingEntry(K)): Likewise.
	(ceilingKey(K)): Likewise.
	(descendingKeySet()): Likewise.
	(descendingMap()): Likewise.
	(firstEntry()): Implemented.
	(floorEntry(K)): Likewise.
	(floorKey(K)): Likewise.
	(higherEntry(K)): Likewise.
	(higherKey(K)): Likewise.
	(lastEntry()): Likewise.
	(lowerEntry(K)): Likewise.
	(lowerKey(K)): Likewise.
	(navigableKeySet()): Likewise.
	(pollFirstEntry()): Likewise.
	(pollLastEntry()): Likewise.
	(DescendingMap): New class for descendingMap().
	(KeySet): New class for keySet().
	(NavigableKeySet): New class for navigableKeySet().
	(DescendingSet): New class for descendingSet().
	(EntrySet): New class for entrySet().
	(NavigableEntrySet): Likewise.
	* java/util/TreeSet.java:
	(headSet(T,boolean)): Implemented.
	(subSet(T,boolean,T,boolean)): Likewise.
	(tailSet(T,boolean)): Likewise.
	(descendingIterator()): Likewise.
	(descendingSet()): Likewise.
	(floor(T)): Likewise.
	(higher(T)): Likewise.
	(lower(T)): Likewise.
	(pollFirst(T)): Likewise.
	(pollLast(T)): Likewise.
	
2006-12-27  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/util/LinkedList.java:
	(offer(T)): Documented.
	(element()): Likewise.
	(peek()): Likewise.
	(poll()): Likewise.
	(remove()): Likewise.
	(descendingIterator()): Implemented.
	(offerFirst(T)): Likewise.
	(offerLast(T)): Likewise.
	(peekFirst()): Likewise.
	(peekLast()): Likewise.
	(pollFirst()): Likewise.
	(pollLast()): Likewise.
	(pop()): Likewise.
	(push(T)): Likewise.
	(removeFirstOccurrence(Object)): Likewise.
	(removeLastOccurrence(Object)): Likewise.
	
2006-12-26  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* NEWS: Mention 1.6 support for java.lang.management
	* configure.ac: Check for getloadavg.
	* examples/gnu/classpath/examples/management/TestOS.java:
	Print system load average.
	* gnu/java/lang/management/OperatingSystemMXBeanImpl.java:
	(getSystemLoadAverage()): Implemented.
	* include/Makefile.am: Add new header.
	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h:
	Regenerated.
	* include/gnu_java_lang_management_VMOperatingSystemMXBeanImpl.h:
	Generated.
	* java/lang/management/OperatingSystemMXBean.java:
	(getSystemLoadAverage()): Implemented.
	* native/jni/java-lang/Makefile.am: Add new native code.
	* native/jni/java-lang/gnu_java_lang_management_VMOperatingSystemMXBeanImpl.c:
	New file.
	* vm/reference/gnu/java/lang/management/VMOperatingSystemMXBeanImpl.java:
	Likewise.
	
2006-12-25  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* NEWS:
	Add information on threading bean VM update.
	
2006-12-25  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* doc/vmintegration.texinfo:
	Updated to match new threading bean API.
	* gnu/java/lang/management/ThreadMXBeanImpl.java:
	(MONITOR_SUPPORT): New constant for object monitor
	lock support property.
	(SYNCHRONIZER_SUPPORT): New constant for ownable
	synchronizer lock support property.
	(dumpAllThreads(boolean,boolean)): Implemented.
	(findDeadlockedThreads()): Likewise.
	(getThreadInfo(long[],boolean,boolean)): Likewise.
	(isObjectMonitorUsageSupported()): Likewise.
	(isSynchronizerUsageSupported()): Likewise.
	* java/lang/management/ThreadInfo.java:
	(ThreadInfo(Thread,long,long,Object,Thread,long,
	long,boolean,boolean,StackTraceElement[],
	MonitorInfo[], LockInfo[])): New constructor.
	(ThreadInfo(long,String,Thread.State,long,long,
	String,long,String,long,long,boolean,boolean,
	StackTraceElement[],MonitorInfo[], LockInfo[])):
	Likewise.
	(from(CompositeData)): Updated to handle new attributes.
	(getLockedMonitors()): Implemented.
	(getLockedSynchronizers()): Likewise.
	(getLockInfo()): Likewise.
	(getLockName()): Handle blocking as documented in 1.6
	(getLockOwnerId()): Likewise.
	(getLockOwnerName()): Likewise.
	(toString()): Likewise.
	(isThreadBlocked()): Thread blocked check based on
	documented 1.6 semantics.
	* java/lang/management/ThreadMXBean.java:
	(dumpAllThreads(boolean,boolean)): Implemented.
	(findDeadlockedThreads()): Likewise.
	(getThreadInfo(long[],boolean,boolean)): Likewise.
	(isObjectMonitorUsageSupported()): Likewise.
	(isSynchronizerUsageSupported()): Likewise.
	* vm/reference/gnu/java/lang/management/VMThreadMXBeanImpl.java:
	(findDeadlockedThreads()): New native method.
	(getLockInfo(ThreadInfo)): Likewise.
	(getMonitorInfo(ThreadInfo)): Likewise.
	
2006-12-25  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/lang/management/MonitorInfo.java:
	Make variables private.
	* java/util/Arrays.java:
	(binarySearch(byte[],byte)): Implemented in terms
	of range-based variant.
	(binarySearch(short[],short)): Likewise.
	(binarySearch(int[],int)): Likewise.
	(binarySearch(long[],long)): Likewise.
	(binarySearch(char[],char)): Likewise.
	(binarySearch(float[],float)): Likewise.
	(binarySearch(double[],double)): Likewise.
	(binarySearch(byte[],int,int,byte)): Implemented.
	(binarySearch(short[],int,int,short)): Likewise.
	(binarySearch(int[],int,int,int)): Likewise.
	(binarySearch(long[],int,int,long)): Likewise.
	(binarySearch(char[],int,int,char)): Likewise.
	(binarySearch(float[],int,int,float)): Likewise.
	(binarySearch(double[],int,int,double)): Likewise.
	(binarySearch(Object[],int,int,Object)): Likewise.
	(binarySearch(T[],int,int,T,Comparator)): Likewise.
	
2006-12-25  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/beans/ConstructorProperties.java:
	New file.
	* java/lang/management/LockInfo.java:
	Likewise.
	* java/lang/management/MonitorInfo.java:
	Likewise.
	* java/lang/management/ThreadInfo.java:
	(getStackTraceType()): New method to
	make the StackTraceElement type accessible.
	(from(CompositeData)): Refactored to use
	getStackTraceType().
	
2006-12-24  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/classpath/Pair.java: New class.
	* java/io/ObjectInputStream.java:
	(readUnshared()): Implemented.
	(readObject(boolean)): Renamed from readObject
	in order to handle unshared serialization.
	(parseContent(byte,boolean)): Added unshared parameter.
	(assignNewHandle(Object,boolean)): Likewise.
	(rememberHandle(Object,boolean,int)): Likewise.
	(lookupHandle(int)): Added handling of invalidated handles.
	(processResolution(ObjectStreamClass,Object,int,boolean)):
	Added unshared parameter.
	* java/io/ObjectOutputStream.java:
	(writeUnshared()): Implemented.
	(writeObject(Object,boolean)): Renamed from
	writeObject(Object) in order to handle
	unshared serialization.
	
2006-12-23  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/lang/management/BeanImpl.java:
	(translate(String)): Correct handling of
	CompositeData objects.
	* java/lang/management/ManagementFactory.java:
	(ManagementInvocationHandler.invoke(Object,
	Method,Object[])): Handle translation and notifications.
	(ManagementInvocationHandler.translate(Object,
	Method)): Implement type translation.
	* java/lang/management/MemoryUsage.java:
	(from(CompositeData)): Fix capitalisation.
	* java/lang/management/ThreadInfo.java:
	(from(CompositeData)): Likewise.
	* javax/management/StandardMBean.java:
	(getMBeanInfo()): Add notification handling.
		
2006-12-23  Sven de Marothy  <sven@physto.se>

	* java/util/GregorianCalendar.java,
	(add): Don't set fields directly anymore. Use set()

2006-12-22  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	PR classpath/30268:
	* javax/management/MBeanServerFactory.java:
	Initialise map of servers immediately.
	(createMBeanServer(String)): Remove map
	construction.

2006-12-22  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(shiftX): Remove rounding.
	(shiftY): Likewise.

2006-12-22  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(locked): Removed field.
	(BufferedImageGraphics): Remove locked flag.
	(drawComposite): Transform bounds properly; set cairo composite directly.
	(drawImage): Transform bounds properly.
	(updateBufferedImage): Remove locked flag; transform bounds properly.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(copyArea): Add comment.
	(drawImage): Transform bounds properly; update clipping region.
	(getClipInDevSpace): Transform bounds properly.
	(getTransformedBounds): New method.
	(setAntialias): Updated javadoc.
	(setCustomPaint): Transform bounds properly.
	(updateClip): Avoid use of GeneralPath when possible.

2006-12-22  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	PR classpath/30217:
	* javax/management/ObjectName.java:
	(getKeyPropertyList()): Remove cast and call
	to UnmodifiableMap.
	
2006-12-22  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	PR classpath/30216:
	* javax/management/MBeanServerDelegate.java:
	Initialise list of listeners immediately.
	(addListener(NotificationListener)): Remove list
	construction.
	
2006-12-21  David Daney  <ddaney@avtrex.com>

	* gnu/java/net/protocol/http/Headers.java: Update imports.  Implement
	Iterable<Headers.HeaderElement>.
	(iterator): Make public.
	* gnu/java/net/protocol/http/Request.java (dispatch): Use enhanced for
	loop.
	(notifyHeaderHandlers): Same.
	* gnu/java/net/protocol/http/SimpleCookieManager.java (addCookies):
	Remove unneeded cast.

2006-12-21  Mario Torre  <neugens@limasoftware.net>

	* .settings/org.eclipse.jdt.core.prefs: set compilation flag to warning
	instead of error for empty control flow statements.
	* gnu/javax/swing/text/html/css/CSSParser.java (parseSelector): 
	(parseValue): Reverted last change.
	* java/text/BreakIterator.java (preceding): likewise.
	* external/jsr166/java/util/AbstractQueue.java (clear): likewise.
	* gnu/java/io/Base64InputStream.java (read): likewise.
	* javax/swing/text/DefaultStyledDocument.java (ElementBuffer.insertUpdate): 
	likewise.
	* java/util/zip/DeflaterEngine.java (findLongestMatch): likewise.
	* java/util/zip/ZipInputStream.java (closeEntry): likewise.
	* java/util/zip/DeflaterHuffman.java (Tree.buildLength): likewise.
	* java/io/StreamTokenizer.java (nextToken): likewise.
	* gnu/javax/imageio/png/PNGICCProfile.java (PNGICCProfile): likewise.
	* gnu/java/awt/font/opentype/truetype/VirtualMachine.java (execute):
	likewise.
	* gnu/java/nio/charset/ByteCharset.java (Decoder.decodeLoop): likewise.
	Also fixed typo.
	* gnu/java/awt/print/PostScriptGraphics2D.java (spoolPostScript): likewise.
	* gnu/java/awt/print/JavaPrinterGraphics.java (spoolPostScript): likewise.
	* gnu/javax/net/ssl/provider/SSLRSASignatureImpl.java (engineVerify):
	likewise.
	* javax/swing/text/html/CSSParser.java: 
	(parse): likewise.
	* java/lang/String.java (trim): likewise.
	* java/lang/StrictMath.java (remPiOver2): likewise.
	* gnu/java/awt/peer/qt/QtToolkit.java (QtToolkit): likewise.
	* javax/swing/JComponent.java (paintImmediately2): likewise.
	(paintChildren): likewise.
	* java/util/EnumMap.java (..next): likewise.
	* java/util/BitSet.java (length): likewise.
	* java/util/Collections.java (binarySearch): likewise.
	* java/util/StringTokenizer.java (nextToken): likewise.
	* java/util/PriorityQueue.java (.next): likewise.
	* java/math/BigInteger.java (BigInteger): likewise.
	* gnu/java/lang/management/BeanImpl.java (translate): likewise.

2006-12-19  Mario Torre  <neugens@limasoftware.net>

	* javax/imageio/spi/ServiceRegistry.java: fixed Empty control-flow
	statement.
	* tools/gnu/classpath/tools/rmid/ActivationSystemImpl.java: likewise.
	* gnu/java/io/Base64InputStream.java (read): likewise.
	* gnu/javax/swing/text/html/CharacterAttributeTranslator.java: likewise.
	* java/util/zip/DeflaterEngine.java (findLongestMatch): likewise.
	* java/util/zip/ZipInputStream.java (closeEntry): likewise.
	* java/util/zip/DeflaterHuffman.java (Tree.buildLength): likewise.
	* org/omg/CORBA/ORB.java: likewise.
	* javax/swing/plaf/metal/MetalFileChooserUI.java: likewise.
	* gnu/javax/imageio/png/PNGICCProfile.java (PNGICCProfile): likewise.
	* tools/external/asm/org/objectweb/asm/xml/ASMContentHandler.java: likewise.
	* java/text/MessageFormat.java (MessageFormatElement.setLocale): likewise.
	* java/text/BreakIterator.java (preceding): likewise.
	* gnu/javax/net/ssl/provider/SSLEngineImpl.java: likewise.
	* gnu/javax/net/ssl/provider/SSLRSASignatureImpl.java (engineVerify):
	likewise.
	* java/beans/XMLEncoder.java (writeObject): likewise.
	* gnu/java/beans/encoder/ScanEngine.java (ScanEngine): likewise.
	* java/util/Collections.java (binarySearch): likewise.
	* java/util/StringTokenizer.java (nextToken): likewise.
	* java/util/PriorityQueue.java (.next): likewise.
	* java/util/EnumMap.java (..next): likewise.
	* java/util/BitSet.java (length): likewise.
	* java/util/Date.java (parse): likewise.
	* javax/swing/text/html/CSSParser.java (parse): likewise.
	* javax/swing/plaf/basic/BasicTabbedPaneUI.java
	(TabbedPaneScrollLayout.calculateTabRects): likewise.
	* java/lang/Character.java (UnicodeBlock): likewise.
	* java/lang/String.java (trim): likewise.
	* java/lang/StrictMath.java (remPiOver2): likewise. 
	* javax/swing/JFormattedTextField.java (commitEdit): likewise.
	* javax/swing/JComponent.java (paintImmediately2): likewise.
	(paintChildren): likewise.
	* javax/swing/JToolTip.java (paramString): likewise.
	* javax/swing/JEditorPane.java (JEditorPane): likewise.
	* gnu/CORBA/Poa/gnuPOA.java: likewise.
	* gnu/javax/security/auth/login/ConfigFileParser.java
	(parseAppOrOtherEntry): likewise.
	(parse): likewise.
	* java/math/BigInteger.java (setBitOp): likewise.
	(add): likewise.
	(BigInteger): likewise.
	* gnu/java/lang/management/BeanImpl.java (translate): likewise.
	* javax/swing/text/DefaultStyledDocument.java (ElementBuffer.insertUpdate):
	likewise.
	* javax/swing/text/AbstractDocument.java (BranchElement): likewise.
	* javax/swing/text/JTextComponent.java (getScrollableTracksViewportWidth): 
	likewise.
	* javax/swing/text/FieldView.java (checkContainer): likewise.
	* javax/swing/text/AsyncBoxView.java (ChildLocator.updateChildOffsets): 
	likewise.
	* java/text/DecimalFormat.java (formatToCharacterIterator): likewise.
	(parse): small refactoring.

2006-12-19  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/lang/Enum.java:
	(finalize()): Implemented.
	
2006-12-18  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/lang/management/BeanImpl.java:
	(getAttribute(String)): Fix Map and List conversion.
	* java/lang/management/ManagementFactory.java:
	(newPlatformMXBeanProxy(MBeanServerConnection,
	String, Class<T>)): Add a comma.
	
2006-12-18  Tom Tromey  <tromey@redhat.com>

	* vm/reference/java/net/VMNetworkInterface.java (addresses):
	Genericized.
	(VMNetworkInterface): Updated.
	* java/net/URLClassLoader.java (urls): Genericized.
	(urlinfos): Likewise.
	(addURLImpl): Updated.
	(findClass): Likewise.
	(newInstance): Likewise.
	* java/net/URL.java (ph_cache): Genericized.
	(getURLStreamHandler): Updated.
	* java/net/ResolverCache.java (cache): Genericized.
	(killqueue): Likewise.
	* java/net/NetworkInterface.java (getInetAddresses): Genericized.
	* java/net/MimeTypeMapper.java (mime_types): Genericized.
	(fillFromFile): Likewise.
	(main): Likewise.
	* gnu/java/net/protocol/jar/Handler.java (flat): Genericized.
	* gnu/java/net/protocol/jar/Connection.java (JarFileCache.cache):
	Genericized.
	(JarFileCache.get): Updated.
	* gnu/java/net/protocol/http/SimpleCookieManager.java (cookies):
	Genericized.
	(SimpleCookieManager): Updated.
	(setCookie): Likewise.
	(getCookies): Likewise.
	(addCookies): Likewise.
	* gnu/java/net/protocol/http/Request.java (responseHeaderHandlers):
	Genericized.
	(Request): Updated.
	(createResponseBodyStream): Removed unused variable.
	* gnu/java/net/protocol/http/HTTPURLConnection.java (connect): Remove
	unused variable.
	(getRequestProperties): Genericized.
	* gnu/java/net/protocol/http/HTTPConnection.java
	(handshakeCompletedListeners): Genericized.
	(nonceCounts): Likewise.
	(HTTPConnection): Updated.
	(Pool.connectionPool): Likewise.
	(getNonceCount): Updated.
	(incrementNonce): Likewise.
	* gnu/java/net/protocol/http/Headers.java (headers): Genericized.
	* gnu/java/net/protocol/http/ChunkedInputStream.java (CR, LF): Removed
	unused fields.
	* gnu/java/net/protocol/ftp/FTPURLConnection.java (connect):
	Genericized.
	(getRequestProperties): Likewise.
	(addRequestPropertyValue): Likewise.  Fixed return result.
	* gnu/java/net/protocol/ftp/FTPConnection.java (nameList):
	Genericized.
	* gnu/java/net/local/LocalSocket.java: Fixed imports.
	* gnu/java/net/local/LocalServerSocket.java: Fixed imports.
	* gnu/java/net/loader/URLStreamHandlerCache.java (factoryCache):
	Genericized.
	(add): Updated.
	(get): Likewise.
	* gnu/java/net/loader/URLLoader.java (getClassPath): Genericized.
	* gnu/java/net/loader/JarURLLoader.java (classPath): Genericized.
	(initialize): Updated.
	(getClassPath): Genericized.
	* gnu/java/net/IndexListParser.java (prefixes): Genericized.
	(IndexListParser): Updated.
	(getHeaders): Likewise.
	* gnu/java/net/HeaderFieldHelper.java (headerFieldKeys): Genericized.
	(headerFieldValues): Likewise.
	(HeaderFieldHelper): Updated.
	(getHeaderFieldValueByKey): Likewise.
	(getHeaderFields): Likewise.
	* gnu/java/net/GetLocalHostAction.java: Genericized.
	* gnu/java/net/DefaultContentHandlerFactory.java (imageTypes):
	Genericized.

2006-12-18  Tom Tromey  <tromey@redhat.com>

	* java/util/prefs/Preferences.java (getFactory): Genericized.
	* java/util/prefs/AbstractPreferences.java (childCache): Genericized.
	(nodeListeners): Likewise.
	(preferenceListeners): Likewise.
	(cachedChildren): Rewrote.
	(childrenNames): Updated.
	(addNodeChangeListener): Likewise.
	(addPreferenceChangeListener): Likewise.
	* gnu/java/util/prefs/gconf/GConfNativePeer.java (getKeys):
	Genericized.
	(getChildrenNodes): Likewise.
	(gconf_client_all_nodes): Likewise.
	(gconf_client_all_keys): Likewise.
	* gnu/java/util/prefs/MemoryBasedPreferences.java (entries):
	Genericized.
	(keysSpi): Likewise.
	(getSpi): Likewise.
	* gnu/java/util/prefs/GConfBasedPreferences.java (childrenNamesSpi):
	Genericized.
	(keysSpi): Likewise.
	(postorderRemove): Likewise.
	* gnu/java/util/prefs/EventDispatcher.java (queue): Genericized.
	(run): Updated.

2006-12-18  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(drawGlyphVector): Round bounds instead of casting & truncating..

2006-12-17  Tom Tromey  <tromey@redhat.com>

	* javax/sound/sampled/BooleanControl.java (type): Removed unused
	field.
	* javax/sound/sampled/AudioSystem.java (getAudioFileTypes):
	Genericized.
	(getAudioInputStream): Removed unused variable.
	(getMixerInfo): Genericized.
	(getSourceLineInfo): Likewise.
	(getTargetEncodings): Likewise.
	(getTargetFormats): Likewise.
	(getTargetLineInfo): Likewise.
	* javax/sound/sampled/AudioFormat.java (properties): Genericized.
	(AudioFormat): Updated.
	* javax/sound/sampled/AudioFileFormat.java (properties): Genericized.
	(AudioFileFormat): Updated.

2006-12-17  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/lang/management/ManagementFactory.java:
	(newPlatformMXBeanProxy(MBeanServerConnection,
	String, Class<T>)): Initial implementation.
	
2006-12-17  Tom Tromey  <tromey@redhat.com>

	* javax/naming/spi/Resolver.java: Fixed comments and imports.
	* javax/naming/ldap/InitialLdapContext.java (InitialLdapContext):
	Genericized.
	* javax/naming/directory/BasicAttributes.java (attributes):
	Genericized.
	(BasicAttributes): Updated.
	(get): Likewise.
	(getAll): Likewise.
	(getIDs): Rewrote.
	(readObject): Updated.
	(BasicAttributesEnumeration): Genericized.
	* javax/naming/directory/BasicAttribute.java (BasicAttribute):
	Genericized.
	(clone): Likewise.
	(readObject): Likewise.
	* javax/naming/Reference.java (Reference): Genericized.
	(clone): Likewise.
	(get): Likewise.
	(get): Likewise.
	* javax/naming/InitialContext.java (colon_list): Genericized.
	(merge): Likewise.
	* javax/naming/CompoundName.java (elts): Genericized.
	(CompoundName): Updated.
	(addAll): Likewise.
	(compareTo): Likewise.
	(endsWith): Likewise.
	(get): Likewise.
	(hashCode): Likewise.
	(startsWith): Likewise.
	(readObject): Likewise.
	* javax/naming/CompositeName.java (elts): Genericized.
	(CompositeName): Updated.
	(addAll): Likewise.
	(compareTo): Likewise.
	(get): Likewise.
	(getPrefix): Likewise.
	(getSuffix): Likewise.
	(toString): Likewise.
	(readObject): Likewise.

2006-12-17  Mark Wielaard  <mark@klomp.org>

	* doc/www.gnu.org/include/layout.wml: Remove gif reference.
	* doc/www.gnu.org/include/macros.wml: Correct FSF contact info.

	* doc/www.gnu.org/newsitems.txt: Add 0.93.
	* doc/www.gnu.org/downloads/downloads.wml: Likewise.
	* doc/www.gnu.org/announce/20061211.wml: New file.

2006-12-17  Mark Wielaard  <mark@klomp.org>

	* examples/Makefile.am (JCOMPILER): Don't warn for deprecation,
	serial, typeHiding, unchecked, unused and varargsCast.
	* tools/Makefile.am (JCOMPILER): Likewise.

2006-12-17  Mark Wielaard  <mark@klomp.org>

	* tools/Makefile.am (TOOLS_ZIP): Don't remove .lst files immediately.
	(clean-local): Remove all .lst files
	* tools/.cvsignore: Add *.lst.

2006-12-16  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/awt/HintingDemo.java:
	New demonstration program for the autohinter.

2006-12-16  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/FontDelegate.java
	(FLAG_FITTED): New constant field.
	(FLAG_NO_HINT_HORIZONTAL): New constant field.
	(FLAG_NO_HINT_VERTICAL): New constant field.w
	(FLAG_NO_HINT_EDGE_POINTS): New constant field.
	(FLAG_NO_HINT_STRONG_POINTS): New constant field.
	(FLAG_NO_HINT_WEAK_POINTS): New constant field.
	(TYPE_FITTED): Replaced by flags above.
	(TYPE_SCALED): Replaced by flags above.
	(TYPE_ORIGINAL): Replaced by flags above.
	* gnu/java/awt/font/GNUGlyphVector.java
	(getGlyphOutline): Use FLAG_FITTED.
	* gnu/java/awt/font/autofit/AutoHinter.java
	(setFlags): New method. Sets hinting flags.
	* gnu/java/awt/font/autofit/GlyphHints.java
	(flags): New field.
	(alignStrongPoint): Use 16.16 fixed arithmetic.
	(doAlignEdgePoints): New helper method.
	(doAlignStrongPoints): New helper method.
	(doAlignWeakPoints): New helper method.
	(doHorizonal): Check flags.
	(doVertical): Check flags.
	* gnu/java/awt/font/autofit/Latin.java
	(applyHints): Check hinting flags.
	(computeEdges): Also initialize fitted position.
	(scaleMetricsDim): Commented out buggy block.
	* gnu/java/awt/font/opentype/Hinter.java
	(setFlags): New method.
	* gnu/java/awt/font/opentype/OpenTypeFont.java
	(checkHinter): Accept flags parameter.
	(createGlyphVector): Pass flags to hinter.
	(getGlyphOutline): Pass flags to hinter.
	* gnu/java/awt/font/opentype/truetype/Fixed.java
	(floatValue16): New method.
	* gnu/java/awt/font/opentype/truetype/Zone.java
	(getX): Use new flags.
	(getY): Use new flags.

2006-12-16  Mark Wielaard  <mark@klomp.org>

	* tools/Makefile.am (TOOLS_ZIP): Remove all-classes.lst.
	(clean-local): Likewise.

2006-12-16  Mark Wielaard  <mark@klomp.org>

	* tools/Makefile.am (TOOLS_ZIP): Don't pass -w to JCOMPILER.

2006-12-15  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/util/Collections.java:
	(toArray()): Return Object[] as required.
	(toArray(S[])): Use new type variable S rather than
	the class one.
	
2006-12-15  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* m4/acinclude.m4 (CLASSPATH_FIND_JAVAC): Added support for Sun's
	javac.
	(CLASSPATH_WITH_JAVAC): Added.
	(CLASSPATH_CHECK_JAVAC): Likewise.
	* lib/Makefile.am (JAVAC): Renamed to JCOMPILER.
	(FOUND_JAVAC): Added support for Sun's javac.
	* examples/Makefile.am: Likewise.
	* tools/Makefile.am: Likewise.

2006-12-15  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java:
	(draw): Pass boolean to setAntialias.
	(drawGlyphVector): Likewise.
	(drawString): Likewise.
	(fill): Likewise.
	(setAntialias): Change signature to accept boolean.

2006-12-15  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/FontDelegate.java
	(TYPE_FITTED): New constant.
	(TYPE_ORIGINAL): New constant.
	(TYPE_SCALED): New constant.
	(getGlyphOutline): Allow the kind of outline be specified as one
	of the constants above.
	* gnu/java/awt/font/GNUGlyphVector.java
	(getGlyphOutline(int,int)): Add type parameter for fetching
	the intermediate outlines for debugging.
	(getGlyphOutline(int)): Fetch TYPE_FITTED outline from font
	delegate.
	(getOutline(float,float,int)): Added for debugging purpose.
	(performDefaultLayout): Round the advance here for better hinting.
	This is only a workaround for not hinting the metrics right now.
	* gnu/java/awt/font/autofit/AxisHints.java
	(getEdgeIndex): New helper method. Fetches the index of
	a given edge in the array.
	(newEdge): Fixed sorting.
	* gnu/java/awt/font/autofit/Edge.java
	(pos): New field. Stores the fitted position.
	(scale): New field.
	(toString): More debug output.
	* gnu/java/awt/font/autofit/GlyphHints.java
	(alignEdgePoints): New method. Aligns the points of an outline
	to their edges hinted positions.
	(alignStrongPoints): New method. Aligns strong points.
	(alignWeakPoints): New method. Aligns weak points.
	(getPointIndex): New helper method.
	(iupInterp): New helper method. Interpolates points.
	(iupShift): New helper method. Shifts a complete contour.
	(storePoint): New helper method.
	* gnu/java/awt/font/autofit/Latin.java
	(alignEdgePoints): Moved to GlyphHints.
	(alignLinkedEdge): New helper method.
	(alignSerifEdge): New helper method.
	(alignStrongPoints): Moved to GlyphHints.
	(alignWeakPoints): Moved to GlyphHints.
	(applyHints): Call moved methods on GlyphHints.
	(computeStemWidth): New helper method.
	(doHorzSnap): New helper method.
	(doVertSnap): New helper method.
	(doMono): New helper method.
	(doneWidth): New helper method.
	(doStemAdjust): New helper method.
	(hintEdges): Implemented.
	(initWidths): Removed old comment.
	(snapWidth): New helper method.
	* gnu/java/awt/font/autofit/Width.java
	(toString): More debug output.
	* gnu/java/awt/font/opentype/OpenTypeFont.java
	(getGlyphOutline): Add type parameter for debugging.
	* gnu/java/awt/font/opentype/Scaler.java
	(getOutline): Add type parameter for debugging.
	* gnu/java/awt/font/opentype/truetype/Point.java
	Make all flags of short type. Add new accessor methods for
	coordinates that can return scaled and original shapes too.
	* gnu/java/awt/font/opentype/truetype/TrueTypeScaler.java
	(getOutline): Add type parameter for debugging.
	* gnu/java/awt/font/opentype/truetype/Zone.java
	Add type parameter to X and Y accessors.
	(getPath): Add type parameter.
	(getPathIterator): Likewise.
	(transform): Do store transformed value in the x and y fields too.
	* gnu/java/awt/font/opentype/truetype/ZonePathIterator.java
	(type): New field.
	(ZonePathIterator): Add type parameter.
	(getSegment): Fetch coordinates with type.
	(getStartSegment): Likewise.

2006-12-15  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* autogen.sh: Check for all 2.6x autoconf versions.

2006-12-15  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(antialias): New private field.
	(ignoreAA): New private field.
	(cairoSetAntialias): New native method.
	(draw): Check anti-alias setting.
	(drawGlyphVector): Likewise.
	(drawString): Likewise.
	(fill): Likewise.
	(setAntialias): New private method.
	(setup): Set default antialias value.
	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h: Regenerated.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_CairoGraphics2D.c:
	(gnu_java_awt_peer_gtk_CairoGraphics2D_cairoSetAntialias): New method.

2006-12-15  Tom Tromey  <tromey@redhat.com>

	* external/jsr166/.cvsignore: Added Makefile.

2006-12-15  Tom Tromey  <tromey@redhat.com>

	* tools/gnu/classpath/tools/serialver/SerialVer.java (addFileURL):
	Genericized.
	(getClassLoader): Likewise.
	(classes): Likewise.
	* tools/gnu/classpath/tools/native2ascii/Native2ASCII.java (main):
	Removed unused variable.
	* tools/gnu/classpath/tools/jar/WorkSet.java (allItems): Genericize.
	(initSet): Likewise.
	* tools/gnu/classpath/tools/jar/Main.java (entries): Genericize.
	* tools/gnu/classpath/tools/jar/Indexer.java (indexJarFile):
	Genericized.
	* tools/gnu/classpath/tools/jar/Creator.java (writeFile): Close the
	input stream.
	(writtenItems): Genericize.
	(addEntries): Likewise.
	(getAllEntries): Likewise.

2006-12-15  Tom Tromey  <tromey@redhat.com>

	PR classpath/29526:
	* gnu/java/nio/ChannelInputStream.java (read): New overload.
	(read): Mask return result.

2006-12-15  Andrew Haley  <aph@redhat.com>

	* tools/Makefile.am (TOOLS_ZIP): Pass -g -w to javac.
	Create all-classes.lst that contains all source filenames.
	Delete asm.lst.

	* tools/gnu/classpath/tools/jar/Creator.java (writeFile): Close
	the inputStream.

2006-12-14  David Daney  <ddaney@avtrex.com>

	* gnu/java/net/protocol/http/HTTPURLConnection.java: Clean
	imports.
	(getHeaderFields): Change return type to Map<String,List<String>>
	* gnu/java/net/protocol/http/Headers.java: Clean imports.
	(headers) Change type to ArrayList<HeaderElement>.
	(iterator) Change return type to Iterator<HeaderElement>.
	(getValue) Remove casts.
	(put) Same.
	(putAll) Same.
	(remove) Same.
	(getAsMap) Change return type to Map<String,List<String>> and use
	generics internally.
	(getHeaderName) Remove casts.
	(getHeaderValue) Same.

2006-12-14  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/autofit/HintScaler.java
	Renamed Scaler to HintScaler to avoid name-clash.
	* gnu/java/awt/font/autofit/AutoHinter.java
	(scaler): New field.
	(applyHints): Scale the metrics before applying the hints.
	(init): Copy font into scaler.
	* gnu/java/awt/font/autofit/Edge.java
	(blueEdge): New field.
	(toString): Include first and last fields in debug output.
	* gnu/java/awt/font/autofit/GlyphHints.java
	(reload): Grab the scales here.
	* gnu/java/awt/font/autofit/Latin.java
	(computeBlueEdges): Implemented blue-edge detection.
	(computeEdges): Correctly calculate edgeDistanceThreshold and
	the scaled edge position.
	(initWidths): Renamed Scaler to HintScaler. Sort widths and
	store widthCount.
	(scaleMetrics): Add HintScaler parameter. Implemented to scale
	the metrics.
	(scaleMetricsDim): New helper method.
	* gnu/java/awt/font/autofit/LatinAxis.java
	(orgDelta): New field.
	(orgScale): New field.
	* gnu/java/awt/font/autofit/LatinBlue.java: Reordered flags.
	(FLAG_BLUE_ACTIVE): New flag.
	* gnu/java/awt/font/autofit/Scaler.java: Renamed to HintScaler.
	* gnu/java/awt/font/autofit/Script.java
	(scaleMetrics): Add HintScaler argument.
	* gnu/java/awt/font/autofit/ScriptMetrics.java
	Renamed Scaler to HintScaler.
	* gnu/java/awt/font/autofit/Utils.java
	(sort(int,Width[])): New helper method. Sorts Width arrays.
	(mulDiv): New helper method.
	(pixFloor): New helper method.
	(pixRound): New helper method.
	* gnu/java/awt/font/autofit/Width.java
	(toString): New method. For debug output.
	* gnu/java/awt/font/opentype/truetype/Fixed.java
	(mul16): New method. Multiplies with 16.16 fixed point arithmetics.
	(div16): New method. Divides with 16.16 fixed point arithmetics.
	(valueOf16): New method. Converts double to 16.16 fixed point.
	* gnu/java/awt/font/opentype/truetype/Zone.java
	(scaleX): New field.
	(scaleY): New field.
	(shearX): New field.
	(shearY): New field.
	(transform): Store translation and shearing in fields instead of
	local vars.

2006-12-14  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/autofit/AutoHinter.java
	(hints): New field.
	(applyHints): New method. Implements the actual hinting.
	* gnu/java/awt/font/autofit/AxisHints.java
	(edges): New field.
	(AxisHints): Initialize edges field.
	(newEdge): New method. Records a new edge and sorts it into the
	existing list.
	* gnu/java/awt/font/autofit/Edge.java: New class.
	* gnu/java/awt/font/autofit/GlyphHints.java
	(GlyphHints): Initialize the scales with 1.
	(doHorizontal): New method.
	(doVertical): New method.
	* gnu/java/awt/font/autofit/Latin.java
	(alignEdgePoints): New stub method.
	(alignStrongPoints): New stub method.
	(alignWeakPoints): New stub method.
	(applyHints): Take outline as argument. Implemented skeleton.
	(computeBlueEdges): New stub method.
	(computeEdges): New method. Detects edges on a glyph outline.
	(detectFeatures): New methods. Performs local feature analysis.
	(hintEdges): New stub method.
	(initBlues): Remove debug output.
	* gnu/java/awt/font/autofit/LatinAxis.java
	(edgeDistanceThreshold): Changed to be an int
	(as fixed-point decimal).
	* gnu/java/awt/font/autofit/Script.java
	(applyHints): Include the outline in the method call.
	* gnu/java/awt/font/autofit/Segment.java
	(FLAG_EDGE_NORMAL): Set value to 0.
	(FLAG_EDGE_SERIF): New constant.
	(FLAG_EDGE_DONE): New constant.
	(edge): New field.
	(edgeNext): New field.
	* gnu/java/awt/font/opentype/Hinter.java
	(applyHints): New method. Applies the hints to the specified outline.
	* gnu/java/awt/font/opentype/OpenTypeFont.java
	(getGlyphOutline): Check the hinter and call the scaler with the
	hinter.
	* gnu/java/awt/font/opentype/Scaler.java
	(getOutline): Also pass a Hinter.
	* gnu/java/awt/font/opentype/truetype/GlyphLoader.java
	(loadCompoundGlyph): Also accept a hinter argument.
	(loadGlyph): Also accept a hinter argument.
	(loadSimpleGlyph): Also accept a hinter argument. Hint the
	resulting outline.
	(loadSubGlyph): Also accept a hinter argument.
	* gnu/java/awt/font/opentype/truetype/TrueTypeScaler.java
	(getOutline): Accept hinter and pass it to the loader.
	(getRawOutline): Pass null hinter to the loader.

2006-12-14  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/autofit/LatinBlue.java:
	New class.

2006-12-14  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/autofit/Latin.java
	(CAPITAL_TOP): New constant.
	(CAPITAL_BOTTOM): New constant.
	(SMALL_F_TOP): New constant.
	(SMALL_TOP): New constant.
	(SMALL_BOTTOM): New constant.
	(SMALL_MINOR): New constant.
	(BLUE_MAX): New constant.
	(IDENTITY): New constant transform.
	(MAX_TEST_CHARS): New constant.
	(TEST_CHARS): New constants.
	(initBlues): Implemented.
	(initWidths): Use constant identity transform for loading
	the test glyph.
	(isTopBlue): New helper method.
	* gnu/java/awt/font/autofit/LatinAxis.java
	(widths): Initialize in constructor.
	(blues): New field. Stores the blue zones.
	(blueCount): New field. The number of blue zones.
	(LatinAxis): New constructor.
	* gnu/java/awt/font/autofit/Utils.java
	(sort): New helper method.
	* gnu/java/awt/font/opentype/truetype/Zone.java
	(getContourEnd): New helper method.

2006-12-13  David Daney  <ddaney@avtrex.com>

	* java/lang/Collections.java
	(UnmodifiableEntrySet.toArray): Fix bad casts.

2006-12-13  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/autofit/AutoHinter.java: New class. The entry
	point into the autohinter.
	* gnu/java/awt/font/autofit/AxisHints.java
	(majorDir): New field.
	(numEdges): New field.
	(numSegments): New field.
	(AxisHints): New constructor.
	(newSegment): New method. Records a new segment.
	* gnu/java/awt/font/autofit/Constants.java
	(DIR_DOWN): New constant.
	(DIR_LEFT): New constant.
	(DIR_RIGHT): New constant.
	(DIR_TOP): New constant.
	(DIR_NONE): New constant.
	* gnu/java/awt/font/autofit/GlyphHints.java
	(contours): New field.
	(numContours): New field.
	(maxPoints): New field.
	(metrics): New field.
	(numPoints): New field.
	(points): New field.
	(GlyphHints): New constructor.
	(computeInflectionPoints): New helper method.
	(computeSegments): Moved to Latin.
	(linkSegments): Moved to Lating.
	(reload): Implemented.
	(rescale): Copy the metrics.
	(setWeakPoint): New helper method.
	* gnu/java/awt/font/autofit/Latin.java
	(MAX_WIDTH): Make package private.
	(computeSegments): New method. Computes the segments to a glyph.
	(initWidths): Implemented. Determines the standard widths of stems
	for the font.
	(linkSegments): New method. Links stem segments and determines
	serif segments.
	* gnu/java/awt/font/autofit/LatinMetrics.java
	(LatinMetrics()): New constructor.
	(LatinMetrics(OpenTypeFont)): New constructor.
	* gnu/java/awt/font/autofit/ScriptMetrics.java
	(ScriptMetrics): New constructor.
	* gnu/java/awt/font/autofit/Segment.java
	(FLAG_EDGE_NORMAL): New constant.
	(FLAG_EDGE_ROUND): New constant.
	(contour): New field.
	(dir): New field.
	(first): New field.
	(flags): New field.
	(index): Removed.
	(last): New field.
	(len): New field.
	(maxPos): New field.
	(minPos): New field.
	(numLinked): New field.
	(score): New field.
	(serif): New field.
	(toString): New method. For debug output.
	* gnu/java/awt/font/autofit/Utils.java: New utility class.
	* gnu/java/awt/font/opentype/Hinter.java: New interface for
	hinter implementations.
	* gnu/java/awt/font/opentype/OpenTypeFont.java
	(hinter): New field. Stores the hinter for that font.
	(checkHinter): Checks if a hinter is installed and installs one
	if necessary.
	(createGlyphVector): Check installed hinter.
	* gnu/java/awt/font/opentype/truetype/Fixed.java: Make class public
	for access in the autohinting package.
	* gnu/java/awt/font/opentype/truetype/Point.java: New class. Stores
	coordinates and additional info that describe the outline of a glyph.
	* gnu/java/awt/font/opentype/truetype/Zone.java: Use Point class
	for storing the points.

2006-12-13  Tom Tromey  <tromey@redhat.com>

	* java/security/BasicPermission.java: Remove gcj workaround.
	* java/security/cert/X509Certificate.java: Remove gcj workaround.
	* java/net/ServerSocket.java (ServerSocket): Remove gcj
	workaround.
	(getImpl): Likewise.
	* java/util/TreeMap.java (TreeIterator): Remove gcj workaround.
	* java/text/AttributedStringIterator.java (getRunLimit): Remove
	qualifications.
	(getRunStart): Likewise.
	* java/awt/AWTKeyStroke.java (removeEldestEntry): Remove gcj
	workaround.
	* java/awt/AlphaComposite.java (removeEldestEntry): Remove gcj
	workaround.
	* java/awt/geom/GeneralPath.java (WIND_EVEN_ODD, WIND_NON_ZERO,
	BIG_VALUE): Don't fully qualify.
	* gnu/javax/sound/midi/alsa/AlsaMidiSequencerDevice.java: Removed
	imports.
	* gnu/javax/sound/midi/alsa/AlsaPortDevice.java: Removed import.
	* gnu/javax/sound/midi/dssi/DSSISynthesizer.java: Removed import.
	* javax/swing/JComponent.java (firePropertyChange): Removed.
	* javax/swing/text/InternationalFormatter.java (clone):
	Uncomment.
	* javax/swing/text/AbstractDocument.java (addEdit): Remove gcj
	workaround.
	(getChange): Likewise.

2006-12-13  Tom Tromey  <tromey@redhat.com>

	* examples/Makefile.am: Removed gcjx code.
	* lib/Makefile.am: Removed gcjx code.
	* tools/Makefile.am: Removed gcjx code.
	* m4/acinclude.m4 (CLASSPATH_FIND_JAVAC): Removed gcjx code.
	(CLASSPATH_WITH_GCJX): Removed.
	(CLASSPATH_CHECK_GCJX): Likewise.

2006-12-13  Tom Tromey  <tromey@redhat.com>

	* tools/toolwrapper.c (MAINCLASS): New define.
	(main): Use it.
	* tools/Makefile.am (gnative2ascii_CFLAGS): Added -D for
	MAINCLASS.
	(gserialver_CFLAGS): Likewise.
	* tools/gnative2ascii.in: Main class is named Native2ASCII.
	* tools/gserialver.in: Main class is named SerialVer.

2006-12-12  Roman Kennke  <kennke@aicas.com>

	* javax/imageio/FileCacheImageOutputStream.java
	(cache): New field. The actual cache as RandomAccessFile.
	(cacheDir): Removed. Not needed at all.
	(cacheFile): New field. The cache file.
	(maxPos): New field. Stores the maximum position.
	(FileCacheImageOutputStream): Initialize cache file.
	(checkStreamClosed): Removed. This should be done by the super
	method checkClosed().
	(close): Properly close the stream and delete the cache.
	(flushBefore): Implemented to also flush the cache.
	(length): Implemented to return the length of the cache.
	(read()): Implemented to read from the cache.
	(read(byte[],int,int)): Likewise.
	(seek): Implemented to seek the cache too.
	(write(int)): Write to cache.
	(write(byte[],int,int))

2006-12-12  Francis Kung  <fkung@redhat.com>

	PR 30155
	* javax/imageio/spi/IIORegistry.java (IIORegistry): Register Toolkit SPIs.

2006-12-12  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* javax/management/AttributeList.java:
	Extend ArrayList<Object>.
	
2006-12-12  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	PR classpath/30154:
	* javax/management/MBeanServer.java:
	(createMBeanServer(String)): Check for a null
	builder.

2006-12-11  Roman Kennke  <kennke@aicas.com>

	* java/awt/print/PrinterJob.java
	(lookupStreamPrintServices): Uncommented and fixed parameters.

2006-12-11  Roman Kennke  <kennke@aicas.com>

	* java/awt/datatransfer/SystemFlavorMap.java
	(flavorToNativeMap): Make typesafe.
	(nativeToFlavorMap): Make typesafe.
	(SystemFlavorMap): Read in mapping by reading the flavormap.properties.
	(addFlavorForUnencodedNative): Access maps in a typesafe way.
	(addUnencodedNativeForFlavor): Access maps in a typesafe way.
	(getFlavorsForNative): Implemented.
	(getNativesForFlavor): Implemented.
	(setupMapping): New helper method.

2006-12-11  Jeroen Frijters  <jeroen@frijters.net>

	* javax/net/ssl/SSLSocketFactory.java (getDefault):
	Chain exception cause.

2006-12-11  Roman Kennke  <kennke@aicas.com>

	* .classpath: Include ASM in Eclipse classpath.

2006-12-11  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/lang/management/BeanImpl.java:
	(translate(String)): Trim strings of whitespace.
	* javax/management/MBeanAttributeInfo.java:
	(MBeanAttributeInfo(String,String,Method,Method)):
	Use Class.getName() for normal (non-parameterized) cases.
	* javax/management/MBeanConstructorInfo.java:
	(MBeanConstructorInfo(String, Constructor)):
	Likewise.
	* javax/management/MBeanOperationInfo.java:
	(MBeanOperationInfo(String, Method)):
	Likewise.

2006-12-11  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/lang/Class.java:
	(getClasses()): Return Class<?>[].
	(internalGetClasses()): Likewise.
	(getConstructor(Class<?>...)): Add type parameter
	to parameters.
	(getDeclaredConstructor(Class<?>...)): Likewise.
	(getDeclaredClasses()): Return Class<?>[].
	(getDeclaredClasses(boolean)): Likewise.
	(getDeclaredConstructors()): Return Constructor<?>[].
	(getDeclaredConstructors(boolean)): Likewise.
	(getDeclaredMethod(String,Class<?>...)): Add type
	parameter to parameters.
	(getInterfaces()): Return Class<?>[].
	(getMethods(String,Class<?>...)): Add type
	parameter to parameters.
	* java/text/CollationKey.java:
	Make non-final.
	* java/text/DecimalFormatSymbols.java:
	Likewise.
	
2006-12-11  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/lang/management/BeanImpl.java:
	(translate(String)): Handle Map and List as
	Strings of the form "java.util.Map<K,V>" and
	"java.util.List<E>"
	* javax/management/MBeanAttributeInfo.java:
	(MBeanAttributeInfo(String,String,Method,Method)):
	Use generic parameter and return types.
	* javax/management/MBeanConstructorInfo.java:
	(MBeanConstructorInfo(String, Constructor)):
	Use generic parameter types.
	* javax/management/MBeanOperationInfo.java:
	(MBeanOperationInfo(String, Method)):
	Use generic parameter and return types.
	
2006-12-10  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/lang/management/BeanImpl.java:
	(translate(String)): Comment out code for using type
	variables for Map and List.
	* java/lang/Thread.java:
	(Thread(ThreadGroup,Runnable,String,long)): Fix
	incrementation of totalThreadsCreated to be prior to use.
	
2006-12-10  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* javax/management/MBeanServerFactory.java:
	(createMBeanServer(String)): Added security check.
	(findMBeanServer(String)): Likewise.
	(newMBeanServer(String)): Likewise.
	(releaseMBeanServer(String)): Likewise.
	* javax/management/MBeanServerPermission.java:
	New file.
	
2006-12-08  David Daney  <ddaney@avtrex.com>

	* native/jni/java-nio/gnu_java_nio_VMChannel.c (is_non_blocking_fd):
	Fix comment.

2006-12-08  David Daney  <ddaney@avtrex.com>

	* NEWS: Mention URLConnection.[get|set]ReadTimeout.

2006-12-08  David Daney  <ddaney@avtrex.com>

	* gnu/java/net/protocol/http/HTTPConnection.java (imports): Add
	SocketException.
	(HTTPConnection): Handle NumberFormatException in properties parsing.
	(Pool.get): Set timeout on reused sockets.
	* gnu/java/net/protocol/http/HTTPURLConnection.java (proxyPort):
	Initialize.
	(HTTPURLConnection): Cleanup properties handling.
	(getConnection): Use both connection and read timeouts.
	(setConnectTimeout): Removed.
	(setReadTimeout): New method.
	* java/net/URLConnection.java (timeout): Renamed to...
	(connectTimeout): ... connectTimeout throughout.
	(readTimeout): New field.
	(getReadTimeout): New method.
	(setReadTimeout): New method.

2006-12-08  Tania Bento  <tbento@redhat.com>

	* java/awt/ScrollPane.java
	(doLayout): Change the location of the scrollpane's child
	to (0, 0).

2006-12-08  David Daney  <ddaney@avtrex.com>

	* native/jni/java-nio/gnu_java_nio_VMChannel.c (is_non_blocking_fd):
	New method.
	(Java_gnu_java_nio_VMChannel_read__ILjava_nio_ByteBuffer_2): Throw
	SocketTimeoutException if a blocking socket timesout.
	(Java_gnu_java_nio_VMChannel_readScattering): Same.
	(Java_gnu_java_nio_VMChannel_read__I): Same.
	(Java_gnu_java_nio_VMChannel_connect): Initialize the fd set.
	(Java_gnu_java_nio_VMChannel_connect6): Same.

2006-12-08  Mark Wielaard  <mark@klomp.org>

	* configure.ac (VERSION): Set to 0.93-generics.
	* NEWS: Add release date.

2006-12-08  Tania Bento  <tbento@redhat.com>

	* java/awt/ScrollPane.java
	(getScrollPosition): Throw NullPointerException if scrollpane
	does have a child.
	(setScrollPosition(int, int)): Throw NullPointerException if
	scrollpane does have a child.  Check that both ints are within
	the allowed bounds; If they are not, scroll to the closest allowed
	bound.

2006-12-07  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(EditorKitMapping): New inner helper class.
	(editorKits): New static field for caching editor kit instances.
	(static_initiazer): Initialize static mappings here.
	(createEditorKitForContentType): Try to use cached instance.
	Use correct classloader for loading.
	(getEditorKitClassNameForContentType): Make use of EditorKitMapping
	class.
	(getEditorKitForContentType): Store the fetched editor kit.
	Fallback to createDefaultEditorKit().
	(init): Don't clean the static registry here.
	(registerEditorKitForContentType(String,String,ClassLoader)):
	Implemented.
	(registerEditorKitForContentType(String,String)): Delegate to
	the other version of this method with the thread's context
	classloader.

2006-12-07  Mark Wielaard  <mark@klomp.org>

	* examples/gnu/classpath/examples/swing/HtmlDemo.java
	(setPage): Don't convert URL to String for setPage().

2006-12-07  Mark Wielaard  <mark@klomp.org>

	* tools/Makefile.am (clean-local): Remove iasm and asm.lst.

2006-12-07  Mark Wielaard  <mark@klomp.org>

	* tools/Makefile.am: Explicitly define  and use bootclasspath as
	GLIBJ_BOOTCLASSPATH

2006-12-07  Mark Wielaard  <mark@klomp.org>

	* javax/swing/JEditorPane.java (createEditorKitForContentType):
	Always load from system class loader.

2006-12-07  Mark Wielaard  <mark@klomp.org>

	* java/net/URL.java (URL(URL,String,URLStreamHandler,boolean)): New
	private constructor.
	(URL(URL,String,URLStreamHandler)): Call new constructor.
	(URL(URL,String)): Likewise.
	(URL(String)): Likewise.

2006-12-07  Tom Tromey  <tromey@redhat.com>

	* NEWS: Mention ASM.
	* INSTALL: Don't mention --with-asm.
	* tools/external/README: New file.
	* tools/toolwrapper.c (main): Don't use ASM_JAR.
	* tools/gjavah.in: Don't use PATH_TO_ASM.
	* tools/grmic.in: Likewise.
	* tools/Makefile.am (GLIBJ_CLASSPATH): Removed PATH_TO_ASM, added
	'asm'.
	(javah, rmic): Removed variables.
	(bin_PROGRAMS): Updated.
	(gappletviewer_CFLAGS): Don't define ASM_JAR.
	(gjarsigner_CFLAGS): Likewise.
	(gkeytool_CFLAGS): Likewise.
	(gjar_CFLAGS): Likewise.
	(gnative2ascii_CFLAGS): Likewise.
	(gserialver_CFLAGS): Likewise.
	(grmiregistry_CFLAGS): Likewise.
	(gtnameserv_CFLAGS): Likewise.
	(gorbd_CFLAGS): Likewise.
	(grmid_CFLAGS): Likewise.
	(gjavah_CFLAGS): Likewise.
	(grmic_CFLAGS): Likewise.
	(bin_SCRIPTS): Updated.
	(TOOLS_JAVA_FILES): Updated.
	($(TOOLS_ZIP)): Compile ASM sources.  Copy resource files.
	* configure.ac: Removed --with-asm.  Always build gjavah.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/swing/BrowserEditorKit.java:
	New class.
	* examples/gnu/classpath/examples/swing/HtmlDemo.java
	(LoadActionListener): Call setPage() helper method.
	(createContent): Register tweaked editor kit. For FormSubmitEvents
	call submitForm(), otherwise setPage().
	(postData): Helper method for posting form data.
	(setPage): Helper method for navigating to a new URL.
	(submitForm): Helper method for submitting a form.
	* examples/gnu/classpath/examples/swing/forms.html:
	Added text/password fields and select boxes.
	* examples/gnu/classpath/examples/swing/welcome.html: Fixed typo.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/FormView.java
	(SubmitThread.postData): Implemented.
	(SubmitThread.run): Pass data to postData().
	(actionPerformed): Reset form when reset button is activated.
	(createComponent): Add support for select lists and comboboxes.
	Don't set value of text and password fields here, this is done
	now in HTMLDocument for consistency.
	(getElementFormData): Add support for fetching form data from
	select lists and comboboxes as well as textareas.
	(getSelectData): New helper method. Fetches form data from
	select boxes.
	(getTextAreaData): New helper method. Fetches form data from
	textareas.
	(resetForm): New helper method. Resets the entire form.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.FormAction.end): Handle SELECT and OPTION tags.
	(HTMLReader.FormAction.start): Handle SELECT and OPTION tags.
	(HTMLReader.FormAction.setModel): Initialize text and password
	values here. Also, use the resetable special models.
	Group radio buttons into ButtonGroup for exclusive selection.
	(HTMLReader.FormTagAction): New class. Handles FORM tags.
	(HTMLReader.buttonGroups): New field.
	(HTMLReader.numOptions): New field.
	(HTMLReader.option): New field.
	(HTMLReader.selectModel): New field.
	(HTMLReader.textAreaDocument): Make ResetablePlainDocument.
	(HTMLReader.handleText): Handle OPTION text.
	(HTMLReader.initTags): Map FORM tags to FormTagAction.
	(HTMLReader.textAreaContent): Set initial content.
	* javax/swing/text/html/Option.java
	(Option): Make copy of attribute set. Initialize selected state.
	(getValue): Fetch value from attribute set.
	* javax/swing/text/html/ResetableModel.java: New interface.
	* javax/swing/text/html/ResetablePlainDocument.java: New class.
	Supports resetting the state.
	* javax/swing/text/html/ResetableToggleButtonModel.java: Likewise.
	* javax/swing/text/html/SelectComboBoxModel.java: Likewise.
	* javax/swing/text/html/SelectListModel.java: Likewise.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/DefaultCaret.java
	(appear): Adjust visibility here.
	(setDotImpl): Don't adjust visibility here.
	(moveDotImpl): Don't adjust visibility here.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/gtk/AsyncImage.java
	(Loader.run): Synchronize on the AsyncImage to avoid threading
	issues.
	(addObservers): Check for obs==null outside and synchronize on
	this inside to avoid locking issues.
	(checkImage): New helper method.
	(notifyObservers): Check that the correct lock is held and
	remove actual locking.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	(checkImage): Added special handling for AsyncImages.
	
2006-12-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/swing/Demo.java
	(getIcon): Made package private.
	* examples/gnu/classpath/examples/swing/HtmlDemo.java
	(hyperlinkUpdate): Convert URL to string.

2006-12-06  Mark Wielaard  <mark@klomp.org>

	* gnu/java/awt/peer/gtk/AsyncImage.java (addObserver): Never notify
	null Observer.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/icons/back.png,
	* examples/gnu/classpath/examples/icons/reload.png:
	New icons for the HTML browser.
	* examples/gnu/classpath/examples/swing/HtmlDemo.java
	(history): New field. Manages the browsing history.
	(HtmlDemo): Initialize history.
	(createContent): Set location and add history. Add toolbar.
	(createToolBar): New helper method.
	(main): Make default size bigger.
	* examples/gnu/classpath/examples/swing/frame1.html,
	* examples/gnu/classpath/examples/swing/frame2.html,
	* examples/gnu/classpath/examples/swing/frame3.html,
	* examples/gnu/classpath/examples/swing/frame4.html,
	* examples/gnu/classpath/examples/swing/frames.html,
	* examples/gnu/classpath/examples/swing/tables.html:
	New example pages.
	* examples/gnu/classpath/examples/swing/welcome.html
	Add a couple of links and new test pages.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(getStream): Buffer the stream for efficiency.
	(setPage): Don't scroll the view at this point.
	* javax/swing/plaf/basic/BasicTextUI.java
	(RootView.paint): Call RootView's setSize to get synchronization.
	(RootView.setSize): Synchronize to prevent race in layout code.
	* javax/swing/text/AbstractDocument.java
	(notifyListeners): New field.
	(fireChangedUpdate): Track notifyListener field.
	(fireRemoveUpdate): Track notifyListener field.
	(fireIndertUpdate): Track notifyListener field.
	(writeLock): Check notifyListener and throw IllegalStateException.
	* javax/swing/text/View.java
	(preferenceChanged): Create local var for better thread safety and
	more efficiency.

2006-12-06  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/ScrollPane.java (addNotify): Add a parent panel for any
	lightweight component, not just for non-Panel components.
	(addImpl): Do not call doLayout.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkButtonPeer.c
	(setNativeBounds): Ensure widget parent is a GtkFixed before
	calling gtk_fixed_move.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkLabelPeer.c
	(setNativeBounds): Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(setNativeBounds): Likewise.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/TableView.java
	(RowView.layoutMajorAxis): Check column index for invalid value.
	(updateGrid): Check column index for invalid value.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/BlockView.java
	(getAlignment): Align blocks horizontally by the superclass.
	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Replace equals comparison by == for efficiency.
	Add mapping for misplaced tr, td and th tags. Include object mapping.
	* javax/swing/text/html/TableView.java
	(RowView.replace): Invalidate grid early.
	(gridValid): Initialize with false.
	(create): Only create RowView and CellView for correctly placed
	tags. Avoid unnecessary casts.
	(getAlignment): Removed.
	(replace): Invalidate grid early.

2006-12-06  Francis Kung  <fkung@redhat.com>

	* java/awt/geom/RectangularShape.java
	(getBounds): Remove empty rectangle check.

2006-12-06  Ben Konrath  <bkonrath@redhat.com>

	Fixes PR 29853.
	* gnu/xml/dom/DomAttr.java: Don't report mutation if oldValue and
	newValue are the same.
	* gnu/xml/dom/DomNode.java: Set parent if null during mutation.

2006-12-06  Tania Bento  <tbento@redhat.com>

	* javax/swing/border/CompoundBorder.java:
	(isBorderOpaque): If inside border is null, return true if outside
	border is opaque, false otherwise; if outside border is null, return
	true if inside border is opaque, false otherwise; if inside or
	outside border are both not null, then return true only if both the
	inside and outside border are opaque, false otherwise.

2006-12-06  Tania Bento  <tbento@redhat.com>

	* javax/swing/border/CompoundBorder.java:
	(isBorderOpaque): If inside and outside border both have a null
	value, return true.

2006-12-06  Chris Burdess  <dog@gnu.org>

	Fixes PR 29272.
	* javax/xml/parsers/DocumentBuilderFactory.java: Fix broken Javadoc.
	* gnu/xml/stream/SAXParser.java: Fix file descriptor leak.

2006-12-06  Chris Burdess  <dog@gnu.org>

	Fixes PR 29264.
	* gnu/xml/stream/XMLStreamWriterImpl.java: Allow arbitrary text in
	  writeDTD method.

2006-12-06  Chris Burdess  <dog@gnu.org>

	Fixes PR 28816.
	* javax/xml/validation/SchemaFactory.java: Use correct algorithm to
	  discover schema factory implementation class.

2006-12-05  Francis Kung  <fkung@redhat.com>

	* java/awt/BasicStroke.java
	(capEnd): Prevent division by zero.
	* java/awt/geom/Arc2D.java
	(ArcIterator.ArcIterator): Do not shift the arc to make the extent positive.
	(ArcIterator.currentSegment): Handle a negative extent.

2006-12-05  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(constructor): Handle translated subimages properly, ie, if the image's
	0,0 position is not the data buffer's first element.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/gtk/AsyncImage.java
	(Loader.run): Nullify observers after loading.
	(observers): Made package private.
	(addObserver): Check for null observers field. Create local
	variable for thread safety.
	(getHeight): Use addObserver() for checking state of field
	and notifying observer when necessary.
	(getWidth): Use addObserver() for checking state of field
	and notifying observer when necessary.
	(getProperty): Use addObserver() for checking state of field
	and notifying observer when necessary.
	(notifyObservers): Check for null observers field. Create local
	variable for thread safety.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Removed debug output.
	* javax/swing/text/html/InlineView.java
	(getBreakWeight): Likewise.
	* javax/swing/text/html/StyleSheet.java
	(addRule): Likewise.
	(ListPainter.paint): Removed debug output.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/BlockView.java
	(painter): Made package visible.
	* javax/swing/text/html/StyleSheet.java
	(translateBorder): New helper method.
	(translateHTMLToCSS): Add mappings for border attributes.
	* javax/swing/text/html/TableView.java
	Made class subclass of BlockView to get CSS goodness.
	(CellView.rowSpan): New field.
	(CellView.setPropertiesFromAttributes): Fetch rowspan.
	(RowView.overlap): New field.
	(RowView.rowIndex): New field.
	(RowView.layoutMajorAxis): Skip overlapping cells.
	(RowView.layoutMinorAxis): Layout cells that span more than 1 row.
	(numColumns): New field.
	(tmpRect): New field.
	(TableView): Initialize tmpRect.
	(calculateColumnRequirements): Adjusted and fixed for multirows.
	(getAlignment): Overridden to center tables.
	(paint): Overridden to fix clipping.
	(getStyleSheet): Made protected.
	(layoutMajorAxis): Invalidate rows.
	(setPropertiesFromAttributes): Made protected and call super.
	(updateGrid): Update the overlapping information for multirows.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/gtk/AsyncImage.java
	(addObserver): Check for null and ignore null observers.
	(getWidth): Check for null and ignore null observers.
	(getHeight): Check for null and ignore null observers.
	(getProperty): Check for null and ignore null observers.

2006-12-05  Francis Kung  <fkung@redhat.com>

	* java/awt/BasicStroke.java
	(capEnd): Prevent division by zero.
	* java/awt/geom/Arc2D.java
	(ArcIterator.ArcIterator): Do not shift the arc to make the extent positive.
	(ArcIterator.currentSegment): Handle a negative extent.

2006-12-05  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(constructor): Handle translated subimages properly, ie, if the image's
	0,0 position is not the data buffer's first element.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/ImageView.java
	(imageUpdate): Use spans field to determine if the CSS width/height
	are set. Call safePreferenceChanged to protect view structure
	from threading issues.
	(spans): Made package private.
	(ImageView): Initialize loadOnDemand with false.
	(loadImage): Call Toolkit.prepareImage() to make sure we have
	our Observer registered.
	(safePreferenceChanged): New helper method. Calls preferenceChanged
	in a thread safe environment.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* NEWS: Add entry about improved HTML support.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/ImageView.java
	(ImageView): Initialize spans array here.
	(setPropertiesFromAttributes): Moved init of spans array to
	constructor.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/BlockView.java
	(painter): Made package visible.
	* javax/swing/text/html/StyleSheet.java
	(translateBorder): New helper method.
	(translateHTMLToCSS): Add mappings for border attributes.
	* javax/swing/text/html/TableView.java
	Made class subclass of BlockView to get CSS goodness.
	(CellView.rowSpan): New field.
	(CellView.setPropertiesFromAttributes): Fetch rowspan.
	(RowView.overlap): New field.
	(RowView.rowIndex): New field.
	(RowView.layoutMajorAxis): Skip overlapping cells.
	(RowView.layoutMinorAxis): Layout cells that span more than 1 row.
	(numColumns): New field.
	(tmpRect): New field.
	(TableView): Initialize tmpRect.
	(calculateColumnRequirements): Adjusted and fixed for multirows.
	(getAlignment): Overridden to center tables.
	(paint): Overridden to fix clipping.
	(getStyleSheet): Made protected.
	(layoutMajorAxis): Invalidate rows.
	(setPropertiesFromAttributes): Made protected and call super.
	(updateGrid): Update the overlapping information for multirows.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Removed debug output.
	* javax/swing/text/html/InlineView.java
	(getBreakWeight): Likewise.
	* javax/swing/text/html/StyleSheet.java
	(addRule): Likewise.
	(ListPainter.paint): Removed debug output.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/BlockView.java
	(getAlignment): Align blocks horizontally by the superclass.
	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Replace equals comparison by == for efficiency.
	Add mapping for misplaced tr, td and th tags. Include object mapping.
	* javax/swing/text/html/TableView.java
	(RowView.replace): Invalidate grid early.
	(gridValid): Initialize with false.
	(create): Only create RowView and CellView for correctly placed
	tags. Avoid unnecessary casts.
	(getAlignment): Removed.
	(replace): Invalidate grid early.


2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/TableView.java
	(RowView.layoutMajorAxis): Check column index for invalid value.
	(updateGrid): Check column index for invalid value.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(getStream): Buffer the stream for efficiency.
	(setPage): Don't scroll the view at this point.
	* javax/swing/plaf/basic/BasicTextUI.java
	(RootView.paint): Call RootView's setSize to get synchronization.
	(RootView.setSize): Synchronize to prevent race in layout code.
	* javax/swing/text/AbstractDocument.java
	(notifyListeners): New field.
	(fireChangedUpdate): Track notifyListener field.
	(fireRemoveUpdate): Track notifyListener field.
	(fireIndertUpdate): Track notifyListener field.
	(writeLock): Check notifyListener and throw IllegalStateException.
	* javax/swing/text/View.java
	(preferenceChanged): Create local var for better thread safety and
	more efficiency.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/icons/back.png,
	* examples/gnu/classpath/examples/icons/reload.png:
	New icons for the HTML browser.
	* examples/gnu/classpath/examples/swing/HtmlDemo.java
	(history): New field. Manages the browsing history.
	(HtmlDemo): Initialize history.
	(createContent): Set location and add history. Add toolbar.
	(createToolBar): New helper method.
	(main): Make default size bigger.
	* examples/gnu/classpath/examples/swing/frame1.html,
	* examples/gnu/classpath/examples/swing/frame2.html,
	* examples/gnu/classpath/examples/swing/frame3.html,
	* examples/gnu/classpath/examples/swing/frame4.html,
	* examples/gnu/classpath/examples/swing/frames.html,
	* examples/gnu/classpath/examples/swing/tables.html:
	New example pages.
	* examples/gnu/classpath/examples/swing/welcome.html
	Add a couple of links and new test pages.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/swing/Demo.java
	(getIcon): Made package private.
	* examples/gnu/classpath/examples/swing/HtmlDemo.java
	(hyperlinkUpdate): Convert URL to string.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/DefaultCaret.java
	(appear): Adjust visibility here.
	(setDotImpl): Don't adjust visibility here.
	(moveDotImpl): Don't adjust visibility here.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/FormView.java
	(SubmitThread.postData): Implemented.
	(SubmitThread.run): Pass data to postData().
	(actionPerformed): Reset form when reset button is activated.
	(createComponent): Add support for select lists and comboboxes.
	Don't set value of text and password fields here, this is done
	now in HTMLDocument for consistency.
	(getElementFormData): Add support for fetching form data from
	select lists and comboboxes as well as textareas.
	(getSelectData): New helper method. Fetches form data from
	select boxes.
	(getTextAreaData): New helper method. Fetches form data from
	textareas.
	(resetForm): New helper method. Resets the entire form.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.FormAction.end): Handle SELECT and OPTION tags.
	(HTMLReader.FormAction.start): Handle SELECT and OPTION tags.
	(HTMLReader.FormAction.setModel): Initialize text and password
	values here. Also, use the resetable special models.
	Group radio buttons into ButtonGroup for exclusive selection.
	(HTMLReader.FormTagAction): New class. Handles FORM tags.
	(HTMLReader.buttonGroups): New field.
	(HTMLReader.numOptions): New field.
	(HTMLReader.option): New field.
	(HTMLReader.selectModel): New field.
	(HTMLReader.textAreaDocument): Make ResetablePlainDocument.
	(HTMLReader.handleText): Handle OPTION text.
	(HTMLReader.initTags): Map FORM tags to FormTagAction.
	(HTMLReader.textAreaContent): Set initial content.
	* javax/swing/text/html/Option.java
	(Option): Make copy of attribute set. Initialize selected state.
	(getValue): Fetch value from attribute set.
	* javax/swing/text/html/ResetableModel.java: New interface.
	* javax/swing/text/html/ResetablePlainDocument.java: New class.
	Supports resetting the state.
	* javax/swing/text/html/ResetableToggleButtonModel.java: Likewise.
	* javax/swing/text/html/SelectComboBoxModel.java: Likewise.
	* javax/swing/text/html/SelectListModel.java: Likewise.

2006-12-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/swing/BrowserEditorKit.java:
	New class.
	* examples/gnu/classpath/examples/swing/HtmlDemo.java
	(LoadActionListener): Call setPage() helper method.
	(createContent): Register tweaked editor kit. For FormSubmitEvents
	call submitForm(), otherwise setPage().
	(postData): Helper method for posting form data.
	(setPage): Helper method for navigating to a new URL.
	(submitForm): Helper method for submitting a form.
	* examples/gnu/classpath/examples/swing/forms.html:
	Added text/password fields and select boxes.
	* examples/gnu/classpath/examples/swing/welcome.html: Fixed typo.

2006-12-07  Mark Wielaard  <mark@klomp.org>

	* java/net/URL.java (URL(URL,String,URLStreamHandler,boolean)): New
	private constructor.
	(URL(URL,String,URLStreamHandler)): Call new constructor.
	(URL(URL,String)): Likewise.
	(URL(String)): Likewise.

2006-12-07  Mark Wielaard  <mark@klomp.org>

	* javax/swing/JEditorPane.java (createEditorKitForContentType):
	Always load from system class loader.

2006-12-06  Ben Konrath  <bkonrath@redhat.com>

	Fixes PR 29853.
	* gnu/xml/dom/DomAttr.java: Don't report mutation if oldValue and
	newValue are the same.
	* gnu/xml/dom/DomNode.java: Set parent if null during mutation.

2006-12-06  Chris Burdess  <dog@gnu.org>

	Fixes PR 29272.
	* javax/xml/parsers/DocumentBuilderFactory.java: Fix broken Javadoc.
	* gnu/xml/stream/SAXParser.java: Fix file descriptor leak.

2006-12-06  Chris Burdess  <dog@gnu.org>

	Fixes PR 29264.
	* gnu/xml/stream/XMLStreamWriterImpl.java: Allow arbitrary text in
	writeDTD method.

2006-12-056  Chris Burdess  <dog@gnu.org>

	Fixes PR 28816.
	* javax/xml/validation/SchemaFactory.java: Use correct algorithm to
	discover schema factory implementation class.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/gtk/AsyncImage.java: New class. Supports
	asynchronous loading of images.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(drawImage): Fetch real image from possibly AsyncImage.
	* gnu/java/awt/peer/gtk/ComponentGraphics.java
	(drawImage): Fetch real image from possibly AsyncImage.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	(createImage(URL)): Create async image.
	(imageOrError): Made method static for easy access from AsyncImage.
	(prepareImage): For async images, register the observer to the
	image.

2006-12-05  Roman Kennke  <kennke@aicas.com>

	(paintComponent): Include paint area from event.
	(updateComponent): Include paint area from event.

2006-12-06  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/ScrollPane.java (addNotify): Add a parent panel for any
	lightweight component, not just for non-Panel components.
	(addImpl): Do not call doLayout.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkButtonPeer.c
	(setNativeBounds): Ensure widget parent is a GtkFixed before
	calling gtk_fixed_move.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkLabelPeer.c
	(setNativeBounds): Likewise.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkComponentPeer.c
	(setNativeBounds): Likewise.

2006-12-04  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* java/awt/Component.java (getFontImpl): Return a default font if
	topmost parent's font is null.

2006-12-04  Mark Wielaard  <mark@klomp.org>

	* javax/swing/text/html/CSS.java (parseMarginShorthand):
	Remove debug output.

2006-12-04  Roman Kennke  <kennke@aicas.com>

	* java/awt/font/TextLayout.java
	(hitTestChar): Fixed conditions for inclusion of range.
	Use layout information in the run for more efficiency.

2006-12-04  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/GlyphView.java
	(J2DGlyphPainter): New inner class.
	(checkPainter): For Java2D capable environments create
	a J2DGlyphPainter.

2006-12-04  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/gtk/FreetypeGlyphVector.java
	(FreeTypeGlyphVector): Don't filter control chars here.
	(getGlyphs): Filter control chars and replace them by
	hair space char.

2006-12-04  Roman Kennke  <kennke@aicas.com>

	* native/jni/java-nio/gnu_java_nio_VMChannel.c
	(Java_gnu_java_nio_VMChannel_connect): Retry on EINTR.

2006-12-04  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/lang/management/BeanImpl.java:
	(translate(String)): Don't assume the list uses "E",
	just use the first and only type variable.
	* java/lang/management/ManagementFactory.java:
	(getPlatformMBeanServer()): Register logging bean.
	* javax/management/openmbean/OpenType.java:
	(OpenType(String,String,String)): Actually use
	the string created to handle arrays.
	
2006-12-04  Mark Wielaard  <mark@klomp.org>

	* native/jni/java-nio/gnu_java_nio_VMChannel.c
	(JCL_thread_interrupted): Use CallStaticBooleanMethod.

2006-12-04  Mark Wielaard  <mark@klomp.org>

	* vm/reference/gnu/java/nio/VMChannel.java (isThreadInterrupted):
	Make static.
	* native/jni/java-nio/gnu_java_nio_VMChannel.c
	(JCL_thread_interrupted): Only take JNIEnv.
	(vm_channel_class): New static variable.
	(initID): Set vm_channel_class.
	Wrap all reads() and writes() in do-while blocks that check
	interrupted status.

2006-12-04  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/javax/management/Server.java:
	Make map final and initialise it.
	(unregisterMBean(ObjectName)): Match against
	delegate's object name and not the instance.
	* java/lang/management/ManagementFactory.java:
	Added constant fields.
	(getPlatformMBeanServer()): Implemented.
	* javax/management/MBeanServerFactory.java: New file.
	
2006-12-04  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/BoxView.java
	(paint): Replaced painting algorithm with more simple and more
	reliable painting of the box.
	* javax/swing/text/html/BlockView.java
	(PositionInfo): New inner class. Stores additional CSS
	positioning information.
	(positionInfo): New field.
	(BlockView): Initialize positionInfo field.
	(fetchLayoutInfo): New helper method. Fetches additional
	CSS positioning information.
	(layoutMajorAxis): Perform additional CSS layout.
	(layoutMinorAxis): Perform additional CSS layout.
	(positionView): New helper method.
	(replace): Overridden to fetch additional layout information.
	* javax/swing/text/html/CSS.java
	(Attribute.POSITION): New field.
	(Attribute.LEFT): New field.
	(Attribute.RIGHT): New field.
	(Attribute.TOP): New field.
	(Attribute.BOTTOM): New field.
	(getValue): Create Length for left, right, top and bottom
	attributes.

2006-12-04  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/parser/support/Parser.java
	(Sgml): Consume any whitespace that immediately follows
	and sgml insertion.
	(parseDocument): Consume any initial whitespace.

2006-12-03  Mark Wielaard  <mark@klomp.org>

	* gnu/javax/management/Server.java (beans): Initialize.
	(registerMBean): Don't initialize beans.

2006-12-03  Mark Wielaard  <mark@klomp.org>

	* java/util/logging/LogManager.java (getLevelProperty): Check
	whether value is null before passing to Level.parse().

2006-12-04  Robert Lougher  <rob.lougher@gmail.com>

	* java/lang/management/ThreadInfo.java (ThreadInfo): Check
	whether given a null lock and lockOwner.

2006-12-03  Mark Wielaard  <mark@klomp.org>

	* javax/swing/JEditorPane.java (PageLoader.in): Made a PageStream.
	(PageLoader.page): Made package local.
	(PageLoader.run): Don't reset loader.
	(PageLoader.cancel): New method.
	(loading): Renamed to loader.
	(getPage): Return loader.page.
	(setPage): Always set loader. Never reset to null.

2006-12-03  Mark Wielaard  <mark@klomp.org>

	* javax/swing/plaf/basic/BasicTreeUI.java (paint): Check whether
	path[k] is null.
	(isLastChild): Return false when path is null.

2006-12-03  Mark Wielaard  <mark@klomp.org>

	* gnu/java/awt/peer/gtk/GtkComponentPeer.java (paintArea): Renamed
	to currentPaintArea.
	(paintComponent): Work with local reference to currentPaintArea.
	(updateComponent): Likewise.
	(coalescePaintEvent): Set currentPaintArea.

2006-12-02  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* javax/management/MBeanServerBuilder.java: New file.
	
2006-12-01  Mark Wielaard  <mark@klomp.org>

	* java/text/DecimalFormat.java (parse): Always increment parsing
	index and adjust pos result.

2006-12-01  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTML.java
	(Attribute.DYNAMIC_CLASS): New field.
	(Attribute.PSEUDO_CLASS): New field.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.CharacterAction.start): Initialize anchor with link
	pseudo attribute.
	(updateSpecialClass): New helper method. Updates the dynamic
	or pseudo class for anchor tags.
	* javax/swing/text/html/HTMLEditorKit.java
	(LinkController.lastAnchorElement): New field. For tracking
	enter/exit of anchors.
	(LinkController.activateLink): Set pseudo class to 'visited'.
	(LinkController.mouseMoved): Added support for tracking
	the 'hover' dynamic class.
	* javax/swing/text/html/InlineView.java
	(changedUpdate): Fetch new properties.
	* javax/swing/text/html/StyleSheet.java
	(attributeSetToMap): New helper method.
	(getRule): Also append dynamic and pseudo class to key.
	(resolveStyle): Resolve style based generally on all attributes.
	* javax/swing/text/html/TableView.java
	(RowView.layoutMajorAxis): Make sure the grid is valid.
	(updateGrid): Made package private.
	* gnu/javax/swing/text/html/css/Selector.java
	(calculateSpecificity): Added support for dynamic and pseudo classes.
	(matches): Changed to operate on general attributes.
	Added support for dynamic and pseudo classes.

2006-12-01  Mario Torre  <neugens@limasoftware.net>

	* java/text/DecimalFormat.java (formatInternal): move the formatting of
	fractional portion in a separate method.
	Also fixes the handling of decimal separator and its associated field.
	(handleFractionalPart): new method, needed to relax a bit
	formatInternal.
	
2006-12-01  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/beans/beancontext/BeanContextServicesSupport.java:
	(BCSSProxyServiceProvider.getCurrentServiceSelectors(BeanContextServices,
	Class)): Implemented.
	(BCSSProxyServiceProvider.getService(BeanContextServices, Object,
	Class, Object)): Implemented.
	(BCSSProxyServiceProvider.releaseService(BeanContextServices,
	Object, Object)): Implemented.
	(BCSSProxyServiceProvider.serviceRevoked(BeanContextServiceRevokedEvent)):
	Implemented.
	(initialiseBeanContextResources()): Implemented.
	(releaseBeanContextResoures()): Implemented.
	
2006-12-01  Mark Wielaard  <mark@klomp.org>

	* include/gnu_java_awt_peer_gtk_GdkFontPeer.h: Regenerated.

2006-12-01  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/css/BorderStyle.java: New class for
	handling border styles.
	* gnu/javax/swing/text/html/css/BorderWidth.java
	(isValid): New method.
	* gnu/javax/swing/text/html/css/Length.java
	(isValid): New method.
	* javax/swing/text/html/CSS.java
	(addInternal): Added shorthand parsing for border, padding and
	margin.
	(parseBackgroundShorthand): Added API docs.
	(parsePaddingShorthand): New method. Handles padding shorthand
	values.
	(parseMarginShorthand): New method. Handles margin shorthand
	values.
	(parseBorderShorthand): New method. Handles border shorthand
	values.
	* javax/swing/text/html/StyleSheet.java
	(translateHTMLToCSS): Set specific padding attributes.
	(BoxPainter.BoxPainter): Don't handle PADDING and MARGIN here.
	These shorthands are now handled in CSS.
	(BoxPainter.paint): Exclude the outer margin.

2006-12-01  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/css/Length.java
	(emBase): New field.
	(exBase): New field.
	(isFontEMRelative): New field.
	(isFontEXRelative): New field.
	(Length): Recognize and setup EM and EX relative values.
	(getValue): Handle EM and EX relative values.
	(isEMRelative): New method.
	(isEXRelative): New method.
	(setEMBase): New method.
	(setEXBase): New method.
	(setFontBases): New method.
	* gnu/javax/swing/text/html/parser/support/Parser.java
	(_handleEmptyTag): Use new isBlock() helper method.
	(_handleEndTag_remaining): Use new isBlock() helper method.
	(_handleStartTag): Consume whitespace after block start tag.
	(Comment): Consume whitespace after a comment.
	(isBlock): New helper method.
	(readAttributes): Consider all characters in unquoted attribute
	values.
	* javax/swing/text/html/BlockView.java
	(layoutMinorAxis): Use cached span value.
	(paint): Added debug code (commented out).
	(setPropertiesFromAttributes): Set the EM and EX base on lengths.
	* javax/swing/text/html/CSSBorder.java
	(CSSBorder): Take StyleSheet as argument. Call getBorderWidth()
	with stylesheet.
	(getBorderWidth): Set the EM and EX base on the length values.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.ParagraphAction.end): Do not set the inParagraph field.
	(HTMLReader.ParagraphAction.start): Do not set the inParagraph field.
	(HTMLReader.inImpliedParagraph): Removed.
	(HTMLReader.inParagraph): Removed.
	(HTMLReader.parseStack): New field.
	(HTMLReader.addContent): Use new paragraph handling.
	(HTMLReader.addSpecialElement): Use new paragraph handling.
	(HTMLReader.blockClose): Use new paragraph handling.
	(HTMLReader.blockOpen): Use new paragraph handling.
	(HTMLReader.inImpliedParagraph): New helper method.
	(HTMLReader.inParagraph): New helper method.
	* javax/swing/text/html/ImageView.java
	(attributes): New field. Caches view attributes.
	(spans): New field. Caches CSS spans.
	(getAttributes): Correctly setup CSS view attributes.
	(getPreferredSpan): Use caches spans.
	(getStyleSheet): Use the view's getDocument() method.
	(setPropertiesFromAttributes): Cache spans and setup EM and EX.
	(updateSize): Use cached spans.
	* javax/swing/text/html/ParagraphView.java
	(setPropertiesFromAttributes): Setup EM and EX.
	* javax/swing/text/html/StyleSheet.java
	(BoxPainter.BoxPainter): Setup EM and EX correctly.
	(getEMBase): New helper method.
	(getEXBase): New helper method.
	* javax/swing/text/html/TableView.java
	(width): New field. Caches the table width.
	(calculateMinorAxisRequirements): Use caches span.
	(setPropertiesFromAttributes): Cache span and setup EM/EX.
	(updateGrid): Correctly setup EM/EX.

2006-11-30  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/FormSubmitEvent.java: New class.
	* javax/swing/text/html/FormView.java
	(SubmitThread): New class for submitting data in a separate thread.
	(actionPerformed): Fetch the actual for data.
	(addData): New helper method.
	(getElementFormData): New helper method.
	(getFormData): New helper method.
	(getInputFormData): New helper method.
	(submitData): Implemented.
	* javax/swing/text/html/FrameView.java
	(createComponent): Add this as hyperlink listener.
	Set the target document as frame document.
	(getTopEditorPane): New helper method.
	(hyperlinkUpdate): Implementation of the HyperlinkListener interface.
	(handleHyperlinkEvent): New helper method.
	(handleFormSubmitEvent): New helper method.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.BaseAction.start): Track the base target.
	(HTMLReader.BaseAction.end): Removed.
	(baseTarget): New field.
	(frameDocument): New field.
	(getBaseTarget): New property accessor.
	(isFrameDocument): New property accessor.
	(processHTMLFrameHyperlinkEvent): Implemented.
	(setFrameDocument): New property accessor.
	(updateFrame): New helper method.
	(updateFrameSet): New helper method.
	* javax/swing/text/html/HTMLEditorKit.java
	(LinkController.createHyperlinkEvent): Handle frame documents.
	(autoFormSubmission): New field.
	(HTMLEditorKit): Set autoFormSubmission to true.
	(isAutoFormSubmission): New property accessor.
	(setAutoFormSubmission): New property accessor.

2006-11-30  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/ElementIterator.java
	(ElementRef): New inner class.
	(currentDepth): Removed.
	(currentElement): Removed.
	(previousItem): Removed.
	(stack): New field. Holds the iteration stack.
	(state): Removed.
	(ElementIterator(Document)): Removed init of removed fields.
	(ElementIterator(Element)): Removed init of removed fields.
	(current): Changed to stack based algorithm.
	(deepestLeaf): New helper method.
	(depth): Changed to stack based algorithm.
	(first): Changed to stack based algorithm.
	(next): Changed to stack based algorithm.
	(previous): Changed to stack based algorithm.

2006-11-30  Francis Kung  <fkung@redhat.com>

	* .settings/org.eclipse.jdt.core.prefs: Set compilar compliance to 1.4.
	* .externalToolBuilders/ClasspathJar.launch: Include sun.* classses.

2006-11-30  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(draw): Set transform in buffered composite.
	(drawComposite): Do not transform bounds; round bounds.
	(drawGlyphVector):  Set transform in buffered composite.
	(drawRenderedImage):  Set transform in buffered composite.
	(fill):  Set transform in buffered composite.
	(updateBufferedImage): Fix scanline & height calculations.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(createPath): Simplify width & height calculation.
	(drawImage): Also transform width & height.

2006-11-30  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/FrameSetView.java: New class. Implements
	HTML framesets.
	* javax/swing/text/html/FrameView.java: New class. Implements
	HTML frames.
	* javax/swing/text/html/HTMLDocument.java:
	(HTMLReader.addSpecialElement): Only add one artificial space.
	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Uncomment code for FrameSetView and FrameView.
	* gnu/javax/swing/text/html/parser/support/Parser.java
	(_handleEmptyTag): Also consume whitespace after frame tags.

2006-11-30  Gary Benson  <gbenson@redhat.com>

	* java/lang/Thread.java: Javadoc fixes.

2006-11-29  Tom Tromey  <tromey@redhat.com>

	PR classpath/28203:
	* java/lang/Class.java (getAnnotations): Rewrote.

2006-11-29  Tania Bento  <tbento@redhat.com>

	* tools/gnu/classpath/tools/appletviewer/TagParser.java:
	(parseParams): Unescape 'val' before putting it into the Map.
	(unescapeString): New private method.

2006-11-29  Tom Tromey  <tromey@redhat.com>

	* tools/gnu/classpath/tools/getopt/package.html: New file.

2006-11-29  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/metal/MetalIconFactory.java
	(HorizontalSliderThumbIcon.paintIcon()): Commented out gradient paint,
	(VerticalSliderThumbIcon.paintIcon()): Likewise.

2006-11-29  Mario Torre  <neugens@limasoftware.net>

	* java/text/NumberFormat.java (getCurrencyInstance): Replaced dollar sign
	with the default international currency sign \u00A4.
	* java/text/DecimalFormat.java (scanFix): Fix to use the localized symbol
	table for string formatting.
	(formatInternal): likewise.
	(scanNegativePattern): likewise.
	(applyPattern): likewise.
	* java/text/DecimalFormatSymbols.java (clone): Revert to old version as
	Locale is immutable and does not need clone.

2006-11-29  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(drawLine): Remove hard-coded pixel shifting.

2006-11-29  Roman Kennke  <kennke@aicas.com>

	* java/awt/Component.java
	(isShowing): Simplified condition code and avoid unnecessary
	if-codepaths.
	(coalesceEvents): Always coalesce paint events and let the peer
	figure out the expanding of the repaint area.
	* gnu/java/awt/peer/swing/SwingComponentPeer.java
	(currentPaintEvents): Removed. Replaced by paintArea.
	(paintArea): New field. Tracks the dirty area.
	(SwingComponentPeer): Removed init of currentPaintEvents.
	(coalescePaintEvent): Simplified to only union the dirty regions.
	(handleEvent): Paint dirty region that was tracked in paintArea.
	* gnu/java/awt/peer/gtk/GtkComponentPeer.java
	(paintArea): New field. Tracks the dirty region.
	(coalescePaintEvent): Implemented to track the dirty region.
	(paintComponent): Use the dirty region in paintArea. Protect
	state by putting the paint and dispose code in a try-finally.
	(updateComponent): Use the dirty region in paintArea. Protect
	state by putting the paint and dispose code in a try-finally.

2006-11-29  Roman Kennke  <kennke@aicas.com>

	* java/awt/font/TextLayout.java
	(getVisualHighlightShape): Removed debug output.

2006-11-28  Andrew Haley  <aph@redhat.com>

	* vm/reference/sun/reflect/misc/ReflectUtil.java
	(checkPackageAccess): Implement.

2006-11-28  Dalibor Topic  <robilad@kaffe.org>

        * native/jni/java-lang/java_lang_VMDouble.c:
        (parseDoubleFromChars) New function. Factored out from ...
        (Java_java_lang_VMDouble_parseDouble): Factored out the parsing.
        (dtoa_toString): New function. Factored out from ...
        (Java_java_lang_VMDouble_toString) : Factored out the conversion.
        Changed conversion mode to 2, as modes 0 and 1 don't round
        as the API spec demands. Invoke conversion function as often
        as necessary with growing precision until a reversible
        representation of the double in form of a string is reached.

2006-11-28  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JComponent.java
	(putClientProperty): Do not fire event when both old and new
	value are == null.

2006-11-27  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/lang/Enum.java:
	Make name and ordinal final.
	
2006-11-27  Casey Marshall  <csm@gnu.org>

	* java/util/jar/JarEntry.java (certs): removed.
	(jarfile): new field.
	(getCertificates): read the certificates from the containing JarFile.
	* java/util/jar/JarFile.java (JarEnumeration.nextElement): don't
	fill in 'certs,' fill in 'jarfile' for the entry.
	(getEntry): likewise.
	
2006-11-27  Francis Kung  <fkung@redhat.com>

	* java/awt/image/WritableRaster.java
	(createChild): Implemented.

2006-11-27  Roman Kennke  <kennke@aicas.com>

	* java/awt/font/TextLayout.java
	(TextLayout(TextLayout,int,int)): Also layout the new runs.
	(getVisualHighlightShape): Implemented.
	(layoutRuns): Fixed boundary so that the last run is also laid out.
	(left): New helper method.
	(right): New helper method.

2006-11-27  Roman Kennke  <kennke@aicas.com>

	* java/awt/font/TextLayout.java
	(getCaretShape(TextHitInfo,Rectangle2D)): Implemented.
	(getCaretShape(TextHitInfo)): Use natural bounds.
	(getCaretShapes(int,Rectangle2D,CaretPolicy)): New API method.
	(getCaretShapes(int,Rectangle2D)): Delegate to new method
	above with DEFAULT_CARET_POLICY.
	(getCaretShapes(int)): Use natural bounds.

2006-11-27  Roman Kennke  <kennke@aicas.com>

	* java/awt/font/TextLayout.java
	(Run.font): New field.
	(Run.location): New field.
	(Run.Run): Initialize font.
	(font): Removed field. This is moved into Run as the actual font
	is something run-specific.
	(TextLayout(String,Font,FontRenderContext)): Set font on the
	single runs. Layout the runs here.
	(TextLayout(TextLayout,int,int)): Copy over the run fonts.
	(findRunAtIndex): New helper method.
	(getCaretInfo): Implemented.
	(layoutRuns): New helper method.
	(toString): Don't put font in output string.

2006-11-27  Raif S. Naffah  <classpath@naffah-raif.name>

	* AUTHORS: Added Jeroen Fritjers.

2006-11-27  neugens  <neugens@nirvana.limasoftware.net>

	* java/text/DecimalFormat.java (formatInternal): Add an explicit test
	for FieldPosition to be null.
	Check if the factional part is just 0 and can be omitted from the
	result.
	(scanNegativePattern): Fixed index out of bound exception when searching
	for international currency symbol in negative pattern.	

2006-11-27  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/beans/beancontext/BeanContextSupport.java:
	(readObject(ObjectInputStream)): Implemented.
	(writeObject(ObjectOutputStream)): Likewise.
	(BCSChild.getTargetChild()): Added.
	(bcsPreDeserializationHook()): Implemented.
	(bcsPreSerializationHook()): Likewise.
	(childDeserializedHook(Object,BCSChild)): Likewise.
	(isSerializing()): Likewise.
	(readChildren(ObjectInputStream)): Likewise.
	(writeChildren(ObjectOutputStream)): Likewise.
	
2006-11-26  Roger Sayle  <roger <at> eyesopen.com>
	    Ian Lance Taylor  <ian <at> airs.com>
	    Paolo Bonzini <bonzini <at> gnu.org>

	Fixes bug #25557.

	* lib/gen-classlist.sh.in:  Avoid using test's -ef operator for
	increased portability.  Likewise, use -f instead of -e.

2006-11-26  Mark Wielaard  <mark@klomp.org>

	* lib/Makefile.am (propertydirs): Removed.
	(resources): Explicitly create all dirs.

2006-11-26  Mark Wielaard  <mark@klomp.org>

	* gnu/java/net/PlainSocketImpl.java (accept): Reset timeout on Socket.

2006-11-26  Dalibor Topic  <robilad@kaffe.org>

	* native/target/.cvsignore,
	native/target/generic/.cvsignore,
	native/target/Linux/.cvsignore:
	Removed no longer used files.

	* native/target: Removed no longer used directory.

2006-11-26  Dalibor Topic  <robilad@kaffe.org>

	Fixes bug #29133.

	* libraries/clib/nio/gnu_java_nio_VMSelector.c
	(Java_gnu_java_nio_VMSelector_select):
	Use strerror if strerror_r is not available.

	Reported by:  Michael Franz <mvfranz@gmail.com>,
		      Riccardo Mottola <zuse@libero.it>

2006-11-26  Dalibor Topic  <robilad@kaffe.org>

	Fixes bug #26756.
	
	* native/jni/midi-dssi/Makefile.am (AM_CFLAGS): Removed 
	STRICT_WARNING_CFLAGS since it caused the build to fail 
	on GNU/Linux.

2006-11-26  Ian Rogers  <ian.rogers@manchester.ac.uk>

	* doc/vmintegration.texinfo: Update VM Threading Model section.

2006-11-26  Tom Tromey  <tromey@redhat.com>

	* native/jni/java-net/java_net_VMNetworkInterface.c: Conditionally
	include ifaddrs.h.
	(Java_java_net_VMNetworkInterface_getVMInterfaces): Updated
	conditional.
	* native/jni/java-net/gnu_java_net_VMPlainSocketImpl.c:
	Conditionally include ifaddrs.h.
	(getif_address): Updated conditional.
	(getif_index): Likewise.
	* configure.ac: Check for ifaddrs.h.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	* java/io/File.java (list): Return empty list for unreadable dirs.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java (drawGlyphVector):
	Synchronize on font peer.
	(setFont): Likewise.
	* gnu/java/awt/peer/gtk/GdkFontPeer.java (getFontMetrics): Mark
	synchronized.
	(getTextMetrics): Likewise.

2006-11-25  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/GapContent.java
	(getPositionsInRange): Rewritten to use the more efficient
	binary search searchFirst() and avoid an NPE that was caused
	by GC'ed positions.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	* javax/swing/text/CompositeView.java (modelToView): Never return
	null.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	* javax/swing/text/html/TableView.java (calculateColumnRequirements):
	Check whether rowView instanceof RowView.
	(updateGrid): Likewise.

2006-11-25  Mario Torre  <neugens@nirvana.limasoftware.net>

	PR28462
	* java/text/DecimalFormat.java: Almost new rewrite, and update to 1.5.
	* java/text/NumberFormat.java (format): all format methods, fixed
	FieldPosition argument should never be null.
	(format(Object, StringBuffer, FieldPosition)): fixed signature,
	method is not final.
	* java/text/DecimalFormatSymbols.java (clone): fixed to also clone
	locale.
	* AUTHORS: added my name to the file.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	* javax/swing/text/html/StyleSheet.java (paint): Guard against
	getChildAllocation() returning null.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	* gnu/javax/swing/text/html/css/Selector.java (calculateSpecificity):
	Use clazzIndex for id substring.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	* java/awt/EventQueue.java (pop): Only terminate dispatchThread when
	it is still running.

2006-11-25  Mark Wielaard  <mark@klomp.org>

	Fixes bug #28822
	* doc/api/Makefile.am (create_html): Guard GJDOC invocation with
	CREATE_API_DOCS

2006-11-24  Tania Bento  <tbento@redhat.com>

	* java/awt/font/TextHitInfo.java
	(equals(TextHitInfo)): If TextHitInfo parameter is null, return false.
	(beforeOffset): Decreased first parameter by 1.

2006-11-24  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(constructor): Check sample model when setting fastCM flag.
	(updateBufferedImage): Check scanline and sample model offsets before
	copying data directly into the image data buffer.

2006-11-24  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/java2d/QuadSegment.java
	(offsetSubdivided): Handle special straight-line cases.

2006-11-24  Roman Kennke  <kennke@aicas.com>

	* java/awt/dnd/DropTarget.java
	(DropTargetAutoScroller.HYSTERESIS): New constant.
	(DropTargetAutoScroller.DELAY): New constant.
	(DropTargetAutoScroller.inner): New field. A cached
	Rectangle instance.
	(DropTargetAutoScroller.outer): New field. A cached
	Rectangle instance.
	(DropTargetAutoScroller.timer): New field. The actual timer.
	(DropTargetAutoScroller.DropTargetAutoScroller):
	Initialize timer.
	(DropTargetAutoScroller.actionPerformed): Implemented.
	(DropTargetAutoScroller.stop): Implemented.
	(DropTargetAutoScroller.updateLocation): Implemented.
	(clearAutoscroll): Stop the autoscroller before nullifying it.
	(createDropTargetAutoScroller): Don't set the field here,
	only return a new instance.
	(dragEnter): Only do something when active. Initialize
	auto scrolling.
	(dragExit): Only do something when active. Stop auto scrolling.
	(dragOver): Only do something when active. Update auto scrolling.
	(drop): Only do something when active. Update auto scrolling.
	(dropActionChanged): Only do something when active. Update
	auto scrolling.
	(initializeAutoScrolling): Check if component is an instance
	of Autoscroll, otherwise do nothing.
	(setActive): Disable autoscrolling when deactivating.
	(setComponent): When component is set to null, disable autoscrolling.

2006-11-24  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextServicesSupport.java
	(getChildBeanContextServicesListener): Implemented.

2006-11-23  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/headless/HeadlessGraphicsEnvironment.java
	(createGraphics): Use constructor to create new instance of
	BufferedImageGraphics.
	* java/awt/Toolkit.java
	(getDefaultToolkit): Really try to get a real toolkit. Only
	use HeadlessToolkit if no other is available.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	(checkHeadless): New helper method. Checks for headless environment
	and throws HeadlessException if appropriate.
	(createButton): Check for headless.
	(createCanvas): Check for headless.
	(createCheckbox): Check for headless.
	(createCheckboxMenuItem): Check for headless.
	(createChoice): Check for headless.
	(createDialog): Check for headless.
	(createDragGestureRecognizer): Check for headless.
	(createDragSourceContextPeer): Check for headless.
	(createEmbeddedWindow): Check for headless.
	(createFileDialog): Check for headless.
	(createFrame): Check for headless.
	(createCheckbox): Check for headless.
	(createLabel): Check for headless.
	(createList): Check for headless.
	(createMenu): Check for headless.
	(createMenuBar): Check for headless.
	(createMenuItem): Check for headless.
	(createPanel): Check for headless.
	(createPopupMenu): Check for headless.
	(createScrollbar): Check for headless.
	(createScrollPane): Check for headless.
	(createTextArea): Check for headless.
	(createTextField): Check for headless.
	(createWindow): Check for headless.

2006-11-23  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextSupport.java
	(deserialize): Implemented,
	(serialize): Implemented.

2006-11-23  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/headless/HeadlessGraphicsEnvironment.java
	(createGraphics): Try to use Cairo graphics if available.

2006-11-22  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextSupport.java
	(toArray): Added API docs,
	(toArray(Object[])): Added API docs, removed NotImplementedException.

2006-11-22  Tania Bento  <tbento@redhat.com>

	* javax/swing/JRootPane.java
	(setLayeredPane): Added documentation; throw 
	IllegalComponentStateException if layered pane parameter is null.

2006-11-22  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextSupport.java
	(avoidingGui): Removed NotImplementedException.

2006-11-22  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(drawGlyphVector): Clip updated area to glyph bounds.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(createPath): Eliminate distortion when pixel-shifting rectangles; separate
	x-coordinate and y-coordinate pixel shifting.
	(shifted): Removed method.
	(shiftX): New method, recognising scaling transforms.
	(shiftY): New method, recognising scaling transforms.
	(walkPath): Separate x-coordinate and y-coordinate pixel shifting.

2006-11-22  Roman Kennke  <kennke@aicas.com>

	* java/awt/font/TextLayout.java
	(hash): New field. Caches the hash code.
	(hashCode): Implemented.

2006-11-22  Roman Kennke  <kennke@aicas.com>

	* java/awt/image/ImageFilter.java
	Reformat whole class.
	(getFilterInstance): Don't touch the consumer field. Don't check
	consumer.
	(imageComplete): Don't check consumer.
	(setColorModel): Don't check consumer.
	(setDimensions): Don't check consumer.
	(setHints): Don't check consumer.
	(setPixels): Don't check consumer.
	(setProperties): Pass the original property too.
	* java/awt/image/IndexColorModel.java
	(IndexColorModel(int,int,byte[],byte[],byte[],int)): Set the
	transparent pixel by calling the new helper method.
	(IndexColorModel(int,int,byte[],int,boolean,int)): Set the
	transparent pixel by calling the new helper method.
	(IndexColorModel(int,int,int[],int,boolean,int,int)): Set the
	transparent pixel by calling the new helper method.
	(coerceData): Removed. This is not needed.
	(getAlpha): Simply return value from color map. The transparent
	pixel has to be there.
	(setTransparentPixel): New helper method. Inserts the transparent
	pixel.
	* java/awt/image/RGBImageFilter.java
	Reformat whole class.
	(convertColorModelToDefault): Removed. No longer needed.
	(filterIndexColorModel): Don't handle transparent pixels
	separately.
	(filterRGBPixels): Set pixels on consumer already.
	(makeColor): Removed. No longer needed.
	* java/awt/image/ReplicateScaleFilter.java
	(replicatePixels): Removed.
	(setDimension): Correctly compute destination size, avoid double
	calculations.
	(setPixels): Avoid double calculations. Fixed some boundary cases.
	(setupSources): New helper method.
	* java/awt/image/SampleModel.java
	(setDataElements): Also handle TYPE_SHORT, TYPE_FLOAT
	and TYPE_DOUBLE.
	* java/awt/image/SinglePixelPackedSampleModel.java
	(setDataElements(int,int,int,int,Object,DataBuffer)): Removed.
	This is not needed as the superclass already copies line
	by line.
	(setDataElements(int,int,Object,DataBuffer)): Simplified code,
	removed some checks that the RI also doesn't perform. Call
	DataBuffer.setElem().

2006-11-22  Roman Kennke  <kennke@aicas.com>

	* java/awt/text/TextLayout.java
	(getLogicalRangesForVisualSelection): Implemented.

2006-11-21  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* sun/reflect/annotation/AnnotationParser.java,
	* sun/reflect/annotation/AnnotationType.java,
	* sun/reflect/annotation/EnumConstantNotPresentExceptionProxy.java,
	* sun/reflect/annotation/ExceptionProxy.java:
	Stubbed.
	* sun/misc/ServiceConfigurationError.java,
	* sun/misc/Service.java:
	Implemented.
	
2006-11-21  Roman Kennke  <kennke@aicas.com>

	* java/awt/text/TextLayout.java
	(Run.isLeftToRight): New helper method.
	(logicalToVisual): New field. Maps logical indices to visual
	indices.
	(visualToLogical): New field. Maps visual indices to logical
	indices.
	(TextLayout): Setup mappings.
	(setupMappings): New method for setting up the mappings.
	(getCharacterLevel): Reorganized code.
	(getNextLeftHit(int)): Implemented.
	(getNextLeftHit(int,CaretPolicy)): New method.
	(getNextLeftHit(TextHitInfo)): Implemented.
	(getNextRightHit(int)): Implemented.
	(getNextRightHit(int,CaretPolicy)): New method.
	(getNextRightHit(TextHitInfo)): New method.
	(getVisualOtherHit): Implemented.
	(checkHitInfo): New helper methods for checking parameters.
	(hitToCaret): New helper method. Maps hit infos to caret locations.
	(caretToHit): New helper method. Maps caret locations to hit infos.
	(isCharacterLTR): New helper method.
	(CaretPolicy.getStrongCaret): Implemented.

2006-11-21  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(draw): Include stroke width when calculating bounds.
	(updateBufferedImage): Round bounds more generously, handle negative
	height/width values, and clip more intelligently.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(createPath): Add shortcut optimization for lines.
	(draw): Include stroke width when calculating bounds.
	(drawLine): Delegate to main draw() method.
	(drawRect): Likewise.
	(fillRect): Delegate to main fill() method.
	(findStrokedBounds): New method.
	(setCustomPaint): Round bounds more generously.
	* gnu/java/awt/peer/gtk/ComponentGraphics.java
	(drawLine): Removed.
	(drawRect): Removed.
	(fillRect): Removed.

2006-11-21  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/java2d/TexturePaintContext.java
	(getRaster): Handle negative coordinate values.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(setPaint): Moved custom paint processing to a new method.
	(setPaintPixels): Added x, y parameters.
	(getRealBounds): Added documentation.
	(copy): Copy clipping information.
	(drawLine): Process custom paints.
	(setCustomPaint): New method.
	(fill): Process custom paints.
	(drawGlyphVector): Process custom paints.
	(drawRect): Process custom paints.
	(draw): Process custom paints.
	* gnu/java/awt/peer/gtk/CairoSurface.java
	(cairoCM_opaque): New constant.
	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(argb32): Removed constant.
	(rgb32): Removed constant.
	(BufferedImageGraphics(BufferedImage)): Updated constant names.
	(BufferedImageGraphics(BufferedImageGraphics)): Copy color model flags.
	(updateBufferedImage): Transform to device-space before updating.
	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h
	(Java_gnu_java_awt_peer_gtk_CairoGraphics2D_setPaintPixels): Added x, y
	parameters.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_CairoGraphics2D.c
	(Java_gnu_java_awt_peer_gtk_CairoGraphics2D_setPaintPixels): Set pattern
	source at designated x, y origin.

2006-11-21  Roman Kennke  <kennke@aicas.com>

	* java/awt/text/TextLayout.java
	(Run): New inner helper class.
	(length): New field.
	(naturalBounds): New field.
	(offset): New field.
	(runIndices): Removed. This is now encapsulate in a Run object.
	(runs): Changed to Run[].
	(string): Changed to char[].
	(totalAdvance): New field. Caches advance value.
	(TextLayout(String,Font,FontRenderContext)): Change to store
	string as char[] and run layout as Run[]. Clean out empty
	run items.
	(TextLayout(TextLayout,int,int)): Change to store
	string as char[] and run layout as Run[].
	(clone): Call private constructor for maximum efficiency.
	(determineWhitespace): Adapted to use char[] data.
	(draw): Adapted to use Run objects.
	(getAdvance): Cache computed total advance.
	(getBlackBoxBounds): Adapted to use Run objects.
	(getCaretInfo): Use natural layout bounds.
	(getCharacterCount): Return length field.
	(getLogicalHighlightShape): Adapted to use Run objects.
	(getNaturalBounds): New helper method. Calculates and returns the
	natural bounds of this text layout.
	(getOutline): Adapted to use Run objects.
	(getStringProperties): Adapted to use char[] data.
	(getVisibleAdvance): Adapted to use char[] and Run data.
	(handleJustify): Adapted to use char[] and Run data.
	(hitTestChar(float,float,Rectangle2D)): Implemented.
	(hitTestChar(float,float)): Use natural bounds.
	(setCharIndices): Adapted to use char[] and Run data.
	(toString): Adapted to use char[] and Run data.
	* java/text/Bidi.java
	(requiresBidi): Exclude paragraph separators from bidi-triggers.

2006-11-21  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/gtk/GdkFontMetrics.java:
	Removed. This is now an inner class in GdkFontPeer.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(drawString(float,float)): Use text layout cache from
	GdkFontPeer.
	(getFontMetrics): Delegate to GdkFontPeer.
	* gnu/java/awt/peer/gtk/FreetypeGlyphVector.java
	(getGlyphCodes): Also check array size.
	(getGlyphPositions): Also check array size.
	* gnu/java/awt/peer/gtk/GdkFontPeer.java
	(GdkFontLineMetrics.fm): Removed.
	(GdkFontLineMetrics.strikeThroughOffset): Removed.
	(GdkFontLineMetrics.strikeThroughThickness): Removed.
	(GdkFontLineMetrics.underlineOffset): Removed.
	(GdkFontLineMetrics.underlineThickness): Removed.
	(GdkFontLineMetrics.GdkFontLineMetrics): Don't take
	FontMetrics argument. Don't init removed fields.
	(GdkFontLineMetrics.getAscent): Return font peer's field.
	(GdkFontLineMetrics.getDescent): Return font peer's field.
	(GdkFontLineMetrics.getHeight): Return font peer's field.
	(GdkFontLineMetrics.getLeading): Return font peer's field.
	(GdkFontLineMetrics.getNumChars): Reformat.
	(GdkFontLineMetrics.getStrikeThroughOffset): Return half ascent.
	(GdkFontLineMetrics.getStrikeThroughThickness): Return 1.
	(GdkFontLineMetrics.getUnderlineOffset): Return font peer's field.
	(GdkFontLineMetrics.getUnderlineThickness): Return font peer's field.
	(GdkFontMetrics): Moved class in here as inner class. 
	Make it use the font peer's fields and for the char(s) width
	and string width method, use TextLayout to measure the actual widths.
	(ascent): New field.
	(bundle): Removed.
	(DEFAULT_CTX): New constant field.
	(descent): New field.
	(FONT_METRICS_ASCENT): New constant.
	(FONT_METRICS_DESCENT): New constant.
	(FONT_METRICS_HEIGHT): New constant.
	(FONT_METRICS_MAX_ADVANCE): New constant.
	(FONT_METRICS_MAX_ASCENT): New constant.
	(FONT_METRICS_MAX_DESCENT): New constant.
	(FONT_METRICS_UNDERLINE_OFFSET): New constant.
	(FONT_METRICS_UNDERLINE_THICKNESS): New constant.
	(height): New field.
	(maxAdvance): New field.
	(maxAscent): New field.
	(maxDescent): New field.
	(metrics): New field. Stores a FontMetrics for this font.
	(textLayoutCache): New field. Caches TextLayout instances.
	(underlineOffset): New field.
	(underlineThickness): New field.
	(cinit): Don't initialize resource bundle.
	(GdkFontPeer): Setup the metrics.
	(getFontMetrics): Return stored metrics if possible.
	(getLineMetrics): Adapt to new constructor.
	(initFont): New helper method.
	(setupMetrics): New helper method.
	* gnu/java/awt/peer/gtk/GtkToolkit.java
	(LRUCache): Made class a static class.
	(getFontMetrics): Delegate to GdkFontPeer.
	* native/jni/gtk-peer/gdkfont.h
	Added new constant defines.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GdkFontPeer.c
	(getFontMetrics): Rewritten to fetch the font metrics from
	FreeType.

2006-11-20  Tania Bento  <tbento@redhat.com>

	* javax/swing/ButtonGroup.java:
	(setSelected): Select the ButtonModel if all conditions
	are met.

2006-11-20  Tania Bento  <tbento@redhat.com>

	* javax/swing/JSlider.java:
	(updateLabelUIs): Removed casting.

2006-11-20  Mark Wielaard  <mark@klomp.org>

	* gnu/java/util/regex/RE.java (messages): Don't initialize.
	(bundle): New static final String field.
	(getLocalizedMessage): Initialize messages when still null.
	* gnu/java/util/regex/RESyntax.java (SYNTAX_IS_FINAL): Removed.
	(set): Use RE.getLocalizedMessage().
	(clear): Likewise.
	(setLineSeparator): Likewise.

2006-11-20  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/StyleSheet.java
	(linked): New field.
	(styleSheet): Replaced by linked.
	(addStyleSheet): Use an arraylist for simplicity.
	(getRule): Removed useless instantiation.
	(getStyleSheets): Convert array list to array.
	(removeStyleSheet): Use an arraylist for simplicity.
	(resolveStyle): Include styles from linked lists.

2006-11-20  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/BoxView.java
	(BoxView): Initialize with invalid req's.
	(forwardUpdate): Trigger repaint when children changed the
	major axis.
	(getResizeWeight): Return resizable when the pref differs from
	the min or the pref differs from the max size.
	(layoutMajorAxis): Actually sum up the preferred sizes.
	(paint): Made binary search more robust.
	(replace): Let arrays shrink when needed.
	(replaceLayoutArray): Let arrays shrink when needed.
	(setAxis): Trigger preferenceChanged.
	* javax/swing/text/CompositeView.java
	(getInsideAllocation): Call insets method to take account
	of overriding subclasses.
	* javax/swing/text/DefaultStyledDocument.java
	(ElementBuffer.finishEdit): Clear the stack and edits buffer.
	(ElementBuffer.insertUpdate): Only remove the found element, not
	all.
	* javax/swing/text/GlyphView.java
	(insertUpdate): Pass null in preferenceChanged.
	(removeUpdate): Pass null in preferenceChanged.
	(changedUpdate): Pass null in preferenceChanged.
	* javax/swing/text/Utilities.java
	(drawTabbedText): Avoid single calls to charWidth() and instead
	call charsWidth() on whole chunks.
	* javax/swing/text/html/HTMLDocument.java
	(BlockElement.getName): Fall back to super when necessary.
	(RunElement.getName): Fall back to super when necessary.
	(HTMLReader.MAX_THRESHOLD): New constant field.
	(HTMLReader.GROW_THRESHOLD): New constant field.
	(HTMLReader.theshold): New field.
	(HTMLReader.HTMLReader): Fetch threshold from document.
	(HTMLReader.addContent): Sucessivly grow the threshold.
	(createLeafElement): Don't create two elemens and don't set
	attribute.
	* javax/swing/text/html/TableView.java
	(RowView.replace): Invalidate grid.
	(gridValid): Made package private.
	(layoutMinorAxis): Mark all rows as invalid.
	(replace): Invalidate grid.

2006-11-20  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/AbstractDocument.java
	(DefaultDocumentEvent.changes): Changed to be a HashMap.
	(DefaultDocumentEvent.modified): Made private.
	(DefaultDocumentEvent.THRESHOLD): New constant field.
	(DefaultDocumentEvent.DefaultDocumentEvent): Don't initialize
	changes table.
	(DefaultDocumentEvent.addEdit): Switch to hashmap only when
	exceeding threshold.
	(DefaultDocumentEvent.getChange): Use iterative approach
	when we have no hashmap yet.
	(documentCV): Removed.
	(numWriters): Renamed from numWritersWaiting.
	(createPosition): Reformat.
	(getCurrentWriter): Synchronized.
	(readLock): Implement more straightforward.
	(readUnlock): Implement more straightforward.
	(writeLock): Implement more straightforward.
	(writeUnlock): Implement more straightforward.
	(remove): Write-lock here.
	(removeImpl): Don't write-lock here.

2006-11-20  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(setPage): Set priority on loading thread.

2006-11-20  Roman Kennke  <kennke@aicas.com>

	* javax/swing/plaf/basic/BasicTextUI.java
	(RootView.paint): Avoid allocation.
	(cachedInsets): New field. Caches an Insets instance.
	(getNextVisualPositionFrom): Read-lock the document to avoid
	thread nastiness. Push allocation.
	(getPreferredSize): Push fake allocation when not yet laid out.
	(getVisibleEditorRect): Use cached insets.
	(viewToModel): Read-lock the document to avoid
	thread nastiness. Push allocation.

2006-11-20  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/StyleContext.java
	(attributeSetPool): Synchronize this map.
	(addAttribute): Synchronize this method.
	(addAttributes: Synchronize this method.
	(readObject): Install synchronized map on target object.
	(removeAttribute): Synchronize this method.
	(removeAttributes): Synchronize this method.
	(removeAttributes): Synchronize this method.	
	
2006-11-20  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/GapContent.java
	(GapContentPosition.GapContentPosition): Removed constructor.
	(Mark): Made subclass of WeakReference to refer directly to
	the associated position.
	(Mark.refCount): Removed.
	(Mark.Mark(int,GapContentPosition,ReferenceQueue):
	New constructor. Used to reference a position and register the
	reference queue.
	(Mark.Mark(index)): Call super and don't adjust mark offset.
	(Mark.compareTo): Removed.
	(Mark.equals): Removed.
	(Mark.getOffset): Return at least null. Removed assert.
	(Mark.getPosition): New helper method.
	(garbageMarks): New field.
	(positions): Removed.
	(searchMark): New field.
	(GapContent): Removed init of positions map.
	(addImpl): New helper method.
	(adjustPositionsInRange): Removed.
	(compare): New helper method.
	(createPosition): Rewritten for new datastructures. This now
	performs a much more efficient binary search for finding
	a position at the requested offste.
	(garbageCollect): Rewritten to collect unused marks.
	(getPositionsInRange): Adjusted for new data structures.
	(removeImpl): New helper method.
	(replace): Use new addImpl() and removeImpl() helper method for
	correctly adjusting the positions and gap.
	(search): Rewritten. Implements a more suitable binary search.
	(searchFirst): New helper method.
	(setPositionsInRange): Removed.
	(shiftEnd): Update the marks here.
	(shiftGap): Update the marks here.
	(shiftGapEndUp): Update the marks here.
	(shiftGapStartDown): Update the marks here.

2006-11-20  Marco Trudel <mtrudel@gmx.ch>

	* java/util/jar/JarFile.java (digestAlgorithms): New field used to cache
	digest algorithm implementations.
	(readSignatures): Parse the manifest once and reuse that data.
	Add support for line breaks.
	(verifyHashes): Use the parsed manifest entry.
	(readManifestEntry): Removed.

2006-11-20  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* java/beans/beancontext/BeanContextServicesSupport.java:
	Added more documentation.
	(addService(Class,BeanContextServiceProvider,boolean)):
	Synchronized over global hierarchy lock.
	(bcsPreDeserializationHook(ObjectInputStream)): Implemented.
	(bcsPreSerializationHook(ObjectOutputStream)): Implemented.
	(childJustRemovedHook(Object,BCSChild)): Implemented.
	(createBCSSServiceProvider(Class,BeanContextServiceProvider)):
	Implemented.
	(fireServiceRevoked(BeanContextServiceRevokedEvent)):
	Added revocation-only listeners.
	(getBeanContextServicesPeer()): Implemented.
	(getCurrentServiceClasses(Class)): Synchronized over global
	hierarchy lock.
	(getCurrentServiceSelectors(Class)): Synchronized over global
	hierarchy lock, and fixed FIXME.
	(getService(BeanContextChild,Object,Class,Object,
	BeanContextServiceRevokedListener)): Implemented.
	(hasService(Class)): Synchronized over global hierarchy lock.
	(releaseService(BeanContextChild,Object,Object)): Implemented.
	(revokeService(Class,BeanContextServiceProvider,boolean)): Implemented.
	* java/beans/beancontext/BeanContextSupport.java:
	(remove(Object, boolean)): Documentation correction.
	
2006-11-19  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(PageStream): New inner class.
	(PageLoader): New inner class.
	(loading): New field.
	(setPage): Implemented asynchronous loading.
	* javax/swing/text/DefaultStyledDocument.java
	(ElementBuffer.create): New helper method.
	(create): Use new ElementBuffer method instead of hack.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.flushImpl): New helper method.
	(HTMLReader.addContent): Use flushImpl().
	(HTMLReader.blockClose): Added null check.
	(HTMLReader.flush): Use flushImpl().
	* javax/swing/text/html/HTMLEditorKit.java
	(createDefaultDocument): Set load priority to 4 and token threshold
	to 100.
	* javax/swing/text/html/TableView.java
	(insertUpdate): Overridden to provide correct view factory.
	(removeUpdate): Overridden to provide correct view factory.
	(changedUpdate): Overridden to provide correct view factory.

2006-11-19  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/BoxView.java
	(clipRect): New field.
	(tmpRect): New field.
	(layout): Reorganized code. Now uses layoutAxis() helper method.
	(layoutAxis): New helper method.
	(paint): Optimized by using cached Rectangle objects and
	a binary search for child views inside the clip.
	* javax/swing/text/CompositeView.java
	(insideAllocation): Made private and initialized in constructor.
	(getInsideAllocation): Removed initialization block for
	insideAllocation field. Avoid unnecessary allocations.
	* javax/swing/text/GlyphView.java
	(DefaultGlyphPainter.paint): Only paint the actual glyphs here
	The remaining stuff (background, underline and striking) is
	done in the GlpyhView itself. Avoid unnecessary allocations.
	(cached): A cached Segment instance.
	(getText): Return cached segment.
	(paint): Paint underline, strike and background here. Avoid
	unecessary allocs.

2006-11-19  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/StyleSheet.java
	(getFontSize): Removed debug output.
	(ListPainter.tmpRect): New field.
	(ListPainter.paint): Align bullet vertically centered to
	the first line of the paragraph.

2006-11-17  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/css/CSSParser.java
	(parseDeclaration): Trim string before reporting.
	* gnu/javax/swing/text/html/css/FontSize.java
	(size): New field.
	(isRelative): New field.
	(sizeIndex): New field.
	(FontSize): Initialize new fields.
	(getValue): Changed to call getValue(int).
	(getValue(int)): New method. Implements relative font sizes.
	(isRelative): New method.
	(mapAbsolute): Store index.
	(mapEM): New helper method.
	(mapLarger): New helper method.
	(mapPercent): New helper method.
	(mapRelative): New helper method.
	(mapSmaller): New helper method.
	(mapValue): New helper method.
	* javax/swing/text/html/CSS.java
	(parseBackgroundShorthand): Create CSSColor directly.
	* javax/swing/text/html/StyleSheet.java
	(addRule): Invalidate resolved styles.
	(getFont): Call new getFontSize() method to resolve relative
	font sizes.
	(getFontSize): New helper method. Resolves relative font sizes.
	(translateHTMLToCSS): Create CSS objects directly.

2006-11-13  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/util/regex/RETokenNamedProperty.java:
	(getHandler(String)): Add support for 'all'.

2006-11-18  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/javax/management/Server.java:
	Initial implementation of a GNU management server.
	* javax/management/MBeanPermission.java,
	* javax/management/MBeanRegistration.java,
	* javax/management/MBeanTrustPermission.java:
	Implemented.
	
2006-11-17  Mark Wielaard  <mark@klomp.org>

	* docs/www.gnu.org/newsitems.txt: Add Sun GPL news announcement.

2006-11-17  Gary Benson  <gbenson@redhat.com>

	* java/net/DatagramSocket.java (getLocalAddress, connect,
	receive): Perform security check on address not hostname.

2006-11-16  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/parser/support/Parser.java
	(_handleText): Fixed condition for consuming whitespace.
	Removed validator check, this is superfluous now.

2006-11-16  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/css/CSSParser.java
	(parseRuleset): Support 'combined' selectors.
	(main): Adapt callback for combined selectors support.
	* gnu/javax/swing/text/html/css/CSSParserCallback.java
	(startStatement): Take selector array as argument, to
	support combined selectors.
	* javax/swing/text/html/BlockView.java
	(calculateMinorAxisRequirements): Fetch and apply alignment.
	* javax/swing/text/html/StyleSheet.java
	(CSSStyle): Inverted the constants for correct precedence.
	(CSSStyleSheetParserCallback.styles): New field. Stores the current
	styles.
	(CSSStyleSheetParserCallback.style): Removed.
	(CSSStyleSheetParserCallback.declaration): Update multiple styles.
	(CSSStyleSheetParserCallback.end): Push multiple styles.
	(CSSStyleSheetParserCallback.start): Initialize multiple styles.

2006-11-16  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/FlowView.java
	(LogicalView.getPreferredSpan): Calculate maximum correctly.
	* javax/swing/text/GlyphView.java
	(tabExpander): New field.
	(tabX): New field.
	(breakView): Set tabX on broken view.
	(getPartialSpan): Let the painter fetch the span.
	(getTabbedSpan): Update the tab expander field. Maybe trigger
	relayout.
	(getTabExpander): Simply return the stored expander.
	* javax/swing/text/Utilities.java
	(getTabbedTextOffset): Made algoritm a little smarter and more
	efficient.
	(getTabbedTextWidth): Don't add single char widths, instead add
	chunks of characters.
	* javax/swing/text/html/ParagraphView.java
	(calculateMinorAxisRequirements): Adjust margin only when the
	CSS span is not fixed.

2006-11-16  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextSupport.java
	(getChildBeanContextMembershipListener): Implemented,
	(getChildPropertyChangeListener): Implemented,
	(getChildSerializable): Implemented,
	(getChildVetoableChangeListener): Implemented,
	(getChildVisibility): Implemented,
	(setDesignTime): Use same property name as Sun's implementation.

2006-11-16  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/DesignMode.java: Reformatted and removed a FIXME,
	* java/beans/Statement.java
	(toString): Updated to match reference implementation.

2006-11-15  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLEditorKit.java
	(InsertHTMLTextAction.actionPerformed): Also try inserting
	the alternate tag. Adjust the selection accordingly.
	(InsertHTMLTextAction.adjustSelection): New helper method.
	Adjusts the selection after an insertion.
	(insertAtBoundary): Delegate to deprecated method.
	(insertAtBoundry): Implemented missing method.
	(tryInsert): New helper method.
	(defaultActions): Implemented to fill the array with
	a couple of InsertHTMLTextActions.

2006-11-15  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/ImageView.java
	(Observer): New class. Observes image loading.
	(haveHeight): New field.
	(haveWidth): New field.
	(height): New field.
	(width): New field.
	(image): New field.
	(imageIcon): New field.
	(loading): New field.
	(observer): New field.
	(reloadImage): New field.
	(reloadProperties): New field.
	(ImageView): Initialize observer and some flags.
	(getImage): Update the image state and return the image.
	(loadImage): New helper method. Actually starts loading.
	(paint): Rewritten to paint the image directly, not via Icon.
	(reloadImage): Rewritten. Loads the image and its properties.
	(renderIcon): Removed. No more necessary.
	(setPropertiesFromAttributes): Don't nullify image here.
	Added comment about missing impl.
	(setSize): Added comment about missing impl.
	(updateSize): New helper method. Updates the size attributes.
	(updateState): New helper method. Makes sure the image
	and its properties are valid.

2006-11-15  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/parser/support/Parser.java
	(_handleEndTag_remaining): Consume whitespace after a closing
	block like tag.

2006-11-15  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.ParagraphAction.end): Call super instead of blockClose()
	directly.
	(HTMLReader.ParagraphAction.start): Call super instead of blockOpen()
	directly.
	(HTMLReader.parseStack): Removed.
	(HTMLReader.blockClose): Simply call addContent() with ' '
	instead of doing more complicated stuff. Removed parseStack
	handling.
	(HTMLReader.blockOpen): Removed parseStack handling.
	(getInsertingReader): Removed parseStack init.
	* gnu/javax/swing/text/html/parser/htmlValidator.java
	(closeTag): Return true only when the tag actually should be
	closed.
	* gnu/javax/swing/text/html/parser/support/Parser.java
	(_handleEndTag): Only actually close the tag when the validator
	allows it.

2006-11-15  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/CSS.java
	(Attribute.BORDER_SPACING): New field for the CSS border-spacing
	attribute.
	* javax/swing/text/html/StyleSheet.java
	(BoxPainter.bottomPadding): New field.
	(BoxPainter.leftPadding): New field.
	(BoxPainter.rightPadding): New field.
	(BoxPainter.topPadding): New field.
	(BoxPainter.BoxPainter): Fetch the MARGIN and PADDING* attributes
	too.
	(BoxPainter.getInset): Recognize and include the padding.
	(translateHTMLToCSS): Added mapping for CELLPADDING and CELLSPACING.
	 javax/swing/text/html/TableView.java
	(RowView.calculateMajorAxisRequirements): Adjust req's for
	cellSpacing.
	(RowView.layoutMajorAxis): Adjust multi-column span for cellSpacing.
	(cellSpacing): New field.
	(columnRequirements): Made package private to avoid accessor method.
	(calculateMinorAxisRequirements): Include cellSpacing.
	(calculateMajorAxisRequirements): Overridden to include cellSpacing.
	(layoutMajorAxis): Likewise.
	(layoutColumns): Respect cellSpacing.
	(setParent): Overridden to fetch the CSS attributes when view gets
	connected.
	(setPropertiesFromAttributes): New method. Fetches the cell
	spacing from the CSS attributes.

2006-11-15  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/parser/support/Parser.java
	(_handleText): Consume whitespace directly before a closing tag.
	(restOfTag): Consume whitespace directly after opening.
	* gnu/javax/swing/text/html/parser/support/textPreProcessor.java
	(preprocess): Don't perform array boundary checking by
	catch AIOOBE, instead check the boundary in loop condition.
	* gnu/javax/swing/text/html/parser/support/low/Constants.java
	(TAG_CLOSE): New constants. Describes the token pattern for
	a closing tag.

2006-11-14  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/ImageView.java
	(getPreferredSpan): Use CSS length values.
	* javax/swing/text/html/TableView.java
	(CellView.calculateMajorAxisRequirements): Overridden to
	set the maximum reqs to maximum.
	(RowView.getMaximumSize): For the X_AXIS, set the maximum
	span to maximum.
	(RowView.getMinimumSpan): Overridden. For the X_AXIS, return
	the total column reqs.
	(RowView.getPreferredSpan): Overridden. For the X_AXIS, return
	the total column reqs.
	* gnu/javax/swing/text/html/css/CSSColor.java
	(convertValue): Catch NumberFormatExceptions for more robustness.
	* gnu/javax/swing/text/html/css/FontSize.java
	(mapPixels): Actually map px values. Catch NFE for more robustness.

2006-11-14  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/font/autofit/AxisHints.java,
	* gnu/java/awt/font/autofit/Constants.java,
	* gnu/java/awt/font/autofit/GlyphHints.java,
	* nu/java/awt/font/autofit/Latin.java,
	* nu/java/awt/font/autofit/LatinAxis.java,
	* gnu/java/awt/font/autofit/LatinMetrics.java,
	* gnu/java/awt/font/autofit/Scaler.java,
	* gnu/java/awt/font/autofit/Script.java,
	* gnu/java/awt/font/autofit/ScriptMetrics.java,
	* gnu/java/awt/font/autofit/Segment.java,
	* gnu/java/awt/font/autofit/Width.java:
	New classes. This is some skeleton stuff for the FreeType-alike
	auto-gridfitter.
	* gnu/java/awt/font/opentype/CharGlyphMap.java: Made class public.
	* gnu/java/awt/font/opentype/OpenTypeFont.java
	(unitsPerEm): Made field public.
	(getRawGlyphOutline): New method. Fetches the raw outline.
	* gnu/java/awt/font/opentype/Scaler.java
	(getRawGlyphOutline): New method. Fetches the raw outline.
	* gnu/java/awt/font/opentype/truetype/GlyphLoader.java
	(loadGlyph): New method. This is used to load raw outlines.
	* gnu/java/awt/font/opentype/truetype/TrueTypeScaler.java
	(getRawOutline): New method. Fetches the raw outline.
	* gnu/java/awt/font/opentype/truetype/Zone.java:
	Made class public.

2006-11-14  Roman Kennke  <kennke@aicas.com>

	* javax/swing/RepaintManager.java
	(RepaintManager): Fetch the default state for the double buffering
	from a system property gnu.swing.doublebuffering.

2006-11-14  Roman Kennke  <kennke@aicas.com>

	* javax/swing/plaf/basic/BasicLabelUI.java
	(cachedInsets): New field.
	(getFontMetrics): New helper method. Fetches the font metrics
	from the component or the toolkit.
	(getPreferredSize): Use getFontMetrics() helper method for
	fetching the font metrics.
	(paint): Use getFontMetrics() helper method for
	fetching the font metrics. Only paint if icon or text
	are != null. Use cached insets.
	(paintDisabledText): Don't store/restore color object. The
	JComponent painting mechanism takes care of this by calling
	create().
	(paintEnabledText): Don't store/restore color object. The
	JComponent painting mechanism takes care of this by calling
	create().

2006-11-14  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/GLightweightPeer.java
	(handleEvent): Try to do something reasonable and trigger painting
	for the lightweight component.
	(getFontMetrics): Fetch and return a font metrics object from
	the Toolkit.

2006-11-13  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/java/util/regex/RETokenNamedProperty.java:
	(getHandler(String)): Add support for 'all'.
	
2006-11-13  Andreas Tobler  <a.tobler@schweiz.org>

	* AUTHORS: Add myself.

2006-11-13  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* AUTHORS: Add Tania Bento, Thomas Fitzsimmons, Francis Kung and
	Dalibor Topic.  Re-order 'K' section.  Remove trailing space from
	Roman Kennke's entry.

2006-11-13  Roman Kennke  <kennke@aicas.com>

	* java/awt/image/IndexColorModel.java
	(createCompatibleSampleModel): Implemented missing method.

2006-11-11  Andreas Tobler  <a.tobler@schweiz.org>

	* gnu/java/awt/peer/gtk/GtkImageConsumer.java (setPixels): Handle data
	from big endian systems correctly.

2006-11-11  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/css/CSSColor.java
	(isValidColor): New helper method. Checks strings if they
	form a valid color value.
	* gnu/javax/swing/text/html/css/Length.java
	(Length): Catch number format exceptions.
	* javax/swing/text/html/CSS.java
	(addInternal): New method. Checks for shorthand CSS attributes
	and parses them.
	(parseBackgroundShorthand): New method. Parses the background
	shorthand attribute.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.LinkAction): Made class a subclass of HiddenAction.
	(HTMLReader.LinkAction.start): Implemented to load the linked
	stylesheet.
	(HTMLReader.LinkAction.end): Removed. This is not needed.
	* javax/swing/text/html/StyleSheet.java
	(CSSStyleSheetParserCallback.declaration): Push declaration
	through CSS.addInternal() to parse shorthand attributes.
	(addCSSAttribute): Push declaration through CSS.addInternal()
	to parse shorthand attributes.
	(importStyleSheet): Implemented. This adds a stylesheet from
	an URL.
	* javax/swing/text/html/TableView.java
	(calculateColumnRequirements): Increase column index for
	non CellView children to avoid endless loop.
	* javax/swing/text/CompositeView.java
	(setParent): Comparen with numChildren not with real arraylength.

2006-11-11  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextSupport.java
	(getChildBeanContextChild): Implemented.

2006-11-10  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/View.java
	(updateLayout): Only repaint when needed.

2006-11-10  David Gilbert  <david.gilbert@object-refinery.com>

	* java/util/Collections.java
	(sort(List)): Minor API doc addition,
	(sort(List, Comparator)): Likewise.

2006-11-10  David Fu  <fchoong@netbeans.jp>

	* javax/swing/text/html/HTMLWriter.java
	(traverse): Removed Classpath specific handling of implied
	tags.
	(traverseHtmlFragment): Removed Classpath specific handling of
	implied	tags.

2006-11-10  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/ParagraphView.java
	(Row.getMaximumSize): Removed. This method is not necessary.
	* javax/swing/text/html/TableView.java
	(CellView): Moved attribute init to setPropertiesFromAttributes().
	(setPropertiesFromAttributes): Fetch attributes here.
	(RowView.RowView): Documented.
	(RowView.getMaximumSpan): Overridden to restrict the max span
	in the Y direction.
	(RowView.layoutMajorAxis): Correctly layout the spans.
	(columnWidths): New field. Stores the width attributes of
	the columns.
	(calculateColumnRequirements): Added support for relative
	 (== percent) width attributes.
	(calculateMajorAxisRequirements): Removed.
	(calculateMinorAxisRequirements): Removed unnecessary code.
	(getMaximumSpan): Overridden to restrict the table's width.
	(layoutColumns): Documented. Implement more clever table layout,
	i.e. for relative columns etc.
	(layoutMinorAxis): Don't mark rows invalid.
	(updateGrid): Added docs. Initialize column widths.

2006-11-09  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/headless/HeadlessGraphicsEnvironment,
	* gnu/java/awt/peer/headless/HeadlessToolkit: New classes.
	Implement basic headless toolkit.
	* java/awt/Toolkit.java
	(getDefaultToolkit): Check headless property and create
	headless toolkit when true.

2006-11-09  Ingo Proetel  <proetel@aicas.com>
2006-11-09  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/peer/swing/SwingButtonPeer.java
	(SwingButton.button): New field.
	(SwingButton.SwingButton): Added constructor.
	(SwingButton.isShowing): Access button field instead of
	the surrounding class.
	(SwingButton.getParent): Access button field instead of
	the surrounding class.
	(SwingButtonPeer): Call new SwingButton constructor.
	* gnu/java/awt/peer/swing/SwingComponent.java:
	Several documentation updates.
	* gnu/java/awt/peer/swing/SwingComponentPeer.java
	(currentPaintEvents): New field.
	(peerFont): New field.
	(SwingComponentPeer): Initialize currentPaintEvents fields.
	(coalescePaintEvents): Implemented.
	(dispose): Unregister peer from heavyweight list of its container.
	(getGraphics): Fetch graphics from parent component.
	(handleEvent): Discard paint event if its coalesced.
	(init): Register component with its container for proper painting.
	(paint): Call peerPaint().
	(peerPaint): Added argument that indicates if we should update.
	Call paint or update on the actual AWT component.
	(peerPaintComponent): New method. Paints the peer (Swing) component.
	(setFont): Set peerFont field.
	* gnu/java/awt/peer/swing/SwingContainerPeer.java
	(backbuffer): New field.
	(focusOwner): New field.
	(heavyweightDescendents): New field.
	(SwingContainerPeer): Take Container as argument. Don't call init
	yet.
	(addHeavyweightDescendent): New method.
	(getFocusOwner): New helper method.
	(getInsets): Delegate to insets().
	(handleKeyEvent): Dispatch event to focus owner.
	(handleMouseEvent): Dispatch to child component.
	(isDoubleBuffering): New helper method.
	(peerPaint): Overridden to implement container painting with
	double buffering.
	(peerPaintChildren): New method. Paints the descendents of this
	container.
	(removeHeavyweightDescendent): New helper method.	
	* gnu/java/awt/peer/swing/SwingFramePeer.java
	(peerPaint): Removed.
	(peerPaintComponent): Overridden to paint the menu bar.
	* gnu/java/awt/peer/swing/SwingLabelPeer.java
	(SwingLabel.label): New field.
	(SwingLabel.SwingLabel): Added constructor with Label argument.
	(SwingLabel.getGraphics): Implemented to fetch the graphics from
	the actual AWT component.
	(SwingLabel.getParent): Implemented to fetch the parent from
	the AWT component.
	(SwingLabel.isShowing): Access the label field.
	(SwingLabelPeer): Set alignment from label.
	* gnu/java/awt/peer/swing/SwingListPeer.java: New class.
	* gnu/java/awt/peer/swing/SwingMenuBarPeer.java: Documentation
	fixlet.
	* gnu/java/awt/peer/swing/SwingPanelPeer.java:
	Don't be a lighweight peer.
	(SwingPanelPeer): Call init.
	* gnu/java/awt/peer/swing/SwingTextAreaPeer.java: New class.
	* gnu/java/awt/peer/swing/SwingTextFieldPeer.java
	(SwingTextField.textField): New field.
	(SwingTextField.SwingTextField): New constructor.
	(SwingTextField.isShowing): Access field not enclosing class.
	(SwingTextField.getGraphics): New method.
	(SwingTextField.getParent): New method.
	(SwingTextFieldPeer): Call new constructor.
	(select): Renamed arguments.
	* gnu/java/awt/peer/swing/SwingWindowPeer.java
	(SwingWindowPeer): Call init.

2006-11-09  Tania Bento  <tbento@redhat.com>

	* javax/swing/JLabel.java
	(JLabel(Icon)): Changed documentation; Changed text to null.
	(JLabel(Icon,int)): Likewise.
	(JLabel(text)): Changed documenation.
	(JLabel(text,int)): Likewise.
	(JLabel(text,Icon,int)): Changed documentation; Throw 
	IllegalArgumentException if int is not one of LEFT, RIGHT,
	CENTER, LEADING or TRAILING.

2006-11-09  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextSupport.java
	(BeanContextSupport): Use correct dtime default,
	(BeanContextSupport(BeanContext)): Likewise,
	(BeanContextSupport(BeanContext, Locale)): Likewise, plus renamed
	locale argument,
	(BeanContextSupport(BeanContext, Locale, boolean)): Likewise,
	(BeanContextSupport(BeanContext, Locale, boolean, boolean)): Likewise.

2006-11-09  David Gilbert  <david.gilbert@object-refinery.com>

	* java/beans/beancontext/BeanContextSupport.java
	(getBeanContextPeer): Implemented.

2006-11-09  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/BlockView.java
	(cssHeight): Removed.
	(cssWidth): Removed.
	(cssSpans): New field. Replaces the two fields above.
	(BlockView): Allocate cssSpans array.
	(layoutMinorAxis): Fetch and use child span, not this view's span.
	(setCSSSpan): Adjusted to use cssSpans array.
	(setPropertiesFromAttributes): Adjusted to use cssSpans array.

2006-11-09  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/InlineView.java
	(nowrap): New field.
	(getBreakWeight): Add support for nowrap.
	(setPropertiesFromAttributes): Fetch the nowrap setting.

2006-11-09  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/css/CSSParser.java
	(parseRuleset): Use new Selector class.
	(parseValue): Parse multiple anys, not only one.
	(main): Allow stylesheet be specified on the command line.
	Use new Selector class.
	* gnu/javax/swing/text/html/css/CSSParserCallback.java
	(startStatement): Use Selector class.
	* gnu/javax/swing/text/html/css/CSSScanner.java
	(readName): Actually read a character in the loop to avoid
	endless loop.
	* gnu/javax/swing/text/html/css/Length.java
	(getValue): Only multiply when we have a percentage value.
	* gnu/javax/swing/text/html/css/Selector.java:
	New class. Provides handling of CSS selectors.
	* javax/swing/text/html/StyleSheet.java
	(CSSStyle.PREC_AUTHOR_IMPORTANT): New constant field.
	(CSSStyle.PREC_AUTHOR_NORMAL): New constant field.
	(CSSStyle.PREC_NORM): New constant field.
	(CSSStyle.PREC_UA): New constant field.
	(CSSStyle.PREC_USER_IMPORTANT): New constant field.
	(CSSStyle.precedence): New field.
	(CSSStyle.priority): Removed.
	(CSSStyle.selector): New field.
	(CSSStyle.CSSStyle(int,Selector)): Initialize with Selector
	and precendence.
	(CSSStyle.compareTo): Adjusted to use the precedence and
	specificity of the selector.
	(CSSStyleSheetParserCallback.precedence): New field.
	(CSSStyleSheetParserCallback.selector): Removed.
	(CSSStyleSheetParserCallback.style): New field.
	(CSSStyleSheetParserCallback.CSSStyleSheetParserCallback):
	Initialize with precedence.
	(CSSStyleSheetParserCallback.declaration): Don't look up
	existing rule, simply create new one.
	(CSSStyleSheetParserCallback.endStatement): Append style
	to stylesheet.
	(CSSStyleSheetParserCallback.startStatement): Use new Selector
	class.
	(css): Changed to be ArrayList.
	(addRule): Create parser with author-normal precendence.
	(getRule): Fixed implementation.
	(loadRules): Create parser with UA precendence.
	(resolveStyle): Use Selector class for resolving and matching
	stylesheet rules.
	(translateHTMLToCSS): Added mappings for a couple of HTML
	attributes.

2006-11-09  David Gilbert  <david.gilbert@object-refinery.com>

	Fixes bug #29770
	* java/beans/SimpleBeanInfo.java
	(loadImage): Check for nulls.

2006-11-09  Robert Schuster  <robertschuster@fsfe.org>

	* native/jni/java-nio/gnu_java_nio_VMChannel.c:
	(getpeername): Added 16 byte offset to memcpy operation.

2006-11-09  Robert Schuster  <robertschuster@fsfe.org>

	* native/jni/java-nio/gnu_java_nio_VMChannel.c:
	(getsockname): Added 16 byte offset to memcpy operation.

2006-11-08  Mark Wielaard  <mark@klomp.org>

	Fixes bug #29754
	* java/io/OutputStreamWriter.java
	(OutputStreamWriter(OutputStream,Charset)): Set encodingName.
	(OutputStreamWriter(OutputStream,CharsetEncoder)): Likewise.

2006-11-08  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLEditorKit.java
	(getParser): Use plain HTML_401F DTD.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.print): Removed method and all calls to it.
	(HTMLReader.printBuffer): Removed method and all calls to it.
	(HTMLReader.inImpliedParagraph): New field.
	(HTMLReader.inParagraph): New field.
	(HTMLReader.addContent): Create implied p-tag if necessary.
	(HTMLReader.addSpecialElement): Create implied p-tag if necessary.
	(HTMLReader.blockClose): Close implied p-tag if necessary.
	(HTMLReader.blockOpen): Close implied p-tag if necessary.
	* gnu/javax/swing/text/html/parser/HTML_401Swing.java: Removed.

2006-11-08  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Removed mapping for TD tag. This
	is done in TableView.
	* javax/swing/text/html/TableView.java:
	Implemented from scratch.

2006-11-07  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/parser/support/Parser.java
	(_handleText): Check if text content is actually allowed before
	passing empty text fragments on to the parser callbacks.

2006-11-07  Mark Wielaard  <mark@klomp.org>

	* gnu/java/net/protocol/jar/Handler.java (parseURL): Flatten jar
	path.
	(flat): New method.

2006-11-07  Tania Bento  <tbento@redhat.com>

	* java/awt/FlowLayout.java
	(getSize): If parent does not have a component, then a 
	different formula is used to calcuate the width.

2006-11-07  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Include ListView.
	* javax/swing/text/html/ListView.java
	(paint): Removed comment.
	* javax/swing/text/html/StyleSheet.java
	(CSSStyle.priority): New field.
	(CSSStyle.CSSStyle(int)): New constructor with priority.
	(CSSStyle.compareTo): New method. Used for sorting the styles.
	(CSSStyleSheetParserCallback.declaration): Store the style
	with the complete selector.
	(ListPainter.attributes): Renamed as field.
	(ListPainter.styleSheet): New field.
	(ListPainter.type): New field.
	(ListPainter.ListPainter): Pass StyleSheet to constructor.
	(ListPainter.paint): Provide simplistic implementation.
	(getListPainter): Pass StyleSheet to constructor.
	(resolveStyle): Fixed CSS style resolving.

2006-11-07  Roman Kennke  <kennke@aicas.com>

	* gnu/javax/swing/text/html/css/BorderWidth.java:
	New class. Handles CSS border width values.
	* gnu/javax/swing/text/html/css/Length.java
	(floatValue): Made protected so that BorderWidth can access it.
	* javax/swing/text/html/CSS.java
	(Attribute.BORDER_BOTTOM_COLOR): New static field.
	(Attribute.BORDER_BOTTOM_STYLE): New static field.
	(Attribute.BORDER_LEFT_COLOR): New static field.
	(Attribute.BORDER_LEFT_STYLE): New static field.
	(Attribute.BORDER_RIGHT_COLOR): New static field.
	(Attribute.BORDER_RIGHT_STYLE): New static field.
	(Attribute.BORDER_TOP_COLOR): New static field.
	(Attribute.BORDER_TOP_STYLE): New static field.
	(getValue): Added some mappings for the border color and
	border width values.
	* javax/swing/text/html/CSSBorder.java: New class. Implements
	CSS borders.
	* javax/swing/text/html/StyleSheet.java
	(BoxPainter.background): New field.
	(BoxPainter.border): New field.
	(BoxPainter.bottomInset): Documented.
	(BoxPainter.leftInset): Documented.
	(BoxPainter.rightInset): Documented.
	(BoxPainter.topInset): Documented.
	(BoxPainter.BoxPainter): Added support for borders and background.
	(BoxPainter.getInset): Add border insets.
	(BoxPainter.paint): Implemented. Paints the background and the
	CSS border.
	(addRule): Be less picky about parse and IO exceptions.
	(getBoxPainter): Adjust to new BoxPainter constructor.

2006-11-07  Andreas  <a.tobler@schweiz.org>

	* examples/Makefile.am: Add rule to install the *.html files we use
	in the Swing Demo.

2006-11-06  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/ComponentGraphics.java
	(fillRect): Handle custom composites.
	(drawRenderedImage): Handle custom composites.
	(drawImage): Handle custom composites.
	(createBuffer): New method.
	(drawLine): Handle custom composites.
	(drawComposite): New method.
	(fill): Handle custom composites.
	(getNativeCM): New method.
	(drawGlyphVector): Handle custom composites.
	(drawRect): Handle custom composites.
	(draw): Handle custom composites.
	* gnu/java/awt/peer/gtk/VolatileImageGraphics.java
	(drawComposite): Unset composite during draw call, to prevent parent
	from handling composite again.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(getBufferCM): Added comments.
	(getNativeCM): Made abstract.
	(setComposite): Removed comments.

2006-11-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/swing/HtmlDemo.java:
	Fixed initial window size and start document.

2006-11-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.addSpecialElement): Removed comment about
	htmlAttributeSet.
	(HTMLReader.handleComment): Create SimpleAttributeSet instead
	of htmlAttributeSet.
	* javax/swing/text/html/parser/DocumentParser.java
	(gnuParser.handleStartTag): Use SimpleAttributeSet instead
	of htmlAttributeSet.
	* javax/swing/text/html/parser/ParserDelegator.java
	(gnuParser.handleStartTag): Use SimpleAttributeSet instead
	of htmlAttributeSet.
	* gnu/javax/swing/text/html/parser/GnuParserDelegator.java
	(gnuParser.handleStartTag): Use SimpleAttributeSet instead
	of htmlAttributeSet.
	* gnu/javax/swing/text/html/parser/support/Parser.java
	(getAttributes): Return a SimpleAttributeSet.
	(restOfTag): Don't set resolving parent here.

2006-11-06  Tania Bento  <tbento@redhat.com>

	* java/awt/TextComponent.java
	(setSelectionStart): Added check.

2006-11-06  Tania Bento  <tbento@redhat.com>

	* java/awt/TextField.java
	(minimumSize(int)): Check if minimum size has been previously
	set and changed values of Dimension returned if peer == null.
	(preferredSize(int)): Check if preferred size has been previously
	set and changed values of Dimension returned if peer == null.

2006-11-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JTree.java
	(TreeModelHandler.treeNodesRemoved): Implemented.
	(TreeModelHandler.treeStructureChanged): Implemented.
	(nodeStates): Made package private.

2006-11-06  Francis Kung  <fkung@redhat.com>

	PR 29420
	* javax/swing/JTree.java
	(clearSelectionPathStates): New private method to clean up nodeStates.
	(removeSelectionPath): Call clearSelectionPathStates().
	(removeSelectionPaths): Call clearSelectionPathStates().
	(removeSelectionRow): Call clearSelectionPathStates().
	(setSelectionPath): Call clearSelectionPathStates().
	(setSelectionPaths): Call clearSelectionPathStates().
	(setSelectionRow): Call clearSelectionPathStates().

2006-11-06  Ito Kazumitsu  <kaz@maczuka.gcd.org>

	Fixes bug #29703
	* java/util/regex/Matcher.java(reset): Reset inputCharIndexed.

2006-11-06  Roman Kennke  <kennke@aicas.com>

	* examples/gnu/classpath/examples/swing/HtmlDemo.java:
	Changed to implement a minimalistic browser.
	* examples/gnu/classpath/examples/swing/forms.html,
	* examples/gnu/classpath/examples/swing/textstyles.html,
	* examples/gnu/classpath/examples/swing/welcome.html:
	Some example content.

2006-11-06  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/ComponentView.java
	(setParent): Lock the document and repaint the hosting
	container.
	* javax/swing/text/FlowView.java
	(FlowStrategy.createView): Removed comment.
	(FlowView): Initialize span with Short.MAX_VALUE.
	(getFlowStart): Return 0 unconditionally.
	(layout): Moved code around to make it more readable.
	(loadChildren): Always set the parent.
	* javax/swing/text/GlyphView.java
	(DefaultGlyphPainter.fontMetrics): New field.
	(DefaultGlyphPainter.getAscent): Use new helper method to
	synchronize the font metrics.
	(DefaultGlyphPainter.getBoundedPosition): Use new helper method
	to synchronize the font	metrics.
	(DefaultGlyphPainter.getDescent): Use new helper method to
	synchronize the font metrics.
	(DefaultGlyphPainter.getHeight): Use new helper method to
	synchronize the font metrics.
	(DefaultGlyphPainter.getSpan): Use new helper method to
	synchronize the font metrics.
	(DefaultGlyphPainter.modelToView): Use new helper method to
	synchronize the font metrics.
	(DefaultGlyphPainter.updateFontMetrics): New helper method for
	font metrics caching.
	(DefaultGlyphPainter.viewToModel): Use new helper method to
	synchronize the font metrics. Fixed view to model mapping.
	* javax/swing/text/View.java
	(removeAll): Pass null to replace().
	(setParent): Only reparent children that have this view as parent.

2006-11-05  Mark Wielaard  <mark@klomp.org>

	* include/gnu_java_net_VMPlainDatagramSocketImpl.h: Removed.
	* include/gnu_java_nio_channels_FileChannelImpl.h: Removed.
	* native/jni/java-net/gnu_java_net_VMPlainDatagramSocketImpl.c:
	Removed.
	* native/jni/java-nio/gnu_java_nio_channels_FileChannelImpl.c:
	Removed.
	* native/jni/java-nio/Makefile.am (libjavanio_la_SOURCES):
	Remove gnu_java_nio_channels_FileChannelImpl.c.

2006-11-03  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/BlockView.java
	(attributes): New field.
	(cssHeight): New field.
	(cssWidth): New field.
	(painter): New field.
	(calculateMajorAxisRequirements): Overridden to account for
	CSS settings.
	(calculateMinorAxisRequirements): Overridden to account for
	CSS settings.
	(layoutMinorAxis): Overridden to account for CSS settings.
	(changedUpdate): Formatting fixlet.
	(constrainSize): New helper method.
	(getAlignment): Fix alignment.
	(getAttributes): Cache attributes for better performance.
	(getStyleSheet): Fetch stylesheet from document rather than creating
	a new one.
	(paint): Remove comment.
	(setCSSSpan): New helper method.
	(setPropertiesFromAttributes): Implemented to fetch the
	recognized properties.
	* javax/swing/text/html/CSS.java
	(getValue): Added mapping for width and height attributes.
	* javax/swing/text/html/InlineView.java
	(longestWord): New field.
	(getLongestWord): New helper method.
	(calculateLongestWord): New helper method.
	(getMinimumSpan): Overridden to constrain the minimum span by the
	longest word.
	* javax/swing/text/html/ParagraphView.java
	(cssHeight): New field.
	(cssWidth): New field.
	(calculateMinorAxisRequirements): Overridden to account for
	CSS settings.
	(setCSSSpan): New helper method.
	(setPropertiesFromAttributes): Fetch CSS width and height. Added
	null check.
	* gnu/javax/swing/text/html/css/Length.java
	(percentage): New field.
	(Length): Determine percentage values.
	(getValue(float)): New method for handling percentage values.
	(isPercentage): New method.

2006-11-03  Tania Bento  <tbento@redhat.com>

	* java/awt/TextArea.java
	(getMinimumSize): Changed documentation.
	(getPreferredSize): Changed documentation.
	(getMinimumSize(int,int)): Changed documenation.
	(getPreferredSize(int,int)): Changed documenation.
	(minimumSize): Changed documentation.
	(preferredSize): Changed documenation.
	(minimumSize(int,int)): Changed documentation.  Checked if 
	minimum size had been previously set and changed values of
	Dimension returned if peer == null.
	(preferredSize(int, int)): Checked if preferred size had been
	previously set and changed values of Dimension returned if
	peer = null.

2006-11-03  Tania Bento  <tbento@redhat.com>

	* java/awt/event/ComponentEvent.java
	(paramString): Changed format of string representation returned.

2006-11-03  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.FormAction.start): Added support for textarea.
	(HTMLReader.FormAction.end): Added support for textarea.
	(HTMLReader.HeadAction.end): Call super to actually close the
	block.
	(HTMLReader.inTextArea): New field.
	(HTMLReader.textAreaDocument): New field.
	(HTMLReader.handleText): Call textAreaContent when inside
	a textarea tag.
	(HTMLReader.textAreaContent): Implemented to initialize
	the text area's model.
	* javax/swing/text/html/FormView.java
	(createComponent): Added support for textarea tag.

2006-11-03  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.IsindexAction.start): Implemented.

2006-11-03  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/StyleSheet.java
	(addRule): Implemented.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.inStyleTag): New field.
	(HTMLReader.styles): New field.
	(HTMLReader.HeadAction.end): Implemented to read all stylesheets,
	if any.
	(HTMLReader.StyleAction.start): Set inStyleTag flag.
	(HTMLReader.StyleAction.end): Set inStyleTag flag.
	(HTMLReader.handleText): When inside a style tag, add
	content to the styles array.

2006-11-02  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/FormView.java
	(maxIsPreferred): New field.
	(createComponent): Initialize components correctly.
	(getMaximumSpan): Return the preferred span for components
	that need this. The maxIsPreferred flag is set accordingly
	in createComponent.
	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.FormAction.start): Implemented to set the
	correct model as attribute.
	(HTMLReader.FormAction.setModel): New helper method.
	(HTMLReader.FormAction.end): Call super to finish the element.
	Added TODO about things left to do.
	(HTMLReader.handleComment): Use SimpleAttributeSet rather
	than htmlAttributeSet.
	* javax/swing/text/html/HTMLEditorKit.java
	(HTMLFactory.create): Create BlockView for FORM tags.
	Create FormView for INPUT, TEXTAREA and SELECT tags.

2006-11-02  David Gilbert  <david.gilbert@object-refinery.com>

	* java/awt/geom/GeneralPath.java: API doc fixes.

2006-11-02  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/ImageView.java
	(getImageURL): Fetch attribute from element. Consider the
	base URL for relative image locations.

2006-11-02  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(setContentType): Strip off attributes.
	* javax/swing/text/html/HTMLEditorKit.java
	(LinkController.activateLink(int,JEditorPane,int,int): New
	method. Implements activation of a hyperlink.
	(LinkController.activateLinke(int,JEditorPane)): Delegate
	to the other activateLink() method.
	(LinkController.createHyperlinkEvent): New helper method.
	(LinkController.mouseClicked): Implemented to activate the link.
	(LinkController.mouseDragged): Added comment that this
	method does nothing.
	(LinkController.mouseMoved): Update cursor for hyperlinks.
	(mouseHandler): Renamed field to linkController.
	(HTMLEditorKit): Create a link controller.
	(clone): Give the clone a new link controller.
	(deinstall): De-install link controller as mouseMotionListener too.
	(install): Install link controller as mouseMotionListener too.

2006-11-02  Roman Kennke  <kennke@aicas.com>

	PR 29644
	* javax/swing/text/FlowView.java
	(FlowStrategy.changedUpdate): Reversed condition. This caused
	wrong layout and bad performance.
	(FlowStrategy.insertUpdate): Reversed condition. This caused
	wrong layout and bad performance.
	(FlowStrategy.removeUpdate): Reversed condition. This caused
	wrong layout and bad performance.
	(LogicalView): Changed to be a subclass of CompositeView.
	(LogicalView()): Only take one Element argument.
	(LogicalView.childAllocation): New method for implementing
	the abstract CompositeView method.
	(LogicalView.forwardUpdateToView): Overridden for correct
	reparenting.
	(getMinimumSpan): Overridden to handle line breaking correctly.
	(getPreferredSpan): Implemented to handle line breaking correctly.
	(getViewAtPoint): New method for implementing
	the abstract CompositeView method.
	(getViewIndexAtPosition): Overridden to handle leaf elements
	correctly.
	(isAfter): New method for implementing
	the abstract CompositeView method.
	(isBefore): New method for implementing
	the abstract CompositeView method.
	(loadChildren): Overridden to handle leaf elements
	correctly.
	(paint): New method for implementing
	the abstract CompositeView method.
	(calculateMinorAxisRequirements): Use preferredSpan in calculation.
	(loadChildren): Initialize flow layout by sending a synthetic
	insertUpdate() to the layout strategy.
	* javax/swing/text/GlyphView.java
	(DefaultGlyphPainter.getBoundedPosition): Fall back to Toolkit's
	font metrics if component is not available. Add initial offset
	to result.
	(breakView): Be more clever when breaking the view.
	(getBreakLocation): New helper method to determine a good
	break location.
	(getBreakWeight): Be more clever when breaking the view.
	(getTabbedSpan): Make sure we have a painter. Use view's
	start and end offset rather than the element's.
	* javax/swing/text/Utilities.java
	(drawTabbedText): Avoid useless add and sub with the y offset.

2006-11-02  Roman Kennke  <kennke@aicas.com>

	PR 29644
	* gnu/java/awt/peer/ClasspathFontPeer.java
	(getStringBounds): Removed abstract method. This is replaced
	in java.awt.Font to use a TextLayout.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java
	(GtkWindowPeer): Set a font on the window object.
	* gnu/java/awt/peer/gtk/FreetypeGlyphVector.java
	(FreetypeGlyphVector(Font,String,FontRenderContext,int)):
	Changed to take char,int,int instead of String. Filter
	control characters.
	(FreetypeGlyphVector(Font,String,FontRenderContext)):
	Create char array out of string.
	(getLogicalBounds): Don't translate bounds. They already are
	translated.
	* gnu/java/awt/peer/gtk/GdkFontMetrics.java
	(stringWidth): Filter out control characters.
	* gnu/java/awt/peer/gtk/GdkFontPeer.java
	(getStringBounds): Removed unneeded method.
	(layoutGlyphVector): Pass char array directly to FreetypeGlyphVector
	constructor.
	* gnu/java/awt/peer/qt/QtFontPeer.java
	(getStringBounds): Removed unneeded method.
	* gnu/java/awt/peer/x/XFontPeer.java
	(getStringBounds): Removed unneeded method.
	* gnu/java/awt/peer/x/XFontPeer2.java
	(getStringBounds): Removed unneeded method.
	* java/awt/Font.java
	(getStringBounds(char[],int,int,FontRenderContext)):
	Use TextLayout to determine the bounds.
	(getStringBounds(CharacterIterator,int,int,FontRenderContext)):
	Delegate to the char[] version of this method.
	(getStringBounds(String,FontRenderContext)):
	Delegate to the char[] version of this method.
	(getStringBounds(String,int,int,FontRenderContext)):
	Delegate to the String version of this method.

2006-11-01  Tania Bento  <tbento@redhat.com>

	* java/awt/ScrollPaneAdjustable.java
	(paramString): Changed format of string representation returned.
	(paramStringHelper): New private method.

2006-11-01  Tania Bento  <tbento@redhat.com>

	* java/awt/GridBagLayout.java
	(toString): Implemented method.

2006-10-30  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* native/plugin/gcjwebplugin.cc (GCJ_New): Move GLib threading
	initialization to NP_Initialize.
	(NP_Initialize): Initialize GLib threading.

2006-10-31  Tania Bento  <tbento@redhat.com>

	* javax/swing/JTextField.java
	(fireActionPerformed): When creating the new event, if
	actionCommand == null, then getText() is used.

2006-10-31  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(fillArc): Corrected arc type to Arc2D.PIE.

2006-10-31  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLDocument.java
	(HTMLReader.PreAction.end): Implemented.
	(HTMLReader.PreAction.start): Implemented.
	(HTMLReader.inPreTag): New field.
	(HTMLReader.handleTag): When inside a pre tag, call preContent().
	(HTMLReader.preContent): Implemented.

2006-10-31  Tania Bento  <tbento@redhat.com>

	* javax/swing/JTextField.java
	(fireActionPerformed): When creating the new event, 
	actionCommand should be used as the command, not
	getText().

2006-10-31  Roman Kennke  <kennke@aicas.com>

	* javax/swing/text/html/HTMLEditorKit.java
	(write): Use HTMLWriter or MinimalHTMLWriter for writing
	HTML or Styled documents.

2006-10-31  David Fu  <fchoong@netbeans.jp>

	* javax/swing/text/html/HTMLWriter.java: New class.

2006-10-30  Roman Kennke  <kennke@aicas.com>

	* java/awt/dnd/DragSourceContext.java
	(dragExit): Use constant fields instead of 0.
	(updateCurrentCursor): Completed implementation.

2006-10-30  Roman Kennke  <kennke@aicas.com>

	* java/awt/dnd/DragGestureRecognizer.java
	(resetRecognizer): Added API docs. Do not replace the events object
	but rather clear() it. Removed not implemented tag.

2006-10-30  Roman Kennke  <kennke@aicas.com>

	* java/awt/datatransfer/DataFlavor.java
	(writeExternal): Remove not implemented tag.

2006-10-30  Roman Kennke  <kennke@aicas.com>

	* java/awt/datatransfer/DataFlavor.java
	(javaFileListFlavor): Don't explicitly specify class.
	(plainTextFlavor): Don't explicitly specify class.
	(mimeType): Changed to type MimeType. Remove final.
	(representationClass): Remove final.
	(DataFlavor): Don't do anything here.
	(DataFlavor(Class,String,String)): Removed.
	(DataFlavor(Class,String)): Initialize here.
	(DataFlavor(String,String,ClassLoader)): Initialize in init().
	(DataFlavor(String,String)): Initialize in init().
	(DataFlavor(String)): Initialize in init().
	(init): New initialization method.
	(getMimeType): Delegate to MimeType.toString().
	(getParameter(String,String)): Removed. Is now done in MimeType.
	(getParameter(String)): Delegate to MimeType.
	(getPrimaryType): Delegate to MimeType.
	(getRepresentationClassFromMime): Removed.
	(getRepresentationClassFromMimeThrows): Removed.
	(getSubType): Delegate to MimeType.
	(hashCode): Take MimeType.toString() for the hashCode.
	(isFlavorRemoveObjectType): Return true only when representation
	class is remove and serializable and the mime type is remote.
	(isFlavorSerializedObjectType): Return true only when representation
	class is serializable and the mime type is serialized.
	(isMimeTypeEqual): Rewritten to delegate to MimeType.matches().
	(isMimeTypeSerializedObject): Delegate to isMimeTypeEqual().
	(readExternal): Implemented stub method.
	(writeExternal): Implemented stub method.
	* java/awt/datatransfer/MimeType.java: New helper class.

2006-10-28  Roman Kennke  <kennke@aicas.com>

	* javax/swing/TransferHandler.java
	(importData): Implemented stub method. Added API docs.

2006-10-26  Christian Elias Naur  <elias@oddlabs.com>

	* native/jni/gtk-peer/gtk_jawt.c (classpath_jawt_get_depth): New
	function.
	* native/jni/classpath/classpath_jawt.h: Likewise.
	* native/jawt/jawt.c (_Jv_GetDrawingSurfaceInfo): Added
	initializer for surface_info_x11->depth.

2006-10-26  Tania Bento  <tbento@redhat.com>
	
	* java/awt/FileDialog.java:
	(setFile): Changed if-clause condition.

2006-10-25  Francis Kung  <fkung@redhat.com>

	* include/gnu_java_nio_VMChannel.h,
	* include/java_net_VMNetworkInterface.h,
	* include/gnu_java_nio_EpollSelectorImpl.h,
	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h,
	* include/gnu_java_nio_FileChannelImpl.h,
	* include/gnu_java_nio_KqueueSelectorImpl.h,
	* include/gnu_java_nio_VMPipe.h,
	* include/gnu_java_net_VMPlainSocketImpl.h: Regenerated.

2006-10-25  Tania Bento  <tbento@redhat.com>

	* java/awt/Dialog.java: Created new private variable
	next_dialog_number.
	(Dialog(Frame, String, boolean, GraphicsConfiguration)):
	Set cursor to default cursor.
	(Dialog(Dialog, STring, boolean, GraphicsConfiguration)):
	Same.
	(generateName): New method.
	(getUniqueLong): New private method.
	* java/awt/FileDialog.java: Created new private variable
	next_file_dialog_number.
	(setFile): If file == "", set it to null.
	(generateName): New method.
	(getUniqueLong): New private method.

2006-10-25  Robert Schuster  <robertschuster@fsfe.org>

	* java/net/MulticastSocket.java:
	(setNetworkInterface): Rewritten.

2006-10-25  Robert Schuster  <robertschuster@fsfe.org>

	* native/jni/java-net/javanet.h: Added declaration for
	_javanet_create_inetaddress.
	* native/jni/java-net/javanet.c:
	(_javanet_create_inetaddress): Removed static keyword.

2006-10-25  Robert Schuster  <robertschuster@fsfe.org>

        * gnu/java/net/PlainDatagramSocketImpl.java:
        (connect): Use VMChannel instance for connect call.
        (getTimeToLive): Call VMPlainSocketImpl.getTimeToLive.
        (setTimeToLive): Call VMPlainSocketImpl.setTimeToLive.
	(setOption): Handle multicast options.
	(getOption): Handle multicast options.
        * gnu/java/net/PlainSocketImpl.java:
        (getTimeToLive): Call VMPlainSocketImpl.getTimeToLive.
        (setTimeToLive): Call VMPlainSocketImpl.setTimeToLive.
	(setOption): Filter unappropriate options.
	(getOption): Filter unappropriate options.
	(connect): Use given SocketAddress.
	(close): Reset address and port.
	(getInetAddress): 
        * include/Makefile.am: Removed all occurences of
        gnu_java_net_VMPlainDatagramSocketImpl.h.
        * include/gnu_java_net_VMPlainDatagramSocketImpl.h: Removed.
        * native/jni/java-net/Makefile.am: Removed
        gnu_java_net_VMPlainDatagramSocketImpl.c from sources.
        * native/jni/java-net/gnu_java_net_VMPlainDatagramSocketImpl.c:
        Removed.
        as SocketException, declare to throw SocketException.
        * native/jni/java-nio/gnu_java_nio_VMChannel.c: Added definitions
        for SocketException and ConnectException.
        (Java_gnu_java_nio_VMChannel_connect): Throw SocketException instead
        of IOException.
        (Java_gnu_java_nio_VMChannel_connect6): Throw SocketException instead
        of IOException.
	(Java_gnu_java_nio_VMChannel_accept): Rewritten.
	(JCL_thread_interrupted): New function.
	(initIDs): Added initialisation for isThreadInterrupted method id.
        * native/jni/java-net/gnu_java_net_VMPlainSocketImpl.c: Added
        CPNET_IP_TTL to java_sockopt enum.
        (Java_gnu_java_net_VMPlainSocketImpl_setOption): Handle CPNET_IP_TTL
        case, handle SO_LINGER case properly.
        (Java_gnu_java_net_VMPlainSocketImpl_getOption): Handle CPNET_IP_TTL
        case, handle SO_LINGER case properly.
	(Java_gnu_java_net_VMPlainSocketImpl_getMulticastInterface): New
	function.
	(Java_gnu_java_net_VMPlainSocketImpl_setMulticastInterface): New
	function.
	(Java_gnu_java_net_VMPlainSocketImpl_setMulticastInterface6): New
	function.
	(Java_gnu_java_net_VMPlainSocketImpl_leave6): Fixed constant to be
	IPV6_LEAVE_GROUP.
        * vm/reference/gnu/java/net/VMPlainDatagramSocketImpl.java: Removed.
        * vm/reference/gnu/java/nio/VMChannel.java:
        (connect(int, byte[], int, int)): Declare to throw SocketException.
        (connect6): Declare to throw SocketException.
        (connect(InetSocketAddress, int)): Catch IOException and rethrow
	(isThreadInterrupted): New method.
        * vm/reference/gnu/java/net/VMPlainSocketImpl.java: Added CP_IP_TTL
        field.
        (setTimeToLive): New method.
        (getTimeToLive): New method.
	(setMulticastInterface(int, InetAddress)): New method.
	(setMulticastInterface(int, int, Inet4Address): New method.
	(setMulticastInterface6(int, int, Inet6Address): New method.
	(setOptions): Handle SO_LINGER case.
	(getOptions): Add missing SO_REUSEADDR case.
	* java/net/Socket.java:
	(Socket(InetAddress, int, InetAddress, int, boolean)): Close socket
	when exception was thrown out of connect().
	(setSoLinger): Replaced instantiations with valueOf calls, replaced
        Boolean.FALSE with Integer.valueOf(-1).
	* native/jni/native-lib/cpio.h: Added cpio_closeOnExec declaration.
	* native/jni/native-lib/cpio.c: Added cpio_closeOnExec implementation.
        * NEWS: Documented VM interface changes.

2006-10-25  Robert Schuster  <robertschuster@fsfe.org>

	* java/net/Inet6Address.java:
	(isMulticastAddress): Fixed check.

2006-10-25  Robert Schuster  <robertschuster@fsfe.org>

	Fixes PR29576
	* java/net/MulticastSocket.java:
	(getNetworkInterface): Return a special NetworkInterface instance
	if the socket's multicast interface is set to any.

2006-10-25  Robert Schuster  <robertschuster@fsfe.org>

	Fixes PR29576
	* java/net/NetworkInterface.java:
	(createAnyInterface): New method.
	(equals): Added if-statement to handle case where netif.name is null.
	* vm/reference/java/net/VMNetworkInterface.java:
	(hashCode): Rewritten.
	(VMNetworkInterface): New constructor.

2006-10-24  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* tools/Makefile.am: Add ASM_JAR define to each tool's CFLAGS.
	* tools/toolwrapper.c (main): Set bootclasspath, not classpath.
	Add ASM_JAR to bootclasspath.

2006-10-24  Tania Bento  <tbento@redhat.com>

	* java/awt/Scrollbar.java:
	(setLineIncrement): Removed unnecessary if-clause and if 
	lineIncrement == 0, then it should be set to 1, not 0.
	(setPageIncrement): Removed unnecessary if-clause and if
	pageIncrement == 0, then it should be set to 1, not 0.
	(setValues): If visibleAmount <= 0, it should be set to 1, not 0.
	If maximum <= minimum, maximum should be set to mininum + 1. The
	actual value of maximum is maximum - visibleAmount, so I made 
	this change to the appropriate if-check. Remove the two unneccessary
	if-clauses.

2006-10-23  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(cairoSetFont): New method.
	(copy): Set font using setFont method.
	(setFont): Call cairoSetFont.
	(setup): Set font using setFont method.
	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h: Added method.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_CairoGraphics2D.c
	(install_font_peer): Removed.
	(cairoDrawGlyphVector): Removed call to install_font_peer.
	(cairoSetFont): New method.

2006-10-23  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/NativeEventLoopRunningEvent.java: New file.
	* gnu/java/awt/peer/gtk/GtkMainThread.java: Post
	NativeEventLoopRunningEvent after GTK main loop start and stop.
	* java/awt/EventQueue.java (isShutdown): Check nativeLoopRunning.
	(getNextEvent): Set dispatchThread to null.
	(postEventImpl): Set nativeLoopRunning.
	(pop): Interrupt event dispatch thread.
	* java/awt/Frame.java (noteFrame): Synchronize on weakFrames.

2006-10-22  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* native/jni/java-net/gnu_java_net_VMPlainSocketImpl.c (config-int.h):
	Added include.
	* native/jni/java-nio/gnu_java_nio_VMChannel.c (config-int.h):
	Likewise.

2006-10-23  Marco Trudel <mtrudel@gmx.ch>

	* gnu/javax/crypto/pad/PKCS7.java (unpad): Removed an unnecessary test.
	* javax/crypto/CipherOutputStream.java: Re-implemented.
	* gnu/javax/crypto/jce/cipher/CipherAdapter.java
	(engineUpdate(byte[], int, int)): Always keep data for unpadding in padded
	decryption mode and check if it is a complete block.
	(engineUpdate(byte[], int, int, byte[], int)): Likewise.
	(engineDoFinal(byte[], int, int)): In padded decryption mode, take
	partially processed data into account.

2006-10-21  Tom Tromey  <tromey@redhat.com>

	PR classpath/29086:
	* java/util/AbstractCollection.java (toArray): Removed cast.

2006-10-20  Tom Tromey  <tromey@redhat.com>

	* tools/gnu/classpath/tools/javah/JniIncludePrinter.java (printClass):
	Don't use mangled class name for .h file.
	* tools/gnu/classpath/tools/javah/JniStubPrinter.java (printClass):
	Don't use mangled class name for .c file.
	* tools/gnu/classpath/tools/javah/CniPrintStream.java (writeClass):
	Handle classes from the default package.

2006-10-20  Francis Kung  <fkung@redhat.com>

	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h: Added missing constants.

2006-10-19  Francis Kung  <fkung@redhat.com>

	PR 29510
	* java/awt/image/BufferedImage.java
	(constructor): Updated some properties of default image types.
	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(argb32): Updated field to match default in BufferedImage.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	PR 29419
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(copyArea): Changed size comparison to return when size == 0
	too.
	* javax/swing/JViewport.java
	(paintBackingStore): Check width and height of blitted area
	and only do blit if its > 0.
	(paintBlit): Check width and height of blitted area
	and only do blit if its > 0.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	PR 27091
	* gnu/java/awt/peer/gtk/GtkFramePeer.java
	(maximize): New native method.
	(unmaximize): New native method.
	(iconify): New native method.
	(deiconify): New native method.
	(getState): Implemented.
	(setState): Implemented.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java
	(oldState): Rename to windowState and made protected, so that
	the FramePeer can access it.
	(postWindowEvent): Handle state change events more gently and
	correctly.
	* java/awt/Frame.java
	(getState): Fetch state from getExtendedState().
	(setExtendedState): Update the peer. Check if the state change
	is actually supported.
	(getExtendedState): Update the state from the peer.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkFramePeer.c
	(maximize): New method.
	(unmaximize): New method.
	(iconify): New method.
	(deiconify): New method.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(AWT_FRAME_NORMAL): New macro.
	(AWT_FRAME_ICONIFIED): New macro.
	(AWT_FRAME_MAXIMIZED_BOTH): New macro.
	(window_window_state_cb): Rewritten to handle window state changes
	more gently (mostly on the java side of the world).
	* include/gnu_java_awt_peer_gtk_GtkFramePeer.h: Regenerated.

2006-10-18  Tania Bento  <tbento@redhat.com>

	* java/awt/CardLayout.java:
	(maximumLayoutSize): Return a new Dimension with Integer.MAX_VALUE as
	its height and width if Container passed as argument is null.
	(gotoComponent): Consider the case where the component is not visible.

2006-10-18  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* resource/gnu/classpath/tools/appletviewer/MessagesBundle.properties:
	Rename file...
	* resource/gnu/classpath/tools/appletviewer/messages.properties:
	New file.
	* resource/gnu/classpath/tools/appletviewer/MessagesBundle_de.properties:
	Remove file.
	* tools/gnu/classpath/tools/appletviewer/AppletWarning.java:
	Remove file.
	* tools/gnu/classpath/tools/appletviewer/ConsoleDialog.java:
	Likewise.
	* tools/gnu/classpath/tools/appletviewer/Messages.java: New file.
	* tools/gnu/classpath/tools/appletviewer/CommonAppletStub.java:
	Retrieve user-visible strings through Messages.getString.
	* tools/gnu/classpath/tools/appletviewer/Main.java: Likewise.
	* tools/gnu/classpath/tools/appletviewer/PluginAppletContext.java:
	Likewise.
	* tools/gnu/classpath/tools/appletviewer/PluginAppletViewer.java:
	Likewise.
	* tools/gnu/classpath/tools/appletviewer/PluginAppletWindow.java:
	Likewise.
	* tools/gnu/classpath/tools/appletviewer/StandaloneAppletContext.java:
	Likewise.
	* tools/gnu/classpath/tools/appletviewer/StandaloneAppletViewer.java:
	Likewise.
	* tools/gnu/classpath/tools/appletviewer/StandaloneAppletWindow.java:
	Likewise.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkWindowPeer.c
	(AWT_WINDOW_OPENED): Remove unnecessary macro.
	(window_show_cb): Removed unnecessary function.
	(connect_signals): Don't connect signal for show.  *
	gnu/java/awt/peer/gtk/GtkWindowPeer.java
	(hasBeenShown): Removed. This is handled in java.awt.Window.
	(postWindowEvent): Removed handling of WINDOW_OPENED. This is done
	in java.awt.Window.  * java/awt/Window.java
	(dispose): Post WINDOW_CLOSED here, not WINDOW_OPENED.

2006-10-18  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoSurfaceGraphics.java
	(drawRenderedImage):  New method.
	(drawImage): New method.
	(CairoSurfaceGraphics): Set clip.
	(createBuffer): New method.
	(getBufferCM): New method.
	(drawComposite): New method.
	(fill): New method.
	(getNativeCM): New method.
	(drawGlyphVector): New method.
	(draw): New method.
	* gnu/java/awt/peer/gtk/VolatileImageGraphics.java
	(getNativeCM): Reflect renamed field.
	* gnu/java/awt/peer/gtk/CairoSurface.java
	(cairoCM_pre): Renamed from cairoColorModel.
	(cairoColorModel): Set premultiplication to false.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	PR 28769
	* javax/swing/JScrollPane.java
	(viewportBorder): Made field private.
	(wheelScrollingEnabled): Made field private.
	(JScrollPane): Enabled wheel scrolling by default.
	* javax/swing/JTree.java
	(TreeSelectionRedirector.valueChanged): Don't repaint anything
	here.
	(getScrollableUnitIncrement): Fixed thinko.
	* javax/swing/plaf/basic/BasicScrollBarUI.java
	(static scrollByBlock): New static method to avoid code duplication
	for the BasicScrollPane wheel scrolling.
	(static scrollByUnits): New static method to avoid code duplication
	for the BasicScrollPane wheel scrolling.
	(scrollByBlock): Delegate to static helper method.
	(scrollByUnit): Delegate to static helper method.
	* javax/swing/plaf/basic/BasicScrollPaneUI.java
	(MouseWheelHandler.mouseWheelMoved): Delegate to BasicScrollBarUI
	static helper methods to avoid code duplication.
	(MouseWheelHandler.bounds): Removed.
	(MouseWheelHandler.getValue): Removed.
	(MouseWheelHandler.scroll): Removed.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	PR 29502
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java
	(updateComponent): Don't override this here.
	* java/awt/Window.java
	(addWindowListener): Ignore null listener. Set newEventsOnly flag.
	(addWindowFocusListener): Ignore null listener. Set newEventsOnly
	flag.
	(addWindowStateListener): Ignore null listener. Set newEventsOnly
	flag.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(getStream): Try to detect and set the content type of the
	connection stream.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	* javax/swing/RepaintManager.java
	(RepaintWorkerEvent): Pass full set of params to super.
	(RepaintWorker.dispatch): Overridden to allow apps to call this
	via reflection.
	(addDirtyRegion): Synchronize a little more to protect the
	dirtyComponents field and avoid NPEs.
	(invokeLater): Pass full set of params to RepaintWorkerEvent
	constructor.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JEditorPane.java
	(page): Removed field. The page is now stored in the correct
	document property.
	(getPage): Fetch page URL from document property.
	(read): Set the document for this JEditorPane. Use a Reader
	for reading in the document.
	(setPage): Call getStream() to get the stream from which we read.
	Fire property change. Store page in document property.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	* java/awt/datatransfer/DataFlavor.java
	(DataFlavor(String)): Removed check for space in mime string.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	* java/awt/Container.java
	(validateTree): Call ContainerPeer.begin|endLayout() rather than
	begin|endValidate().
	(validate): Call ContainerPeer.begin|endValidate() here.
	Added some local vars to avoid NPEs.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	* native/target/.cvsignore
	* native/target/Linux/.cvsignore
	* native/target/generic/.cvsignore:
	Added to let CVS ignore the generated Makefile and Makefile.in
	files.

2006-10-18  Roman Kennke  <kennke@aicas.com>

	PR 29448
	* java/awt/Window.java
	(eventTypeEnabled): Overridden to handle WindowEvents.
	(processEvent): Switch between processWindowEvent(),
	processWindowFocusEvent() and processWindowStateEvent() here,
	rather than simply calling processWindowEvent().
	(processWindowEvent): Only dispatch event to listener, do not
	switch to processWindowFocusEvent() or processWindowStateEvent()
	here.
	* javax/swing/JFrame.java
	(frameInit): Explicitly enable window and key events here.
	(processWindowEvent): Throw out some unnecessary code.
	* javax/swing/JWindow.java
	(windowInit): Explicitly enable key events here.
	* javax/swing/JDialog.java
	(close_action): Renamed to closeAction.
	(dialogInit): Explicitly enable window events here.
	(getDefaultCloseOperation): Renamed close_action to closeAction.
	(processWindowEvent): Throw out some unnecessary code.
	Renamed close_action to closeAction.
	(setDefaultCloseOperation): Renamed close_action to closeAction.

2006-10-17  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gnu/java/awt/peer/gtk/GtkMainThread.java: Introduce running flag
	to track native GTK event loop status.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkToolkit.c: Set and
	clear running flag when native GTK event loop starts and stops.

2006-10-17  Roman Kennke  <kennke@aicas.com>

	* javax/swing/TransferHandler.java
	(exportToClipboard): Implemented.

2006-10-17  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java (draw): Extend updated
	region to account for pixel-shifting.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java (shiftDrawCalls): Made
	proctected.

2006-10-17  Francis Kung  <fkung@redhat.com>

	PR 29450
	* gnu/java/awt/peer/gtk/FreetypeGlyphVector.java
	(getLogicalBounds): Translate individual glyphs before appending bounds.
	(getOutline): Translate individual glyphs before appending outline.

2006-10-17  Cameron McCormack  <cam@mcc.id.au>

	PR 29014
	* java/awt/font/TextLayout.java
	(bidi): New field.
	(constructor): Store bidi in field.
	(getCharacterLevel): Implemented.

2006-10-17  Roman Kennke  <kennke@aicas.com>

	* javax/swing/TransferHandler.java
	(PropertyTransferable): New inner class. Handles transfers
	from component properties.
	(createTransferable): Implemented.

2006-10-17  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(drawComposite): Ensure	composite does not extend beyond buffer
	bounds.
	* java/awt/image/Raster.java
	(createChild): Ensure child does not extend beyond parent's
	bounds.
	* java/awt/image/WritableRaster.java
	(createWritableChild): Ensure child does not extend beyond
	parent's bounds.

2006-10-17  Jeroen Frijters  <jeroen@frijters.net>

	* native/jni/classpath/jcl.c
	(JNI_OnLoad): Corrected calling convention.

2006-10-16  Roman Kennke  <kennke@aicas.com>

	* javax/swing/TransferHandler.java
	(propertyName): New field.
	(TransferHandler(String)): Store property name in field.
	(canImport): Implemented stub method.
	(exportDone): This is a no-op. Removed not-implemented mark.
	(getPropertyDataFlavor): New helper method.
	(getPropertyDescriptor): New helper method.

2006-10-16  Roman Kennke  <kennke@aicas.com>

	* javax/swing/AbstractButton.java
	(AccessibleJButton.getAfterIndex): Implemented.
	(AccessibleJButton.getAtIndex): Implemented.
	(AccessibleJButton.getBeforeIndex): Implemented.
	(AccessibleJButton.getCharacterAttribute): Completed incomplete
	method implementation.

2006-10-16  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JLabel.java
	(AccessibleJLabel.getIndexAtPoint): Implemented.
	(AccessibleJLabel.getCharacterBounds): Implemented.
	(AccessibleJLabel.getTextRectangle): New helper method.

2006-10-16  Roman Kennke  <kennke@aicas.com>

	* javax/swing/filechooser/FileSystemView.java
	(getFileSystemView): Mark as implemented.

2006-10-14  Roman Kennke  <kennke@aicas.com>

	PR 27957
	* javax/swing/JComponent.java
	(toolTipText): Removed field.
	(createToolTip): Don't set tooltip text here. This is done
	in the ToolTipManager.
	(setToolTipText): Set tooltip text as client property.
	(getToolTipText): Get tooltip text from client property.
	* javax/swing/ToolTipManager.java
	(currentComponent): Made field non-static and of type JComponent.
	(currentPoint): Made field non-static.
	(currentTip): Made field non-static.
	(popup): Made field non-static.
	(toolTipText): New field. Stores the current tooltip text.
	(checkTipUpdate): New helper method. Checks for updates of
	the tooltip text and triggers the appropriate actions.
	(getContentPaneDeepestComponent): Removed unneeded casts.
	(mouseEntered): Removed unneeded cast. Initially fetch tooltip
	text from component.
	(mouseMoved): Check for tooltip text updates.
	(showTip): Set tooltip text from current setting.

2006-10-14  Roman Kennke  <kennke@aicas.com>

	PR 27956
	* javax/swing/JSlider.java
	(setPaintLabels): Call setLabelTable() instead of setting
	the field directly. This also updates the label's size.

2006-10-13  Tom Tromey  <tromey@redhat.com>

	* tools/gnu/classpath/tools/javah/ClassWrapper.java (toString): New
	method.

2006-10-13  Tania Bento  <tbento@redhat.com>

	* java/awt/ScrollPane.java
	(setLayout): Should throw AWTError whenever called.

2006-10-13  Roman Kennke  <kennke@aicas.com>

	PR 29448
	* java/awt/Component.java
	(dispatchEventImpl): Special handle ComponentReshapeEvents to
	update the AWT's knowledge about a component's size.
	* gnu/java/awt/ComponentReshapeEvent.java: New class.
	* gnu/java/awt/peer/gtk/GtkWindowPeer.java
	(postConfigureEvent): Directly dispatch a ComponentReshapeEvent
	to update the AWT's knowledge about the component bounds.

2006-10-13  Tania Bento  <tbento@redhat.com>

	* java/awt/ScrollPaneAdjustable.java
	(setMaximum): Should throw AWTError whenever called.
	(setMinimum): Same.
	(setVisibleAmount): Same.

2006-10-13  Tania Bento  <tbento@redhat.com>

	* java/awt/ScrollPane.java
	(addImpl): When calling super, index should be value passed, 
	not -1.
	(getIsValidString): New helper method for paramString().
	(getScrollbarDisplayString): New helper method for paramString(). 
	(paramString): Changed format of outputted string.

2006-10-13  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/tree/DefaultTreeSelectionModel.java
	(clone): Added cast to TreePath[].

2006-10-13  Roman Kennke  <kennke@aicas.com>

	PR 27780
	* javax/swing/JMenuItem.java
	(isDragging): New field. Indicates if we are inside a mouse
	drag.
	(createMenuDragMouseEvent): Removed unneeded method.
	(processMenuDragMouseEvent): Track if we are dragging.
	(processMouseEvent): Simply forward to processMenuDragMouseEvent().
	* javax/swing/plaf/basic/BasicMenuItemUI.java
	(MenuDragMouseHandler.menuDragMouseDragged): Fetch
	MenuSelectionManager from event.
	(MenuDragMouseHandler.menuDragMouseEntered): Fetch
	MenuSelectionManager from event.
	(MenuDragMouseHandler.menuDragMouseExited): Fetch
	MenuSelectionManager from event.
	(MenuDragMouseHandler.menuDragMouseReleased): Click on mouse
	release inside menu item, otherwise clear selection.
	(MenuInputHandler.mouseReleased): Avoid multiple calls to getX()
	and getY(). Call doClick() rather than the doClick() of JMenuItem.
	(doClick): Perform an immediate click.

2006-10-13  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* javax/swing/DefaultComboBoxModel.java (setSelectedItem): Simply
	return if object is not in the list.

2006-10-12  Andrew Haley  <aph@redhat.com>

	* java/lang/InheritableThreadLocal.java: Rename NULL to sentinel.
	* java/lang/ThreadLocal.java: Likewise.

2006-10-12  Roman Kennke  <kennke@aicas.com>

	PR 27956
	* javax/swing/JSlider.java
	(LabelUIResource): New inner class. A JLabel as UIResource.
	(createStandardLabels): Don't set label bounds here.
	Create LabelUIResource instances.
	(setInverted): Repaint.
	(setLabelTable): Update the label UIs. Revalidate and repaint.
	(setMajorTickSpacing): Update the label table. Repaint if
	necessary.
	(setMinorTickSpacing): Repaint if necessary.
	(setOrientation): Revalidate.
	(setPaintLabels): Revalidate and repaint.
	(setPaintTicks): Revalidate and repaint.
	(setPaintTrack): Repaint.
	(updateLabelUIs): Set the label sizes here.
	(updateUI): Also update the label UIs.
	* javax/swing/plaf/basic/BasicSliderUI.java
	(ComponentHandler.componentResized): Don't revalidate.
	(FocusHandler.focusGained): Don't set field.
	(FocusHandler.focusLost): Don't set field.
	(PropertyChangeHandler.propertyChange): Calculate geometry
	and repaint for a couple more properties.
	(TrackListener.mouseReleased): Repaint.
	(hasFocus): Removed unneeded field.
	(calculateContentRect): No need to check for content size < 0.
	(calculateFocusRect): Use insets from insetCache.
	(calculateLabelRect): Fixed calculation of label rectangle.
	It is relative to the tick rectangle, rather than the content
	rectangle.
	(calculateTickRect): Small restructuring to avoid unnecessary
	comparisons.
	(calculateTrackRect): Fixed calculation of track rectangle.
	(getMaximumSize): Fixed. Fetch preferred size and set
	the height of width to Short.MAX_VALUE.
	(getMinimumHorizontalSize): Fixed to return UIManager value.
	(getMinimumVerticalSize): Fixed to return UIManager value.
	(getPreferredHorizontalSize): Fixed to return UIManager value.
	(getPreferredVerticalSize): Fixed to return UIManager value.
	(getMinimumSize): Fixed to return the UIManager value plus
	insets added.
	(getPreferredSize): Fixed to return the UIManager value plus
	insets added.
	(getWidthOfWidestLabel): Restructured for more cleanness and
	efficiency.
	(hitClip): New helper method.
	(paintHorizontalLabel): Replaced by more efficient and clean
	implementation.
	(paintVerticalLabel): Replaced by more efficient and clean
	implementation.
	(paintLabels): Replaced by more efficient and clean
	implementation.
	(paint): Check if rectangles intersect with clip for maximum
	efficiency.
	(recalculateIfInsetsChanged): Fixed. This method should
	recalculate only when the insets changed.
	(setThumbLocation): Repaint with a reasonable clip.
	(xPositionForValue): Made more clean and efficient.
	(yPositionForValue): Made more clean and efficient.
	* javax/swing/plaf/basic/BasicLookAndFeel.java
	(initComponenDefaults):	Added Slider.horizontalSize,
	Slider.verticalSize, Slider.minimumHorizontalSize and
	Slider.minimumVerticalSize properties.
	* javax/swing/plaf/metal/MetalSliderUI.java
	(getTickLength): Add 1 for horizontal sliders and 3 for
	vertical sliders.
	(paintMajorTickForHorizSlider): Fix colors. Fix line locations.
	(paintMinorTickForHorizSlider): Fix colors. Fix line locations.
	(paintMajorTickForVertSlider): Fix colors. Fix line locations.
	(paintMinorTickForVertSlider): Fix colors. Fix line locations.

2006-10-12  Roman Kennke  <kennke@aicas.com>

	PR 28696
	* javax/swing/text/FlowView.java
	(FlowStrategy.layout): Preserve logical views from getting lost.
	(FlowStrategy.layoutRow): Fix line breaking.
	(FlowStrategy.adjustRow): Fix line breaking.
	(FlowStrategy.changedUpdate): Mark layout invalid, or repaint.
	(FlowStrategy.insertUpdate): Mark layout invalid, or repaint.
	(FlowStrategy.removeUpdate): Mark layout invalid, or repaint.
	(createView): Don't check index.
	(contains): New helper method.
	(reparent): New helper method.
	(layoutDirty): Removed unneeded field.
	(FlowView): Removed layoutDirty field init.
	(changedUpdate): Removed layoutDirty handling.
	(insertUpdate): Removed layoutDirty handling.
	(removeUpdate): Removed layoutDirty handling.
	(layout): Use isLayoutValid() rather than the layoutDirty field.
	* javax/swing/text/GlyphView.java
	(startOffset): Removed.
	(endOffset): Removed.
	(offset): New field.
	(length): New field.
	(GlyphView): Initialize new fields. Removed old fields.
	(createFragment): Create fragment with new relative offsets.
	(getEndOffset): Work with new relative offsets.
	(getStartOffset): Work with new relative offsets.
	* javax/swing/text/ParagraphView.java
	(Row.getStartOffset): Overidden to determine the minimum start
	offset from the children.
	(Row.getEndOffset): Overidden to determine the maximum end
	offset from the children.
	* javax/swing/text/html/BRView.java
	Make subclass of InlineView.
	(getBreakWeight): Fall back to super for Y_AXIS.

2006-10-12  Roman Kennke  <kennke@aicas.com>

	PR 28733
	* javax/swing/plaf/basic/BasicTabbedPaneUI.java
	(TabPaneLayout.normalizeTabRuns): Replaced algorithm with
	one that avoids faulty state that could cause division by zero
	error.

2006-10-12  Roman Kennke  <kennke@aicas.com>

	PR 28057
	* javax/swing/plaf/basic/BasicRadioButtonUI.java
	(paint): Determine correct icon. Added support for HTML label.
	Added small optimizations.
	(getPreferredSize): Only consider the buttons iconTextGap, and
	only when the text is not null.
	* javax/swing/plaf/basic/BasicLookAndFeel.java
	(initComponentDefaults): Fetch border for RadioButton from
	BasicButtons.getRadioButtonBorder().
	* javax/swing/plaf/metal/MetalRadioButtonUI.java
	(paintFocus): Paint focus rectangle one pixel smaller.

2006-10-12  Roman Kennke  <kennke@aicas.com>

	PR 29418
	* javax/swing/tree/AbstractLayoutCache.java
	(getNodeDimensions): Don't throw InternalError, but instead
	return null.
	(getRowsForPaths): Check for null here.
	(isFixedRowHeight): Returns true when rowHeight > 0.
	(setSelectionModel): Set this as the row mapper for the selection
	model.
	* javax/swing/tree/VariableHeightLayoutCache.java
	(NodeRecord.NodeRecord): Initialize bounds field.
	(getBounds): Simply return the bounds field.
	(row2Node): Changed to be an ArrayList.
	(RECT_CACHE): New field. Caches a Rectangle instance.
	(countRows): Added y parameter and return value. The method
	now takes the current y position as parameter, and returns
	the updated y position.
	(getBounds): Fixed to return the correct bounds.
	(getPathForRow): Replaced by fixed implementation.
	(getPreferredHeight): Replaced by more efficient implementation.
	This simply fetches the last node record and returns its lower
	bounds.
	(getPreferredWidth): Added null check.
	(getVisibleChildCount): Added null check.
	(getVisiblePathsFrom): Added null check.
	(setExpandedState): Also expand the ancestors of the node
	to be expanded.
	(setModel): Set dirty flag rather than updating for real.
	(setNodeDimensions): Overridden to set the dirty flag.
	(setRowHeight): Overridden to set the dirty flag.
	(update): Don't special case the root here, this is done now
	in countRows().

2006-10-12  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JComponent.java
	(paintImmediately2): Added support for components which need
	to force themselves as paint root.
	(isPaintRoot): New method. This should be overridden by components
	which need to force themselves as paint root.
	* javax/swing/JViewport.java
	(isPaintRoot): Overridden to force the viewport as paint root
	when running in backingstore mode.

2006-10-12  Roman Kennke  <kennke@aicas.com>

	* javax/swing/tree/DefaultTreeSelectionModel.java
	(PathPlaceHolder): New inner class. Wraps a path and its status
	wrt to its newness.
	(selectedPaths): New field. A supporting datastructure.
	(tmpPaths): New field. A supporting datastructure.
	(DefaultTreeSelectionModel): Initialize the list selection model,
	the leadIndex and the supporting datastructures.
	(addPropertyChangeListener): Create changeSupport object lazily.
	(addSelectionPaths): Mostly rewritten to handle the different
	selection modes correctly.
	(addSelectionPath): Delegate to addSelectionPaths().
	(arePathsContiguous): Replaced with more efficient implementation
	using BitSet
	(canPathBeAdded): Removed unneeded method.
	(canPathsBeAdded): Replaced with more efficient implementation.
	(clearSelection): Create correct event. Clear the fields correctly,
	including the supporting datastructures.
	(clone): Also clone the supporting datastructures and nullify
	changeSupport field.
	(getMaxSelectionRow): Delegate to list selection model.
	(getMinSelectionRow): Delegate to list selection model.
	(getPath): Removed unneeded method.
	(getPropertyChangeListeners): Handle null changeSupport field
	correctly.
	(getRow): Handle null rowMapper field correctly.
	(getSelectionRows): Handle invisible rows correctly.
	(insureRowContinuity): Replaced by more efficient and correct
	implementation.
	(isRowSelected): Delegate to list selection model.
	(notifyPathChange): Made more efficient by use of PathPlaceHolder
	class.
	(removePropertyChangeListener): Handle null changeSupport field.
	(removeSelectionPaths): Mostly rewritten to handle the different
	selection modes correctly.
	(removeSelectionPath): Delegate to removeSelectionPaths().
	(resetRowSelection): Handle list selection model.
	(selectOne): Removed unneeded field.
	(setRowMapper): Reset the row selection.
	(setSelectionMode): Check for invalid mode and set to
	DISCONTINUOUS_TREE_SELECTION in this case. Fire property change.
	(setSelectionPaths): Mostly rewritten to handle the different
	selection modes correctly.
	(setSelectionPath): Delegate to setSelectionPaths().
	(updateLeadIndex): Made more efficient.

2006-10-11  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(buffer, locked): New fields.
	(constructors): Initialize new variables.
	(createBuffer): New method.
	(draw): Implement custom composites.
	(drawComposite): New method.
	(drawGlyphVector): Implement custom composites.
	(drawImage): Implement custom composites.
	(drawRenderedImage): Implement custom composites.
	(fill): Implement custom composites.
	(getBufferCM): New method.
	(getNativeCM): New method.
	(updateBufferedImage): Fix premultiplication.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(copy): Copy composite.
	(drawImage): Set background properly.
	(getBufferCM): New method.
	(setComposite): Reset alpha composite when using custom composite.
	* gnu/java/awt/peer/gtk/CairoSurface.java
	(cairoColorModel): New field.
	(nativeColorModel): Renamed.
	(constructor): Use renamed createCairoSampleModel method.
	(createCairoSampleModel): New method.
	(createNativeSampleModel): Renamed.
	(getBufferedImage): Use renamed cairoColorModel field.
	* gnu/java/awt/peer/gtk/GtkVolatileImage.java
	(gdkColorModel): New field.
	(createGdkSampleModel): New method.
	(getPixels): Added comments.
	(getSnapshot): Use GDK colour and sample models.
	* gnu/java/awt/peer/gtk/VolatileImageGraphics.java
	(createBuffer): Use GDK colour and sample models.
	(getNativeCM): Added comments.
	* java/awt/image/BufferedImage.java
	(constructor): Set premultiplied flag properly.
	
2006-10-11  Edwin Steiner  <edwin.steiner@gmx.net>

	* native/jni/java-nio/gnu_java_nio_VMChannel.c
	(Java_gnu_java_nio_VMChannel_lock): Special case Long.MAX_VALUE.

2006-10-10  Francis Kung  <fkung@redhat.com>

	PR 29372
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(createPath): Added isDraw parameter.
	(draw): Updated createPath call.
	(fill): Updated createPath call.

2006-10-10  Tom Tromey  <tromey@redhat.com>

	PR classpath/29362:
	* gnu/xml/transform/TransformerImpl.java (transform): Only strip if
	there is a stylesheet.

2006-10-10  Roman Kennke  <kennke@aicas.com>

	* java/awt/Toolkit.java
	(getDefaultTookit): Make method synchronized to avoid
	accidentally creating more than one toolkits from different
	threads.

2006-10-10  Roman Kennke  <kennke@aicas.com>

	* java/awt/LightweightDispatcher.java
	(handleMouseEvent): Redispatch MOUSE_WHEEL events too.
	(redispatch): Transfer the button to the redispatched event.

2006-10-10  Francis Kung  <fkung@redhat.com>

	* java/awt/image/ColorModel.java (coerceData): Implemented.

2006-10-09  Christian Elias Naur  <elias@oddlabs.com>

	* vm/reference/java/lang/VMClassLoader.java:
	(defineClassWithTransformers): Use proper class name format.

2006-10-09  Gary Benson  <gbenson@redhat.com>

	* java/net/ServerSocket.java
	(implAccept): Add security check.
	(accept): Close socket if security check fails.
	(setSocketFactory): Add security check and already-set check.

2006-10-09  Roman Kennke  <kennke@aicas.com>

	PR 29325
	* javax/swing/JSplitPane.java
	(dividerLocation): New field. Stores the divider location.
	(JSplitPane): Initialize dividerLocation with -1.
	(addImpl): Removed unneeded local variables.
	(getDividerLocation): Manage dividerLocation in the JSplitPane
	class, not in the UI.
	(setDividerLocation): Manage dividerLocation in the JSplitPane
	class, not in the UI. Only call the UI method for notification.
	* javax/swing/plaf/basic/BasicSplitPaneUI.java
	(BasicHorizontalLayoutManager.layoutContainer): Fetch divider
	location from the JSplitPane. Honour the minimumSize, but only
	if the divider location hasn't been set explicitly.
	(BasicHorizontalLayoutManager.minimumLayoutSize): Removed unneeded
	statement.
	(BasicHorizontalLayoutManager.preferredLayoutSize): Removed unneeded
	statement.
	(BasicHorizontalLayoutManager.resetToPreferredSizes): Don't touch
	the divider location.
	(dividerLocationSet): New field.
	(dividerLocation): Removed field.
	(createActionMap): Fetch and set divider location on the JSplitPane.
	(getDividerLocation): Return the actual real divider location.
	(getMaximumSize): Removed unneeded cast.
	(getPreferredSize): Removed unneeded cast.
	(getMinimumSize): Removed unneeded cast.
	(installUI): Initialize dividerLocationSet with false.
	(uninstallUI): Initialize dividerLocationSet with false.
	(setDividerLocation): Set dividerLocationSet to true.

2006-10-09  Robert Schuster  <robertschuster@fsfe.org>

	* native/jni/java-net/gnu_java_net/VMPlainSocketImpl.c:
	(Java_gnu_java_net_VMPlainSocketImpl_joinGroup): Properly
	convert jstring into char *.
	(Java_gnu_java_net_VMPlainSocketImpl_joinGroup6): Dito.
	(Java_gnu_java_net_VMPlainSocketImpl_leaveGroup): Dito.
	(Java_gnu_java_net_VMPlainSocketImpl_leaveGroup6): Dito.
	(getif_address): Added const modifier to second argument.
	(getif_index): Dito.

2006-10-09  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JTree.java
	(isSelected): Added API docs.

2006-10-09  Roman Kennke  <kennke@aicas.com>

	* javax/swing/JTree.java
	(isSelected): Delegate to the selection model directly.

2006-10-09  Robert Schuster  <robertschuster@fsfe.org>

	* gnu/java/nio/KqueueSelectorImpl.java: Renamed field
	sizeof_struct_kevent to _sizeof_struct_kevent.

2006-10-07  Audrius Meskauskas  <AudriusA@Bioinformatics.org>

	* tools/gnu/classpath/tools/rmic/RMICException.java:
	javadoc corrections, reformatted.

2006-10-07  Christian Elias Naur  <elias@oddlabs.com>

	* gnu/java/lang/InstrumentationImpl.java:
	Made constructor package visible.

2006-10-05  Gary Benson  <gbenson@redhat.com>

	* java/net/Socket.java
	(Socket): Perform security check on address not hostname.

2006-10-04  Roman Kennke  <kennke@aicas.com>

	* javax/swing/tree/VariableHeightLayoutCache.java
	(getBounds): When rect is null, create a new Rectangle.

2006-10-04  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* native/jni/java-nio/javanio.c (cpnio_read, cpnio_readv)
	(cpnio_write, cpnio_writev, cpnio_socket, cpnio_connect)
	(cpnio_accept, cpnio_sendto, cpnio_recvfrom, cpnio_fcntl)
	(cpnio_select): Use CPNIO_EXPORT.
	* native/jni/java-nio/javanio.h (CPNIO_EXPORT): Define to static
	inline instead of extern inline, as newer GCCs changed their
	behavior.

2006-10-04  Gary Benson  <gbenson@redhat.com>

	* java/net/InetAddress.java: Updated javadoc.
	(<clinit>, getByLiteral): Throw InternalError on failures.

2006-10-03  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(compCtx): New field for composite context.
	(copy): Copy composite.
	(dispose): Dispose of composite context.
	(getNativeCM): New method.
	(setComposite): Discard old composite context and set up new context.
	(setRenderingHints): Update composite context.
	* gnu/java/awt/peer/gtk/CairoSurface.java
	(nativeColorModel): New field, renamed from nativeModel.
	(nativeModel): Renamed field to nativeColorModel.
	(CairoSurface(int, int)): Call new method to create sample model.
	(createNativeSampleModel): New method.
	(getBufferedImage): Updated variable name.
	* gnu/java/awt/peer/gtk/VolatileImageGraphics.java
	(buffer): New field.
	(createBuffer): New method.
	(draw): New method.
	(drawComposite): New method.
	(drawGlyphVector): New method.
	(drawImage(Image, AffineTransform, Color, ImageObserver)): New method.
	(drawImage(Image, int, int, ImageObserver)): Check composite.
	(drawImage(Image, int, int, int, int, ImageObserver)): Check composite.
	(fill): New method.
	(getNativeCM): New method.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_GtkVolatileImage.c
	(Java_gnu_java_awt_peer_gtk_GtkVolatileImage_nativeGetPixels): Use 
	intermediary pixbuf to grab on-screen pixels.

2006-10-03  Tom Tromey  <tromey@redhat.com>

	PR classpath/28987:
	* java/util/IdentityHashMap.java (tombstone): Removed.
	(emptyslot): Removed.
	(nullslot): New field.
	(IdentityHashMap): Don't fill array.
	(clear): Fill with null.
	(hash): Now final.  Use linear probing.
	(xform): New method.
	(unxform): Likewise.
	(removeAtIndex): Likewise.
	(clone, containsKey, containsValue, entrySet, get, hashCode,
	keySet, put, remove, values): Updated.
	(IdentityIterator, IdentityEntry): Likewise.
	(writeObject): Likewise.

2006-10-03  Tom Tromey  <tromey@redhat.com>

	* java/util/Locale.java (hashcode): Updated javadoc.
	(hashcodeCache): Removed.
	(Locale): Updated.
	(hashCode): Updated.
	(writeObject): New method.
	(readObject): Updated.

2006-10-02  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java
	(updateBufferedImage): Recognise that raw data is alpha-premultiplied.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(clearRect): Paint background colour with AlphaComposite.SRC rule.
	(drawImage(Image, AffineTransform, Color, ImageObserver)): Alpha
	pre-multiply data before drawing.
	(fillRect): Draw using regular fill() method.
	(setComposite): Handle null case with AlphaComposite.SrcOver default.
	* gnu/java/awt/peer/gtk/CairoSurface.java
	(nativeModel): Use correct value for alpha premultiplication (true).
	* java/awt/image/BufferedImage.java
	(coerceData): Update isPremultiplied field.

2006-10-02  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* gnu/classpath/ListenerData.java:
	New class for holding listener data.
	* gnu/java/lang/management/MemoryMXBeanImpl.java:
	ListenerData class moved to its own file.
	* javax/management/MBeanServerDelegate.java,
	* javax/management/MBeanServerDelegateMBean.java,
	* javax/management/MBeanServerNotification.java:
	Implemented.

2006-10-02  Tania Bento  <tbento@redhat.com>

	* java/ast/Rectangle.java:
	(Rectangle(Rectangle)): Do not throw NPE.
	(Rectangle(Point, Dimension)): Same.
	(Rectangle(Point)): Same.
	(Rectangle(Dimension)): Same.

2006-09-29  Casey Marshall  <csm@gnu.org>

	PR 29190
	* gnu/java/nio/EpollSelectionKeyImpl.java: extend
	`AbstractSelectionKey.'
	(cancel, isValid): removed.
	* gnu/java/nio/EpollSelectorImpl.java (cancelledKeys): removed.
	(events): new field.
	(INITIAL_CAPACITY, MAX_DOUBLING_CAPACITY, CAPACITY_INCREMENT): new
	fields.
	(<clinit>): initialize those constants.
	(<init>): don't initialize `cancelledKeys;' initialize `events.'
	(doSelect): deregister cancelled keys; remove keys attached to
	closed channels; wrap `epoll_wait' in `begin' and `end' calls; use
	`events' buffer; reallocate `events' buffer if needed.
	(register): reallocate `events' buffer if needed.
	(reallocateBuffer): new method.
	(cancel): removed.

2006-09-29  Roman Kennke  <kennke@aicas.com>

	PR 28929
	* javax/swing/JViewport.java
	(cinit): Renamed system property to gnu.swing.scrollmode
	to avoid bloat. Default to BACKINGSTORE, this is much
	more reliable.
	(repaint): Forward repaint() to parent as is specified.

2006-09-29  Tania Bento  <tbento@redhat.com>

	* javax/swing/plaf/basic/BasicTableUI.java
	(getPreferredSize): The number of iterations for the for-loop should be
	the number of columns in the table's column model, not the number of
	columns of the table.
	* javax/swing/JTable.java
	(JTable(TableModel, TableColumnModel, ListSelectionModel): Removed 4
	lines that are not needed.
	(initializeLocalVars): dragEnabled should be set to false, not true.
	(getCellRenderer): Added a check to prevent an
	ArrayIndexOutOfBoundsException.
	(doLayout): The number of iterations for the for-loops should be the
	number of columns in the table's column model, not the number of columns
	of the table.

2006-09-29  Roman Kennke  <kennke@aicas.com>

	* gnu/java/awt/java2d/AbstractGraphics2D.java: Updated
	API docs.
	(isOptimized): Initialize with true.
	(paintRaster): Removed unneeded field.
	(shapeCache): New static field. Caches certain shapes for reuse.
	(computeIntersection): Removed unneeded casts.
	(drawArc): Use shape cache.
	(drawImage): Removed unneeded statement.
	(drawLine): Use shape cache. Pass untranslated coordinates
	to rawDrawLine().
	(drawOval): Use shape cache.
	(drawPolygon): Use shape cache.
	(drawRect): Overridden to provide accelerated rectangle drawing
	if possible and to use the shape cache.
	(drawRoundRect): Use shape cache.
	(fillArc): Use shape cache.
	(fillOval): Use shape cache.
	(fillPolygon): Use shape cache.
	(fillRect): Pass untranslated coordinates to rawFillRect().
	Use shape cache.
	(fillRoundRect): Use shape cache.
	(fillScanlineAA): Removed unneeded statement.
	(fillScanline): Updated API docs.
	(fillShapeAntialias): Removed unnecessary cast.
	(fillShapeImpl): Update API docs. Removed unnecessary cast.
	(fillShape): Updated API docs.
	(getShapeCache): New helper method.
	* gnu/java/awt/java2d/ShapeCache.java: New class. Caches
	certain shapes for reuse in AbstractGraphics2D.

2006-09-28  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* javax/management/BadBinaryOpValueExpException.java:
	(getExp()): Implemented.
	* javax/management/MBeanConnection.java:
	Renamed to MBeanServerConnection.
	* javax/management/MBeanServer.java:
	(setAttribute(Attribute)): Fixed...
	(setAttribute(ObjectName,Attribute)): to this.
	* javax/management/MBeanServerConnection.java:
	Renamed from MBeanConnection.
	* javax/management/QueryExp.java:
	Extend Serializable.
	* javax/management/ValueExp.java:
	Likewise.
	* javax/management/loading/ClassLoaderRepository.java:
	(loadClass(String)): Throw ClassNotFoundException.
	(loadClassBefore(ClassLoader,String)): Likewise.
	(loadClassWithout(String, ClassLoader): Fixed...
	(loadClassWithout(ClassLoader,String)): to this.
	
2006-09-28  Roman Kennke  <kennke@aicas.com>

	* javax/swing/tree/DefaultTreeCellRenderer.java
	(DefaultTreeCellRenderer): Fetch drawsFocusBorderAroundIcon
	property from UIManager.
	(paint): Rewritten to use super's implementation and only paint
	background and focus indicator before.
	(paintFocus): New helper method.
	(getXOffset): New helper method.

2006-09-28  Andrew John Hughes  <gnu_andrew@member.fsf.org>
	
	* javax/management/BadBinaryOpValueExpException.java,
	* javax/management/MBeanConnection.java,
	* javax/management/MBeanServer.java,
	* javax/management/ObjectInstance.java:
	Implemented.
	* javax/management/ObjectName.java:
	(setMBeanServer(MBeanServer)): Implemented.
	* javax/management/QueryExp.java,
	* javax/management/ValueExp.java,
	* javax/management/loading/ClassLoaderRepository.java:
	Implemented.

2006-09-27  Robert Schuster  <robertschuster@fsfe.org>

	* gnu/java/nio/VMChannelOwner.java: Removed unneeded imports.

2006-09-27  Robert Schuster  <robertschuster@fsfe.org>

	* vm/reference/gnu/java/nio/VMChannel.java: Removed unneeded imports.
	* vm/reference/gnu/java/nio/VMPipe.java: Removed unneeded imports.
	* gnu/java/nio/EpollSelectorImpl.java:
	(doSelect): Use Integer.valueOf() instead of constructor call.
	(register): Use Integer.valueOf() instead of constructor call.

2006-09-27  Roman Kennke  <kennke@aicas.com>

	* java/awt/Container.java
	(addContainerListener): Activate newEventsOnly for the component.
	Ignore null listeners.

2006-09-27  Roman Kennke  <kennke@aicas.com>

	* java/awt/EventQueue.java
	(Queue): New inner class. Implements the actual queue.
	(LOW_PRIORITY): New constant field.
	(NORM_PRIORITY): New constant field.
	(queueHead): Removed. Moved into Queue.
	(queueTail): Removed. Moved into Queue.
	(queues): New field.
	(EventQueue): Initialize two internal queues, one for
	normal events, one for low priority events.
	(getNextEventImpl): New helper method, fetches the next event.
	(getNextEvent): Use getNextEventImpl() for fetching the event.
	(peekEvent): Use getNextEventImpl() for fetching the event.
	(peekEvent(int)): Search for event in all queues.
	(postEventImpl(AWTEvent)): Moved actual posting into
	postEventImpl(AWTEvent,int). Prioritize events here.
	(postEventImpl(AWTEvent,int)): Take priority parameter and insert
	event into correct queue. Re-enable event coalescing.
	* gnu/java/awt/LowPriorityEvent.java: New marker interface.
	* javax/swing/RepaintManager.java
	(RepaintWorkerEvent): New internal class. This is a low priority
	event for the repaint worker.
	(addDirtyRegion): Use new internal invokeLater() for sending
	a low priority event.
	(addInvalidComponent): Use new internal invokeLater() for sending
	a low priority event.
	(commitBuffer): Added some null checks.
	(invokeLater): New helper method. Sends a low priority
	repaint worker event on the event queue.

2006-09-27  Roman Kennke  <kennke@aicas.com>

	PR 29036
	PR 29161
	* javax/swing/plaf/basic/BasicButtonUI.java
	(cachedInsets): New field.
	(installListeners): Fire synthetic property change to initialize
	TEXT_LAYOUT_CACHE for the button because the font has been
	installed before.
	(uninstallUI): Clear the TEXT_LAYOUT_CACHE for the button.
	(paint): Use cached insets.
	(paintText): Let new method forward to old one, not vice versa.
	* javax/swing/plaf/basic/BasicMenuItemUI.java
	(defaultAcceleratorLabelGap): Removed unused field.
	(MenuGap): Removed unused field.
	(propertyChangeListener): Made private.
	(getAcceleratorRect): Removed unused method.
	(getAcceleratorText): Removed unused method.
	(getPath): Removed unnecessary cast.
	(installListeners): Fire synthetic property change to initialize
	TEXT_LAYOUT_CACHE for the button because the font has been
	installed before.
	(uninstallUI): Clear the TEXT_LAYOUT_CACHE for the button.
	(layoutMenuItem): Removed unused statements.
	
2006-09-27  Roman Kennke  <kennke@aicas.com>

	PR 29218
	* javax/swing/tree/DefaultTreeModel.java
	(isLeaf): Check if the node allows children when
	asksAllowsChildren is true, otherwise fall back
	to return the node's leaf property.

2006-09-27  Mario Torre  <neugens@limasoftware.net>

	* scripts/check_jni_methods.sh: removed methods from the
	ignore list:
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_finalize_1class
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_init_1id_1cache
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_init_1class
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1escape_1key
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1unescape_1key
	* native/jni/gconf-peer/GConfNativePeer.c: fixed coding style
	to better follow the GNU style.
	* include/gnu_java_util_prefs_gconf_GConfNativePeer.h.
	regenerated header file for GConfNativePeer.

2006-09-27  Robert Schuster  <robertschuster@fsfe.org>

	* INSTALL: Added information about grmic being built when ASM
	is available, added information about gconf dependency, indented
	Qt4 dependency section.
	* configure.ac: Added information about grmic being built when ASM
	is available.

2006-09-27  Ian Rogers  <ian.rogers@manchester.ac.uk>

	* native/jni/classpath/jcl.c (JNI_OnLoad): Don't call
	DeleteGlobalRef on a local ref.

2006-09-24  Mario Torre  <neugens@limasoftware.net>

	* scripts/check_jni_methods.sh: added two new methods in the
	ignore list:
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1escape_1key
	and
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1unescape_1key
	* native/jni/gconf-peer/GConfNativePeer.c:
	(Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1client_1all_1keys):
	refacored method name, renamed from
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1client_1gconf_1client_1all_1keys.
	Added code to unescape escaped GConf key names.
	(Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1client_1all_1nodes):
	refacored method name, renamed from
	Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1client_1gconf_1client_1all_1nodes.
	Added code to unescape escaped GConf key names.
	(Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1escape_1key):
	new function.
	(Java_gnu_java_util_prefs_gconf_GConfNativePeer_gconf_1unescape_1key):
	new function.
	* gnu/java/util/prefs/gconf/GConfNativePeer.java: removed
	version javadoc tag.
	(escapeString): new method.
	(unescapeString): likewise.
	(gconf_escape_key): new native method.
	(gconf_unescape_key): likewise.
	(gconf_client_suggest_sync): update native method signature, now
	explicity throws BackingStoreException.
	(gconf_client_all_nodes): update native method signature, now
	explicity throws BackingStoreException. Refactored method name,
	renamed from gconf_client_gconf_client_all_nodes.
	(gconf_client_all_keys): update native method signature, now
	explicity throws BackingStoreException. Refactored method name,
	renamed from gconf_client_gconf_client_all_keys.
	(getKeys): refactored to use the new method name
	gconf_client_all_keys.
	(getChildrenNodes): refactored to use the new method name
	gconf_client_all_nodes.
	* gnu/java/util/prefs/GConfBasedPreferences.java: removed
	version javadoc tag.
	(GConfBasedPreferences): Added code to escape node names from
	invalid characters so that GConf now accept invalid node names.
	(GConfBasedPreferences): Moved code to register the current
	node to the list of nodes watched by GConf outside the constructor.
	(childSpi): Added code to register the current node to the
	list of nodes watched by GConf.
	(getGConfKey): Added code to escape key names from
	invalid characters so that GConf now accept invalid key names.

2006-09-26  Tom Tromey  <tromey@redhat.com>

	* tools/gnu/classpath/tools/javah/Printer.java (Printer): Don't
	call mkdirs in output-directory case.
	(getPrintStream): Create output directory.
	* tools/gnu/classpath/tools/javah/Main.java (makeOutputDirectory):
	Don't call mkdirs.

2006-09-27  Raif S. Naffah  <raif@swiftdsl.com.au>

	* tools/gnu/classpath/tools/javah/CniIncludePrinter.java (CniIncludePrinter):
	Accept three additional arguments.
	(writePreambleImpl): New method.
	(getPrintStreamImpl): Likewise.
	(printClass): Adapted to use new methods in Printer superclass.
	* tools/gnu/classpath/tools/javah/CniStubPrinter.java: Likewise.
	* tools/gnu/classpath/tools/javah/JniIncludePrinter.java: Likewise.
	* tools/gnu/classpath/tools/javah/JniStubPrinter.java: Likewise.
	* tools/gnu/classpath/tools/javah/Main.java (outFileName): New field.
	(force): Likewise.
	(getParser): Add support for -o option.
	Check that only one of -d or -o is defined.
	Add support for -jni option.
	Add support for -force option.
	(makeOutputFile): New method.
	(writeHeaders): Removed File argument from signature.
	(run): Take into account newly added fields.
	Invoke concrete PrintStream implementations with augmented constructors.
	* tools/gnu/classpath/tools/javah/Printer.java (outputFileObject): New field.
	(isDirectory): Likewise.
	(force): Likewise.
	(wrotePreamble): Likewise.
	(Printer): Changed ctor to accept three additional arguments.
	(printClass): Changed signature to accept one ClassWrapper argument.
	(writePreambleImpl): New abstract method.
	(getPrintStreamImpl): Likewise.
	(getPrintStream): New method.
	(writePreamble): Likewise.

2006-09-26  Tania Bento  <tbento@redhat.com>

	* java/awt/GridLayout.java
	(toString): There is no common before hgap.
	* java/awt/Rectangle.java
	(Rectangle(Rectangle)): Throw NPE if Rectangle is null.
	(Rectangle(Point, Rectangle)): Throw NPE if either Point or 
	Rectangle is null.
	(Rectangle(Point)): Throw NPE if Point is null.
	(Rectangle(Dimension)): Throw NPE if Dimension is null.

2006-09-26  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/metal/MetalIconFactory.java
	(FileIcon16.paintIcon): Apply vertical shift by the number of pixels
	returned by getShift(),
	(FileIcon16.getShift): Updated API docs,
	(FolderIcon16.paintIcon): Apply vertical shift by the number of pixels
	returned by getShift(),
	(FolderIcon16.getShift): Updated API docs,
	(TreeFolderIcon.getShift): Likewise,
	(TreeLeafIcon.getShift): Likewise.

2006-09-26  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/metal/MetalIconFactory.java
	(FileIcon16.paintIcon): Fetch colors from look and feel,
	(FolderIcon16.paintIcon): Likewise.

2006-09-25  Casey Marshall  <csm@gnu.org>

	* gnu/java/nio/FileChannelImpl.java (read): revert back to using
	`readScattering.'
	(write): revert back to using `writeGathering.'
	* vm/reference/gnu/java/nio/VMChannel.java (writeGathering): find
	the first buffer that has data remaining, and start at that one.

2006-09-25  Tom Tromey  <tromey@redhat.com>

	* native/jni/gconf-peer/Makefile.am (libgconfpeer_la_LDFLAGS): New
	variable.

2006-09-25  Tom Tromey  <tromey@redhat.com>

	* tools/.cvsignore: Updated.

2006-09-25  Tom Tromey  <tromey@redhat.com>

	PR libgcj/29178:
	* gnu/java/nio/charset/US_ASCII.java (Encoder.canEncode): New method.
	(Encoder.canEncode): Likewise.
	(Encoder.encodeLoop): Return unmappable for all non-ASCII characters.
	* gnu/java/nio/charset/ByteCharset.java (Encoder.canEncode): New
	method.
	(Encoder.canEncode): Likewise.
	* gnu/java/nio/charset/ISO_8859_1.java (Encoder.canEncode): New
	method.
	(Encoder.canEncode): Likewise.

2006-09-25  Tom Tromey  <tromey@redhat.com>

	* native/fdlibm/mprec.c (mprec_calloc): Renamed.
	(Balloc): Updated.

2006-09-25  Francis Kung  <fkung@redhat.com>

	* java/awt/image/ColorModel.java
	(coerceData): Made abstract.
	(coerceDataWorker): New protected method.
	* java/awt/image/ComponentColorModel.java
	(coerceData): Return new instance of proper ColorModel.
	* java/awt/image/DirectColorModel.java
	(coerceData): Return new instance of proper ColorModel.
	* java/awt/image/IndexColorModel.java
	(coerceData): New method.

2006-09-24  Casey Marshall  <csm@gnu.org>

	* gnu/java/nio/FileChannelImpl.java
	(read): call `read' in a loop, don't use `readScattering.'
	(write): call `write' in a loop, don't use `writeGathering.'

2006-09-24  Mark Wielaard  <mark@klomp.org>

	* configure.ac: Move -pedantic from WARNING to STRICT flags.

2006-09-24  Jeroen Frijters  <jeroen@frijters.net>

	* java/nio/channels/spi/AbstractSelectableChannel.java
	(register): Set interestOps and attachment when the key already
	exists.

2006-09-24  Jeroen Frijters  <jeroen@frijters.net>

	* java/net/ServerSocket.java
	(bind(SocketAddress,int)): Added support for null address.
	Throw proper exception if already bound.
	Handle unresolved addresses correctly. Ignore exceptions that
	happen during close in error path (to prevent losing the original
	exception.)

2006-09-24  Mark Wielaard  <mark@klomp.org>

	Suggested by Aaron M. Ucko <ucko@debian.org>
	Fixes bug #29203
	* native/fdlibm/mprec.c (ulp): Define L as int32_t.

2006-09-24  Jeroen Frijters  <jeroen@frijters.net>

	* java/nio/channels/spi/AbstractSelectableChannel.java
	(implCloseChannel): Cancel all keys after closing the channel.

2006-09-22  Casey Marshall  <csm@gnu.org>

	* gnu/java/nio/EpollSelectorImpl.java (doSelect): remove keys
	after we delete them.
	(selectedKeys): return an empty set if nothing's been selected.
	* native/jni/java-nio/gnu_java_nio_EpollSelectorImpl.c
	(Java_gnu_java_nio_EpollSelectorImpl_epoll_1delete): don't
	throw an exception on EBADF.
	(Java_gnu_java_nio_EpollSelectorImpl_epoll_1wait): don't
	throw exception on EINTR, just return 0.
	
2006-09-22  Casey Marshall  <csm@gnu.org>

	* native/jni/java-io/java_io_VMFile.c (Java_java_io_VMFile_list):
	remove `const' from `filename.'
	* native/jni/native-lib/cpio.c (cpio_readDir): remove `const' from
	`filename.'
	* native/jni/native-lib/cpio.h (cpio_readDir): likewise.

2006-09-22  Casey Marshall  <csm@gnu.org>

	* configure.ac (AC_CHECK_FUNCS): check for `readdir_r.'
	* native/jni/java-io/java_io_VMFile.c (Java_java_io_VMFile_list):
	allocate `filename,' and handle changes to `cpio_readDir.'
	* native/jni/native-lib/cpio.c (cpio_readDir): use `readdir_r' if
	available; copy the filename into the destination buffer; return
	an error code if readdir returns NULL, but errno is 0.
	* native/jni/native-lib/cpio.h (cpio_readDir): change second
	parameter to `const char *.'

2006-09-23  Andrew John Hughes  <gnu_andrew@member.fsf.org>

	* javax/management/ObjectName.java:
	Implemented.
	
2006-09-22  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* resource/gnu/classpath/tools/orbd: New directory.
	* resource/gnu/classpath/tools/rmic: Likewise.
	* resource/gnu/classpath/tools/rmid: Likewise.
	* resource/gnu/classpath/tools/rmiregistry: Likewise.
	* resource/gnu/classpath/tools/tnameserv: Likewise.
	* tools/gnu/classpath/tools/giop: Move contents to...
	* tools/gnu/classpath/tools/orbd,
	tools/gnu/classpath/tools/tnameserv: New directories.
	* tools/gnu/classpath/tools/rmi/rmic: Move contents to...
	* tools/gnu/classpath/tools/rmic: New directory.
	* tools/gnu/classpath/tools/rmi/rmid: Move contents to...
	* tools/gnu/classpath/tools/rmid: New directory.
	* tools/gnu/classpath/tools/rmi/registry: Move contents to...
	* tools/gnu/classpath/tools/rmiregistry: New directory.
	* resource/gnu/classpath/tools/orbd/messages.properties: New file.
	* resource/gnu/classpath/tools/rmic/messages.properties: Likewise.
	* resource/gnu/classpath/tools/rmid/messages.properties: Likewise.
	* resource/gnu/classpath/tools/rmiregistry/messages.properties:
	Likewise.
	* resource/gnu/classpath/tools/tnameserv/messages.properties:
	Likewise.
	* tools/gnu/classpath/tools/orbd/Main.java,
	tools/gnu/classpath/tools/orbd/Messages.java,
	tools/gnu/classpath/tools/orbd/PersistentContext.java,
	tools/gnu/classpath/tools/orbd/PersistentContextMap.java,
	tools/gnu/classpath/tools/orbd/PersistentMap.java,
	tools/gnu/classpath/tools/rmic/AbstractMethodGenerator.java,
	tools/gnu/classpath/tools/rmic/CompilationError.java,
	tools/gnu/classpath/tools/rmic/Generator.java,
	tools/gnu/classpath/tools/rmic/GiopIo.java,
	tools/gnu/classpath/tools/rmic/HashFinder.java,
	tools/gnu/classpath/tools/rmic/Main.java,
	tools/gnu/classpath/tools/rmic/Messages.java,
	tools/gnu/classpath/tools/rmic/MethodGenerator.java,
	tools/gnu/classpath/tools/rmic/RMICException.java,
	tools/gnu/classpath/tools/rmic/RmiMethodGenerator.java,
	tools/gnu/classpath/tools/rmic/RmicBackend.java,
	tools/gnu/classpath/tools/rmic/SourceGiopRmicCompiler.java,
	tools/gnu/classpath/tools/rmic/SourceRmicCompiler.java,
	tools/gnu/classpath/tools/rmic/Variables.java,
	tools/gnu/classpath/tools/rmic/WrapUnWrapper.java,
	tools/gnu/classpath/tools/rmic/templates,
	tools/gnu/classpath/tools/rmid/ActivationSystemImpl.java,
	tools/gnu/classpath/tools/rmid/ActivationSystemImpl_Stub.java,
	tools/gnu/classpath/tools/rmid/Main.java,
	tools/gnu/classpath/tools/rmid/Messages.java,
	tools/gnu/classpath/tools/rmid/PersistentBidiHashTable.java,
	tools/gnu/classpath/tools/rmiregistry/Main.java,
	tools/gnu/classpath/tools/rmiregistry/Messages.java,
	tools/gnu/classpath/tools/rmiregistry/PersistentHashTable.java,
	tools/gnu/classpath/tools/rmiregistry/RegistryImpl.java,
	tools/gnu/classpath/tools/rmiregistry/RegistryImpl_Skel.java,
	tools/gnu/classpath/tools/rmiregistry/RegistryImpl_Stub.java,
	tools/gnu/classpath/tools/tnameserv/Main.java,
	tools/gnu/classpath/tools/tnameserv/Messages.java: New files.
	* tools/gnu/classpath/tools/rmic/ClassRmicCompiler.java: Import
	RMIC.java from cp-tools.
	* configure.ac (AC_CONFIG_FILES): Add tools/grmiregistry,
	tools/gtnameserv, tools/gorbd, tools/grmid and tools/grmic.
	(AC_CONFIG_COMMANDS): Add grmiregistry, gtnameserv, gorbd, grmid
	and grmic.
	* examples/Makefile.am (GLIBJ_CLASSPATH): Add tools.zip.
	* gnu/CORBA/NamingService/NamingServiceTransient.java (main):
	Rename...
	(start): New method.
	* tools/Makefile.am: Add build support for new tool wrappers.
	* tools/gorbd.in: New file.
	* tools/grmic.in: Likewise.
	* tools/grmid.in: Likewise.
	* tools/grmiregistry.in: Likewise.
	* tools/gtnameserv.in: Likewise.
	* tools/gnu/classpath/tools/AbstractMethodGenerator.java: Move to...
	* tools/gnu/classpath/tools/rmic/AbstractMethodGenerator.java: New
	file.
	* tools/gnu/classpath/tools/HelpPrinter.java: Remove file.
	* tools/gnu/classpath/tools/rmi/Persistent.java: Move to...
	* tools/gnu/classpath/tools/common/Persistent.java: New file.

2006-09-22  Ito Kazumitsu  <kaz@maczuka.gcd.org>

	Fixes bug #29047
	* gnu/java/util/regex/RETokenRepeated.java
	(findMatch): Rewriten without using recursive calls,
	(FindMatchControlStack): New class,
	(FindMatchControl): New class,
	(TryAnotherResult): New class,
	(tryAnother): New method.

2006-09-22  Gary Benson  <gbenson@redhat.com>

	* java/net/SocketPermission.java
	(processHostport): Cope with IPv6 addresses with a
	one-digit first component.

2006-09-22  Roman Kennke  <kennke@aicas.com>

	* java/awt/Component.java
	(enableEvents): Set newEventsOnly flag.
	* java/awt/Container.java
	(dispatchEventImpl): Consume event if lightweight dispatcher
	dispatched the event. Don't call processEvent() here, this
	is already done in Component.dispatchEventImpl(). For
	heavyweights or when the lightweight dispatcher could
	not dispatch, fall back to calling super.
	(dispatchNoLightweight): New helper method to avoid
	recursivly calling the lightweight dispatcher.
	* java/awt/LightweightDispatcher.java
	(dragButton): Removed field.
	(dragTarget): Removed field.
	(mouseEventTarget): New field.
	(convertPointToChild): Removed method.
	(dispatchEvent): Don't depend on component beeing
	a window.
	(findTarget): Improved algorithm for finding a target.
	Before we went down to the deepest component and went
	up again to find a suitable target. Now we go
	down only once, without going up.
	(handleMouseEvent): Broke method down into some smaller
	helper methods.
	(isDragging): New helper method.
	(isMouseListening): New helper method.
	(redispatch): New helper method.
	(trackEnterExit): New helper method.

2006-09-22  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/SizeSequence.java
	(getSize): Return 0 if index is out of bounds.

2006-09-21  Tom Tromey  <tromey@redhat.com>

	* tools/gnu/classpath/tools/javah/PathOptionGroup.java
	(PathOptionGroup): Make -I a joined option.
	* tools/gnu/classpath/tools/keytool/CACertCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/CertReqCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/DeleteCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/ExportCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/GenKeyCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/IdentityDBCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/ImportCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/KeyCloneCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/KeyPasswdCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/ListCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/MainCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/PrintCertCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/SelfCertCmd.java: Updated.
	* tools/gnu/classpath/tools/keytool/StorePasswdCmd.java: Updated.
	* tools/gnu/classpath/tools/appletviewer/Main.java: Updated.
	* tools/gnu/classpath/tools/jar/Main.java: Updated.
	* tools/gnu/classpath/tools/jarsigner/Main.java: Updated.
	* tools/gnu/classpath/tools/javah/Main.java: Updated.
	* tools/gnu/classpath/tools/native2ascii/Main.java: Updated.
	* tools/gnu/classpath/tools/serialver/SerialVer.java: Updated.
	* resource/gnu/classpath/tools/getopt/Messages.properties: Removed
	unused entries.
	* resource/gnu/classpath/tools/common/Messages.properties: New file.
	* tools/gnu/classpath/tools/common/Messages.java: New file.
	* tools/gnu/classpath/tools/getopt/Messages.java: Now package-private.
	* tools/gnu/classpath/tools/common/ClasspathToolParser.java: Moved
	from getopt.
	(ClasspathToolParser): Add -J option here.
	(ClasspathToolParser): Call other constructor in this class.
	* tools/gnu/classpath/tools/getopt/Parser.java (handleLongOption):
	Handle joined options.
	(handleShortOptions): Likewise.
	(handleShortOption): Removed.
	(finalGroup): New field.
	(Parser): Initialize new field.  Don't add -J option.
	(addFinal): New method.
	* tools/gnu/classpath/tools/getopt/OptionGroup.java (printHelp): Use
	isJoined.
	* tools/gnu/classpath/tools/getopt/Option.java (isJoined): New method.
	(Option): Check short option for validity.
	(Option): New constructors.
	(joined): New field.

2006-09-21  csm  <csm@pollux.local>

	* gnu/java/net/PlainDatagramSocketImpl.java (send): ignore
	`InterruptedIOException;' try again if it gets thrown.
	(receive): likewise, but re-throw `SocketTimeoutException.'
	* gnu/java/nio/EpollSelectorImpl.java (doSelect): just return 0
	if we have nothing to select.

2006-09-21  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/FreetypeGlyphVector.java:
	(getLogicalBounds): Respect glyph transformations.
	(getGlyphOutline): Added null pointer check.
	(getGlyphTransform): Do not generate identity transform (API permits null).
	(setGlyphPosition): Do not invalidate transform.
	(setGlyphTransform): Do not modify glyph position.

2006-09-21  Francis Kung  <fkung@redhat.com>

	* java/awt/image/ColorModel.java (coerceData): Set alpha premultiplied flag.

2006-09-21  Francis Kung  <fkung@redhat.com>

	* java/awt/image/ColorModel.java (coerceData): Return proper colour model.
	* java/awt/image/ComponentColorModel.java (coerceData): Likewise.
	* java/awt/image/DirectColorModel.java (coerceData): Likewise.

2006-09-21  Tania Bento  <tbento@redhat.com>

	* javax/swing/JTabbedPane.java:
	(insertTab): Notify ChangeListeners if the tab inserted is selected.
	(setModel): A ChangeListener should be created only if there does not 
	currently exist one.

2006-09-21  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/basic/BasicInternalFrameTitlePane.java
	(MaximizeAction.actionPerformed): Change icon on maxButton.

2006-09-21  Roman Kennke  <kennke@aicas.com>

	* javax/swing/plaf/basic/BasicScrollPaneUI.java
	(syncScrollPaneWithViewport): Fixed typo (hsb vs. vsb).
	Use more efficient getViewPosition() and getViewSize() methods
	to avoid creating a rectangle.
	(HSBChangeListener.stateChanged): Update the view position
	unconditionally. Let the Viewport figure out if something
	changed.
	(VSBChangeListener.stateChanged): Update the view position
	unconditionally. Let the Viewport figure out if something
	changed.
	* javax/swing/JViewport.java
	(ViewListener.componentResized): Fire state change, because
	the extentSize changes.
	(extentSize): Removed unneeded field.
	(viewSize): Removed unneeded field.
	(getExtentSize): Return the viewport's size here.
	(getViewRect): Reformatted.
	(getViewSize): Reordered for only one return statement.
	(paintImmediately2): Fixed up javadoc.
	(paint): Removed unneeded statement.
	(setExtentSize): Set viewport size and check for actual change
	of value.
	(setViewPosition): Simplified condition. Set scrollUnderway
	true and don't set isViewSizeSet. Avoid creating one Point
	object.
	(setViewSize): Fixed != comparison with equals(). Set scrollUnderway
	to false.
	* javax/swing/JScrollBar.java
	(ScrollBarListener): New class. Forwards change events from
	the model as adjustment events.
	(sbChangeListener): New field.
	(JScrollBar): Install listener on new model.
	(fireAdjustmentValueChanged(int,int,int)): Delegate to new helper
	method.
	(fireAdjustmentValueChanged(int,int,int,boolean)): New helper
	method to allow custom isAdjusting value.
	(setMaximum): Only forward to model.
	(setMinimum): Only forward to model.
	(setValue): Only forward to model.
	(setVisibleAmount): Only forward to model.
	(setValues): Only forward to model.
	(setModel): Update the change listener.

2006-09-20  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	* java/util/Formatter.java (basicIntegralConversion): Removed 
	check for ZERO && !LEFT_JUSTIFY.
		
2006-09-20  Roman Kennke  <kennke@aicas.com>

	PR 29036
	* javax/swing/plaf/metal/DefaultMetalTheme.java
	(PLAIN_CONTROL_TEXT_FONT): New constant field.
	(BOLD_CONTROL_TEXT_FONT): New constant field.
	(PLAIN_MENU_TEXT_FONT): New constant field.
	(BOLD_MENU_TEXT_FONT): New constant field.
	(controlTextFont): Removed.
	(menuTextFont): Removed.
	(CONTROL_TEXT_FONT): New constant field.
	(MENU_TEXT_FONT): New constant field.
	(getControlTextFont): Use getFont() helper method for fetching
	the correct font.
	(getMenuTextFont): Use getFont() helper method for fetching
	the correct font.
	(getFont): New helper method.
	(isBoldMetal): New helper method.

2006-09-20  Casey Marshall  <csm@gnu.org>

	* NEWS: mention epoll selector along with the kqueue one.

2006-09-20  Casey Marshall  <csm@gnu.org>

	* native/jni/java-nio/gnu_java_nio_EpollSelectorImpl.c
	(Java_gnu_java_nio_EpollSelectorImpl_epoll_1delete): ignore ENOENT.

2006-09-20  Francis Kung  <fkung@redhat.com>

	PR 29011
	* gnu/java/awt/peer/gtk/FreetypeGlyphVector.java:
	(getGlyphTransform): Use translation instead of scale.
	(performDefaultLayout): Increment position values instead of resetting, and
	pre-increment instead of post-increment.
	(setGlyphTransform): Handle null case with identity transform.

2006-09-20  Casey Marshall  <csm@gnu.org>

	* configure.ac (AC_CHECK_HEADERS): check for `sys/epoll.h.'
	(AC_CHECK_FUNCS): check for `epoll_create.'
	* gnu/java/nio/EpollSelectionKeyImpl.java: new file.
	* gnu/java/nio/EpollSelectorImpl.java: new file.
	* gnu/java/nio/SelectorProviderImpl.java (epoll_failed): new class
	field.
	(openSelector): return epoll selector if requested and available.
	* include/Makefile.am (H_FILES): add gnu_java_nio_EpollSelectorImpl.h.
	(gnu_java_nio_EpollSelectorImpl.h): new target.
	* include/gnu_java_nio_EpollSelectorImpl.h: new file.
	* native/jni/java-nio/Makefile.am (libjavanio_la_SOURCES): add
	gnu_java_nio_EpollSelectorImpl.c.
	* native/jni/java-nio/gnu_java_nio_EpollSelectorImpl.c: new file.

2006-09-20  Casey Marshall  <csm@gnu.org>

	* gnu/java/nio/SocketChannelImpl.java (finishConnect): don't
	call `isConnected.'
	(isConnected): return false if `connectionPending' is true.

2006-09-20  Francis Kung  <fkung@redhat.com>

	PR 29011
	* gnu/java/awt/peer/gtk/FreetypeGlyphVector.java:
	(constructor): Expanded glyphPositions array to accomodate Y-coordinates.
	(getGlyphOutline): Call getGylphTransform to generate transform.
	(getGylphPosition): Read position directly out of array.
	(getGlyphPositions): Read positions directly out of array.
	(getGlyphTransform): Generate transform based on gylphPositions array.
	(performDefaultLayout): Populate glyphPositions array instead of transforms.
	(setGlyphPosition): Set position directly into array.
	(setGlyphTransform): Update positions array as well.

2006-09-20  David Daney  <ddaney@avtrex.com>

	PR classpath/28661
	* gnu/java/net/protocol/http/HTTPURLConnection.java (connect):  Add
	default content-type for POST method.

2006-09-20  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/basic/BasicRadioButtonUI.java
	(BasicRadioButtonUI): Don't fetch icon here,
	(installDefaults): Initialise icon here,
	(getDefaultIcon): Just return icon.

2006-09-20  Mark Wielaard  <mark@klomp.org>

	* native/jni/java-nio/Makefile.am (libjavanio_la_SOURCES):
	Add gnu_java_nio_channels_FileChannelImpl.c and javanio.h.
	(EXTRA_DIST): Include javanio.c.

2006-09-20  David Gilbert  <david.gilbert@object-refinery.com>

	* java/awt/geom/RoundRectangle2D.java:
	(getPathIterator): Reimplemented,
	and updated various API doc comments.

2006-09-20  Roman Kennke  <kennke@aicas.com>

	* java/awt/Container.java
	(addImpl): Set the new component's parent after it has been
	added to the array. Call addNotify() and invalidate()
	after the component has been added, so that the peer
	gets to know about the component structure when it is created.
	* java/awt/Window.java
	(dispatchEventImpl): Only revalidate when window is resized,
	let the other stuff be processed by the superclass.
	(dispose): Post WINDOW_CLOSED event only when some listener
	is registered or event is explicitly enabled.
	(show): Post WINDOW_OPENED event when appropriate.

2006-09-20  Roman Kennke  <kennke@aicas.com>

	* java/awt/Component.java
	(addNotify): Invalidate here. Fetch peer font.
	(getFont): Delegate to helper method, to protect from
	overriding client code. Lock the tree while fetching the font.
	(getFontImpl): New helper method. Moved code from getFont() in
	here.
	(removeNotify): Nullify peerFont too.
	(setFont): Synchronize on tree and component to avoid threading
	issues. Update the peerFont correctly.
	(validate): Update the peer font if necessary, before validating.
	(getGraphics): Revert to recursive graphics fetching.
	Set component font on the Graphics object.
	(translateEvent): Removed unnecessary cast.
	* java/awt/Container.java
	(invalidateTree): Made final and private. Made implementation
	slightly more efficient.
	(setFont): Get old and new font via getFont() to account for
	the real font, and only invalidate the tree when they are not
	the same and not equal.
	(visitChild): Set the font of the child on the component graphics.
	* java/awt/Frame.java
	(setMenuBar): Create local reference of peer for thread safety.
	Only call simple invalidate, not invalidateTree().

2006-09-19  Cameron McCormack  <cam@mcc.id.au>

	PR 29012
	* gnu/java/awt/peer/gtk/BufferedImageGraphics.java:
	(constructor): Copy image field.

2006-09-19  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/JMenuBar.java
	(getHelpMenu): Implemented to throw an Error, and added API docs,
	(getMargin): Added API docs,
	(setMargin): Likewise.

2006-09-19  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/AbstractButton.java
	(AbstractButton): Don't call updateUI(),
	* javax/swing/JButton.java
	(JButton(String, Icon)): Call setModel() before init(),
	* javax/swing/JMenuItem.java
	(JMenuItem()): Delegate to another constructor,
	(JMenuItem(Icon)): Likewise,
	(JMenuItem(Action)): Set model,
	(JMenuItem(String, Icon)): Likewise,
	* javax/swing/JToggleButton.java
	(init): Call setModel() before init().

2006-09-19  Mark Wielaard  <mark@klomp.org>

	Fixes bug #29137
	* java/util/logging/LogManager.java (addLogger): Always check for
	existing children of a new Logger.

2006-09-19  Roman Kennke  <kennke@aicas.com>

	* javax/swing/plaf/basic/BasicScrollPaneUI.java
	(HSBChangeListener.stateChanged): Moved handling of header to
	syncScrollPaneWithViewport().
	(VSBChangeListener.stateChanged): Moved handling of header to
	syncScrollPaneWithViewport().
	(ViewportChangedHandler.stateChanged): Removed unused statements.
	(syncScrollPaneWithViewport): Added null checks. Use setValues
	rather then the single setter methods to avoid multiple
	adjustments and side effects. Also snyc the headers here.
	(updateScrollBarDisplayPolicy): Revalidate and repaint here.
	(uninstallUI): Removed unnecessary cast and this qualifier as well
	as the call to super.

2006-09-19  Gary Benson  <gbenson@redhat.com>

	* java/net/ResolverCache.java: New class (a DNS cache).
	* java/net/InetAddress.java
	(internalGetCanonicalHostName, getAllByName): Use the above.

2006-09-19  Jeroen Frijters  <jeroen@frijters.net>

	* gnu/java/nio/SocketChannelImpl.java: Removed unused import.
	* java/net/ServerSocket.java
	(port): New field.
	(bind): Set port field.
	(close): Set impl to null.
	(isClosed): Check impl and channel instead of using VMChannel.
	(toString): Use port field and getLocalPort() method.
	* java/net/Socket.java
	(isClosed): Check impl and channel instead of using VMChannel.

2006-09-18  Tom Tromey  <tromey@redhat.com>

	* java/util/concurrent/CopyOnWriteArrayList.java
	(CopyOnWriteArrayList): New constructor.

2006-09-18  Casey Marshall  <csm@gnu.org>

	* native/jni/java-net/gnu_java_net_VMPlainSocketImpl.c
	(Java_gnu_java_net_VMPlainSocketImpl_listen): remove debug printf.

2006-09-18  Tom Tromey  <tromey@redhat.com>

	* gnu/javax/net/ssl/provider/SSLSocket.java (isBound, isClosed,
	isConnected): Removed old comment.
	(getRemoteSocketAddress): Uncommented.
	(setOOBInline, getOOBInline, setKeepAlive, getKeepAlive,
	setTrafficClass, getTrafficClass, setReuseAddress,
	getReuseAddress, shutdownInput, shutdownOutput, isInputShutdown,
	isOutputShutdown): Uncommented.

2006-09-18  David Pirkle  <dpirkle@symyx.com>

	Fixes PR 28589
	* gnu/xml/transform/XSLURIResolver.java: Test SAXSource for specific
	  input stream during resolution.

2006-09-18  Roman Kennke  <kennke@aicas.com>

	* java/awt/LightweightDispatcher.java
	(findTarget): Correctly translate child coordinates.
	Use Component.eventTypeEnabled() for checking if a component
	has a certain event enabled.
	(handleMouseEvent): Find the correct mouse event target.
 	Use Component.eventTypeEnabled() for checking if a component
	has a certain event enabled.

2006-09-18  Roman Kennke  <kennke@aicas.com>

	* java/awt/Component.java
	(show): Test for the peer beeing lightweight directly.
	(paintAll): Validate before painting. Don't paint when not
	showing. Call peer.paint() when the component is heavyweight.
	(repaint): Delegate to the parent when lightweight, rather
	than skipping to the nearest heavyweight.
	(createImage): Added null check to prevent NPE.
	(dispatchEvent): Moved old event dispatching and toolkit
	event dispatching to dispatchEventImpl.
	(addComponentListener): Don't enable event. Only add listener
	when not null. Switch to new event dispatching only.
	(addFocusListener): Likewise.
	(addHierarchyListener): Likewise.
	(addHierarchyBoundsListener): Likewise.
	(addKeyListener): Likewise.
	(addMouseListener): Likewise.
	(addMouseMotionListener): Likewise.
	(addMouseWheelListener): Likewise.
	(addInputMethodListener): Likewise.
	(coalesceEvents): For mouse events coalesce them only when
	their modifiers are equal. For paint events coalesce the events
	when one contains the other, without going through complicated
	heuristics.
	(dispatchEventImpl): Moved old event dispatching and toolkit
	event dispatching to dispatchEventImpl.
	(coalescePaintEvents): Removed.
	(HeavyweightInLightweightListener.componentHidden):
	Fixed condition.
	* java/awt/Container.java
	(addImpl): Don't enable events on lightweights.
	(remove): Reordered operations. Don't remove any listeners.
	Throw ArrayIndexOutOfBoundsException when index >= ncomponents.
	Only removeNotify() when peer is != null. Only invalidate if 
	not already invalid. Only fire ContainerEvent if there is
	an interested listener or the event is enabled. Dispatch this
	event directly without the event queue.
	(removeAll): Likewise.
	(paintComponents): Only paint when showing. Also paint heavyweights.
	Don't paint the container itself.
	(removeNotify): Create local variables for improved thread safety.
	(addNotifyContainerChildren): Don't enable events for lightweights.

2006-09-18  Roman Kennke  <kennke@aicas.com>

	* java/awt/EventQueue.java
	(INITIAL_QUEUE_DEPTH): Removed obsolete field.
	(next_in): Removed obsolete field.
	(next_out): Removed obsolete field.
	(queueHead): New field. Markes the head of the queue.
	(queueTail): New field. Markes the tail of the queue.
	(queue): Removed obsolete field.
	(EventQueue): Documented empty block.
	(getNextEvent): Changed array based implementation to single-linked
	list based implementation.
	(invokeAndWait): Use an Object as synchronization object rather
	than the current thread.
	(peekEvent(int)): Changed array based implementation to single-linked
	list based implementation.
	(peekEvent()): Changed array based implementation to single-linked
	list based implementation.
	(pop()): Changed array based implementation to single-linked
	list based implementation.
	(postEvent): Foward to postEventImpl.
	(postEventImpl): Changed array based implementation to single-linked
	list based implementation.
	(push): Changed array based implementation to single-linked
	list based implementation.
	* java/awt/AWTEvent.java
	(queueNext): New field. Implements a single-linked list for
	the EventQueue.

2006-09-17  Mark Wielaard  <mark@klomp.org>

	* javax/swing/text/html/HTMLEditorKit (getStyleSheet): Load
	resource from HTMLEditorKit.class.

2006-09-17  Mark Wielaard  <mark@klomp.org>

	* javax/swing/plaf/basic/BasicToolBarUI.java
	(setBorderToNonRollover): Check whether border is null.
	(setBorderToRollover): Likewise.

2006-09-17  Mark Wielaard  <mark@klomp.org>

	* javax/swing/JTree.java (setLeadSelectionPath): Handle null path.

2006-09-17  Mark Wielaard  <mark@klomp.org>

	* native/jni/java-nio/javanio.c (cpnio_fcntl): Last argument is long.
	* native/jni/java-nio/javanio.h (cpnio_fcntl): Likewise.
	* native/jni/java-nio/gnu_java_nio_VMChannel.c
	(Java_gnu_java_nio_VMChannel_lock): Likewise.
	(Java_gnu_java_nio_VMChannel_unlock): Likewise.

2006-09-17  Casey Marshall  <csm@gnu.org>

	* native/jni/classpath/jcl.c (JNI_OnLoad): mark `reserved' as
	unused.

2006-09-17  Chris Burdess  <dog@gnu.org>

	Fixes PR 27610 27687.
	* gnu/xml/dom/ls/SAXEventSink.java: Permit limited subclassing.
	* gnu/xml/transform/SAXTemplatesHandler.java,
	* gnu/xml/transform/SAXTransformerHandler.java: New files.
	* gnu/xml/transform/TransformerFactoryImpl.java: Implement
	  SAXTransformerFactory.

2006-09-16  Casey Marshall  <csm@gnu.org>

	* NEWS: updated.
	* configure.ac (AC_CHECK_HEADERS): check for `sys/event.h'.
	(AC_CHECK_FUNCS): add checks for readv, writev, getifaddrs,
	kqueue, and kevent.
	(HAVE_INET6): define if IPv6 is supported.
	* gnu/java/net/PlainDatagramSocketImpl.java (channel): new field.
	(native_fd): removed.
	(impl): new field.
	(<init>): throw IOException; initialize fields.
	(finalize): removed.
	(getNativeFD): removed.
	(bind): use `PlainSocketImpl.bind.'
	(create): use `PlainSocketImpl.initSocket.'
	(disconnect): use `PlainSocketImpl.disconnect.'
	(getLocalPort): new method.
	(send): use `VMChannel.send.'
	(receive): use `VMChannel.receive.'
	(setOption): use `PlainSocketImpl.setOption.'
	(getOption): use `PlainSocketImpl.getOption.'
	(close): use `VMChannel.State.close.'
	(join): use `PlainSocketImpl.join.'
	(leave): use `PlainSocketImpl.leave.'
	(joinGroup, leaveGroup): implemented.
	* gnu/java/net/PlainSocketImpl.java: make non-final.
	(native_fd): removed.
	(impl): new field.
	(channel): new field.
	(<init>): initialize `impl.'
	(finalize, getNativeFD): removed.
	(setOption): use `PlainSocketImpl.setOption.'
	(getOption): use `PlainSocketImpl.getOption.'
	(shutdownInput): use `PlainSocketImpl.shutdownInput.'
	(shutdownOutput): use `PlainSocketImpl.shutdownOutput.'
	(create): create `channel,' initialize `impl's native state.
	(connect): use `connect(SocketAddress, int).'
	(connect): use `SocketChannelImpl.connect;' initialize `address'
	and `port.'
	(bind): use `VMPlainSocketImpl.bind.'
	(listen): use `VMPlainSocketImpl.listen.'
	(accept): use `SocketChannelImpl.accept.'
	(available): use `VMChannel.available.'
	(close): use `PlainSocketImpl.close.'
	(sendUrgentData): use `PlainSocketImpl.sendUrgentData.'
	(getVMChannel, getInetAddress, getLocalPort, getLocalAddress,
	getPort): new methods.
	(SocketInputStream.read): use `VMChannel.read.'
	(SocketInputStream.read): use `SocketChannel.read.'
	(SocketOutputStream.write): use `VMChannel.write.'
	(SocketOutputStream.write): use `SocketChannel.write.'
	* gnu/java/nio/DatagramChannelImpl.java: implement VMChannel.
	(channel): new field.
	(<init>): initialize `channel.'
	(implCloseSelectableChannel): use `VMChannel.close.'
	(implConfigureBlocking): use `VMChannel.setBlocking.'
	(connect): use `VMChannel.connect.'
	(disconnect): use `VMChannel.disconnect.'
	(isConnected): use `VMChannel.getPeerAddress.'
	(write): use `VMChannel.write.'
	(write): use `VMChannel.writeGathering.'
	(read): use `VMChannel.read.'
	(read): use `VMChannel.readScattering.'
	(receive): use `VMChannel.receive.'
	(send): use `VMChannel.send.'
	(getVMChannel): new method.
	* gnu/java/nio/DatagramChannelSelectionKey.java (getNativeFD):
	access native FD through VMChannel.State.
	* gnu/java/nio/FileChannelImpl.java: moved from
	gnu/java/nio/channels/FileChannelImpl.java.
	* gnu/java/nio/FileLockImpl.java: fix imports.
	* gnu/java/nio/KqueueSelectionKeyImpl.java: new file.
	* gnu/java/nio/KqueueSelectorImpl.java: new file.
	* gnu/java/nio/NIOSocket.java (impl): removed.
	(channel): new field.
	(<init>): init superclass with a `NIOSocketImpl;' init `channel.'
	(getPlainSocketImpl, setChannel): removed.
	(isConnected): new method.
	* gnu/java/nio/NIOSocketImpl.java: new file.
	* gnu/java/nio/PipeImpl.java (SourceChannelImpl): implement
	`VMChannelOwner.'
	(SourceChannelImpl.native_fd): removed.
	(SourceChannelImpl.<init>): init with a `VMChannel.'
	(SourceChannelImpl.getNativeFD): removed.
	(SourceChannelImpl.getVMChannel): new method.
	(SourceChannelImpl.implCloseSelectableChannel): implement.
	(SinkChannelImpl): implement `VMChannelOwner.'
	(SinkChannelImpl.native_fd): removed.
	(SinkChannelImpl.<init>): init with a `VMChannel.'
	(SinkChannelImpl.implCloseSelectableChannel): implement.
	(SinkChannelImpl.getNativeFD): removed.
	(SinkChannelImpl.getVMChannel): new method.
	* gnu/java/nio/SelectionKeyImpl.java (getNativeFD): mark
	deprecated.
	* gnu/java/nio/SelectorProviderImpl.java (SELECTOR_IMPL_KQUEUE,
	SELECTOR_IMPL_EPOLL, SELECTOR_IMPL): new constants.
	(openSelector): return kqueue selector if available.
	* gnu/java/nio/ServerSocketChannelImpl.java: implement
	`VMChannelOwner.'
	(channel): new field.
	(<init>): init `channel.'
	(finalizer): check if the `VMChannel.State' is valid.
	(implCloseSelectableChannel): use `VMChannel.close.'
	(implConfigureBlocking): use `VMChannel.setBlocking.'
	(accept): use `VMChannel.accept.'
	(getVMChannel): new method.
	* gnu/java/nio/ServerSocketChannelSelectionKey.java (getNativeFD):
	access native FD through `VMChannel.State.'
	* gnu/java/nio/SocketChannelImpl.java: implement `VMChannelOwner.'
	(impl): removed.
	(channel, connected, connectAddress): new field.
	(<init>): new constructors.
	(getPlainSocketImpl): removed.
	(implCloseSelectableChannel): use `VMChannel.close.'
	(implConfigureBlocking): use `VMChannel.setBlocking.'
	(connect): use `connect(SocketAddress,int).'
	(connect): use `VMChannel.connect.'
	(finishConnect): don't use a selector.
	(isConnected): use `VMChannel.getPeerAddress.'
	(read): use `VMChannel.read.'
	(read): use `VMChannel.readScattering.'
	(write): use `VMChannel.write.'
	(write): use `VMChannel.writeGathering.'
	(getVMChannel): new method.
	* gnu/java/nio/SocketChannelSelectionKey.java (getNativeFD): get
	native FD from `VMChannel.State.'
	* gnu/java/nio/SocketChannelSelectionKeyImpl.java (getNativeFD):
	get native FD from `VMChannel.State.'
	* gnu/java/nio/VMChannelOwner.java: new file.
	* gnu/java/nio/channels/FileChannelImpl.java: removed.
	* include/Makefile.am: generate `gnu_java_nio_FileChannelImpl.h'
	and `gnu_java_nio_KqueueSelectorImpl.h;' don't generate
	`gnu_java_nio_channels_FileChannelImpl.h.'
	* include/gnu_java_net_VMPlainSocketImpl.h: regenerated.
	* include/gnu_java_nio_FileChannelImpl.h: new file.
	* include/gnu_java_nio_KqueueSelectorImpl.h: new file.
	* include/gnu_java_nio_VMChannel.h: regenerated.
	* include/gnu_java_nio_VMPipe.h: regenerated.
	* include/java_net_VMNetworkInterface.h: regenerated.
	* java/io/FileDescriptor.java: fix imports.
	* java/io/FileInputStream.java (<init>): handle exceptions.
	(read): wrap the destination arary.
	* java/io/FileOutputStream.java (<init>): handle exceptions.
	(write): wrap the source array.
	* java/io/RandomAccessFile.java (<init>): handle exceptions.
	* java/net/DatagramSocket.java (<init>): handle exceptions.
	(receive): handle length/port setting.
	(connect): bind to any address/port if the argument is null.
	* java/net/NetworkInterface.java (name, inetAddress): removed.
	(netif): new field.
	(<init>): make private.
	(getName): return `netif.name.'
	(getInetAddresses): access `netif.addresses.'
	(getDisplayName): return `netif.name.'
	(getByName, getByAddress): handle changes to `VMNetworkInterface.'
	(condense): removed.
	(getNetworkInterfaces): handle changes to `VMNetworkInterface.'
	(equals): compare `netif' fields.
	(hashCode): get hash codes from `netif.'
	(toString): use a StringBuffer.
	* java/net/ServerSocket.java (close): don't set `impl' to null.
	(isClosed): use `VMChannel.State.isClosed.'
	* java/net/Socket.java (getLocalAddress): don't use `getOption' if
	the `SocketImpl' is a `PlainSocketImpl.'
	(close): just close the `impl.'
	(toString): use `super.toString' in the value we return.
	(isConnected): just access `impl,' not `getImpl.'
	(isBound): use `PlainSocketImpl' methods if we can.
	(isClosed): look at `VMChannel.State.'
	* native/jni/classpath/jcl.c (JNI_OnLoad): new function.
	(JCL_NewRawDataObject): don't initialize cached fields here; throw
	an exception if they were not.
	(JCL_GetRawData): throw an exception if cached fields weren't
	created.
	* native/jni/java-lang/java_lang_VMProcess.c: handle
	FileChannelImpl move.
	* native/jni/java-net/gnu_java_net_VMPlainSocketImpl.c
	(IO_EXCEPTION, SOCKET_EXCEPTION, BIND_EXCEPTION,
	THROW_NO_NETWORK): new macros.
	(Java_gnu_java_net_VMPlainSocketImpl_bind): reipmlemented.
	(Java_gnu_java_net_VMPlainSocketImpl_bind6): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_listen): reimplemented.
	(java_sockopt): new enum.
	(Java_gnu_java_net_VMPlainSocketImpl_setOption): reimplemented.
	(Java_gnu_java_net_VMPlainSocketImpl_getOption): reimplemented.
	(Java_gnu_java_net_VMPlainSocketImpl_shutdownInput):
	reimplemented.
	(Java_gnu_java_net_VMPlainSocketImpl_shutdownOutput):
	reimplemented.
	(Java_gnu_java_net_VMPlainSocketImpl_sendUrgentData): new
	function.
	(Java_gnu_java_net_VMPlainSocketImpl_join): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_join6): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_read): removed.
	(Java_gnu_java_net_VMPlainSocketImpl_leave): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_leave6): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_joinGroup): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_write): removed.
	(Java_gnu_java_net_VMPlainSocketImpl_joinGroup6): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_leaveGroup): new function.
	(Java_gnu_java_net_VMPlainSocketImpl_leaveGroup6): new function.
	(getif_address): new function.
	(getif_index): new function.
	* native/jni/java-net/java_net_VMNetworkInterface.c
	(java_net_VMNetworkInterface_init,
	java_net_VMNetworkInterface_addAddress): new file-scope globals.
	(Java_java_net_VMNetworkInterface_initIds): new function.
	(struct netif_entry): new struct.
	(free_netif_list): new function.
	(Java_java_net_VMNetworkInterface_getInterfaces): removed.
	(Java_java_net_VMNetworkInterface_getVMInterfaces): new function.
	* native/jni/java-nio/Makefile.am (libjavanio_la_SOURCES): remove
	gnu_java_nio_channels_FileChannelImpl.c, add
	gnu_java_nio_KqueueSelectorImpl.c.
	* native/jni/java-nio/gnu_java_nio_KqueueSelectorImpl.c: new file.
	* native/jni/java-nio/gnu_java_nio_VMChannel.c
	(INTERRUPTED_IO_EXCEPTION, SOCKET_TIMEOUT_EXCEPTION, ALIGN_UP,
	ALIGN_DOWN): new macros.
	(JCL_init_buffer): get the address through GetDirectBufferAddress
	if possible.
	(Java_gnu_java_nio_VMChannel_stdin_1fd,
	Java_gnu_java_nio_VMChannel_stdout_1fd,
	Java_gnu_java_nio_VMChannel_stderr_1fd): new functions.
	(Java_gnu_java_nio_VMChannel_setBlocking): fix setting blocking
	value.
	(Java_gnu_java_nio_VMChannel_read): renamed...
	(Java_gnu_java_nio_VMChannel_read__ILjava_nio_ByteBuffer_2): to
	this; handle interrupted IO; add HAVE_READ check.
	(Java_gnu_java_nio_VMChannel_write): renamed...
	(Java_gnu_java_nio_VMChannel_write__ILjava_nio_ByteBuffer_2): to
	this; handle zero-length write; add HAVE_WRITE check.
	(Java_gnu_java_nio_VMChannel_receive): new function.
	(Java_gnu_java_nio_VMChannel_send): new function.
	(Java_gnu_java_nio_VMChannel_send6): new function.
	(Java_gnu_java_nio_VMChannel_read__I): new function.
	(Java_gnu_java_nio_VMChannel_write__II): new function.
	(Java_gnu_java_nio_VMChannel_socket): new function.
	(Java_gnu_java_nio_VMChannel_connect): new function.
	(Java_gnu_java_nio_VMChannel_connect6): new function.
	(Java_gnu_java_nio_VMChannel_getsockname): new function.
	(Java_gnu_java_nio_VMChannel_getpeername): new function.
	(Java_gnu_java_nio_VMChannel_accept): new function.
	(Java_gnu_java_nio_VMChannel_disconnect): new function.
	(Java_gnu_java_nio_VMChannel_close): new function.
	(Java_gnu_java_nio_VMChannel_available): new function.
	(FileChannel_mode): new enum.
	(Java_gnu_java_nio_VMChannel_open): new function.
	(Java_gnu_java_nio_VMChannel_position): new function.
	(Java_gnu_java_nio_VMChannel_seek): new function.
	(Java_gnu_java_nio_VMChannel_truncate): new funciton.
	(Java_gnu_java_nio_VMChannel_lock): new function.
	(Java_gnu_java_nio_VMChannel_unlock): new function.
	(Java_gnu_java_nio_VMChannel_size): new function.
	(Java_gnu_java_nio_VMChannel_map): new function.
	(Java_gnu_java_nio_VMChannel_flush): new function.
	* native/jni/java-nio/gnu_java_nio_VMPipe.c
	(Java_gnu_java_nio_VMPipe_init): removed.
	(Java_gnu_java_nio_VMPipe_pipe0): new function.
	* native/jni/java-nio/javanio.c: new file.
	* native/jni/java-nio/javanio.h: new file.
	* native/jni/native-lib/cpnet.c (cpnet_getHostByName): fix for
	systems without `gethostbyname_r.'
	* vm/reference/gnu/java/net/VMPlainSocketImpl.java (nfd): new
	field.
	(<init>, <init>): new constructors.
	(setOption, getOption): make instance methods; defer to native
	implementation.
	(connect): removed.
	(bind): make an instance method; defer to native methods.
	(accept): removed.
	(available): removed.
	(listen): make an instance method; defer to native method.
	(read): removed.
	(join, leave): new methods.
	(write): removed.
	(joinGroup, leaveGroup): new methods.
	(shutdownInput, shutdownOutput): make instance methods.
	(sendUrgentData): removed.
	(State): new class.
	* vm/reference/gnu/java/nio/VMChannel.java: make final.
	(fd): removed.
	(nfd): new field.
	(<init>): new, public constructors.
	(getVMChannel): methods removed.
	(getState, getStdin, getStdout, getStderr, stdin_fd, stdout_fd,
	stderr_fd): new methods.
	(setBlocking): make an instance method.
	(available): new method.
	(read): get native fd from `nfd.'
	(read): new single-byte read method.
	(readScattering): get native fd from `nfd.'
	(receive): new method.
	(write, writeGathering): get native fd from `nfd.'
	(send): new method.
	(write): new single-byte write method.
	(initSocket): new method.
	(connect): new method.
	(disconnect): new method.
	(getLocalAddress): new method.
	(getPeerAddress): new method.
	(accept): new method.
	(openFile): new method.
	(position): new method.
	(seek): new method.
	(truncate): new method.
	(lock): new method.
	(unlock): new method.
	(size): new method.
	(map): new method.
	(flush): new method.
	(close): new method.
	(State): new class.
	(Kind): new class.
	* vm/reference/gnu/java/nio/VMPipe.java (init): removed.
	(pipe, pipe0): new method.
	* vm/reference/java/net/VMNetworkInterface.java (name, addresses):
	new fields.
	(<clinit>): call `initIds.'
	(initIds): new method.
	(getInterfaces): removed.
	(getVMInterfaces): new method.
	(addAddress): new method.
	* vm/reference/java/nio/channels/VMChannels.java: fix imports.

2006-09-16  Chris Burdess  <dog@gnu.org>

	Fixes PR 28572.
	* gnu/xml/transform/StreamSerializer.java: Don't escape XML entities
	  when in text output mode.

2006-09-16  Chris Burdess  <dog@gnu.org>

	Fixes PR 27293.
	* gnu/xml/dom/DomNode.java: Increment length of node during insert.

2006-09-14  Michael Koch  <konqueror@gmx.de>

	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h: Recreated.

2006-09-15  Chistian Elias Naur  <elias@oddlabs.com>

	* java/io/ObjectStreamClass.java (setClass(Class, ObjectStreamClass)):
	Added !cl.isArray() to serialVersionUID mismatch check.

2006-09-14  Francis Kung  <fkung@redhat.com>

	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_CairoGraphics2D.c
	(gnu_java_awt_peer_gtk_CairoGraphics2D_setGradient): Updated constants to
	be compatibe with Cairo 1.2.x.

2006-09-14  Francis Kung  <fkung@redhat.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java: Added interpolation constants.
	(cairoSurfaceSetFilter): Removed method.
	(drawImage): Pass interpolation type as argument to drawing methods.
	(drawPixels): Added interpolation parameter.
	(drawRaster): Pass interpolation type as argument to drawing method.
	(getInterpolation): New method.
	(setRenderingHint): Store hints, but do not set interpolation in cairo.
	(setRenderingHints): Store hints, but do not set interpolation in cairo.
	* gnu/java/awt/peer/gtk/CairoSurface.java
	(drawSurface): Added interpolation parameter.
	(nativeDrawSurface): Added interpolation parameter.
	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h
	(Java_gnu_java_awt_peer_gtk_CairoGraphics2D_drawPixels): Added interpolation
	parameter.
	(Java_gnu_java_awt_peer_gtk_CairoGraphics2D_cairoSurfaceSetFilter): Removed.
	* native/jni/gtk-peer/cairographics2d.h
	(java_awt_rendering_hints_filter): Added bicubic interpolation constant.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_CairoGraphics2D.c
	(Java_gnu_java_awt_peer_gtk_CairoGraphics2D_drawPixels): Added interpolation
	parameter.
	(Java_gnu_java_awt_peer_gtk_CairoGraphics2D_cairoSurfaceSetFilter): Removed.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_CairoSurface.c
	(Java_gnu_java_awt_peer_gtk_CairoSurface_nativeDrawSurface): Added
	interpolation parameter.

2006-09-14  Gary Benson  <gbenson@redhat.com>

	* java/net/InetAddress.java
	(internalGetCanonicalHostName): New method.
	(getCanonicalHostName): Use internalGetCanonicalHostName.
	(getByLiteral): New method.
	(getAllByName): Use getByLiteral.
	* java/net/SocketPermission.java
	(host): Replaced with...
	(hostname, address): New fields.
	(equals, hashcode): Reflect the above.
	(setHostPort): Parse host into hostname or address.
	(implies): Rewrite host checks.

2006-09-14  David Gilbert  <david.gilbert@object-refinery.com>

	Fixes PR28699
	* java/awt/Menu.java
	(insert(MenuItem, int)): Fixed loop range,
	(insert(String, int)): Updated API docs.

2006-09-14  Christian Thalinger  <twisti@complang.tuwien.ac.at>

	Fixes PR22800
	* native/fdlibm/mprec.h (Storeinc): Define correctly for LE
	architectures (like Arm).
	* native/jni/java-lang/java_lang_VMDouble.c (doubleToLongBits):
	Reverted SWAP_DOUBLE patch.
	(doubleToRawLongBits): Likewise.
	(longBitsToDouble): Likewise.

2006-09-14  David Gilbert  <david.gilbert@object-refinery.com>

	* java/awt/Menu.java: Reformatted source file.

2006-09-14  Jeroen Frijters  <jeroen@frijters.net>

	* gnu/java/rmi/server/ActivatableRef.java
	(readExternal, writeExternal): Partial fix for serialization format.

2006-09-14  Jeroen Frijters  <jeroen@frijters.net>

	PR classpath/28984
	* java/io/InputStreamReader.java
	(read(char[],int,int)): Fixed bug.

2006-09-13  Francis Kung  <fkung@redhat.com>

	* java/awt/image/BandCombineOp.java: Updated documentation.
	(filter(Raster, WritableRaster)): Use int arrays, and added simple cache.

2006-09-13  Tom Tromey  <tromey@redhat.com>

	PR classpath/29034:
	* java/io/PipedReader.java (read): Return early if len==0.
	* java/io/PipedInputStream.java (read): Return early if len==0.

2006-09-13  Francis Kung  <fkung@redhat.com>

	* java/awt/image/ConvolveOp.java (filter(Raster, WritableRaster)):
	Removed hard-coded max sample value.
	* java/awt/image/RescaleOp.java (filter(Raster, WritableRaster)): 
	Fixed finding of max sample value.

2006-09-12  David Gilbert  <david.gilbert@object-refinery.com>

	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(setPaint): Check null argument ('p').

2006-09-12  Francis Kung  <fkung@redhat.com>

	PR 27940
	* gnu/java/awt/java2d/TexturePaintContext.java
	(constructor): Fixed typo, getMinY instead of getMaxX.
	* gnu/java/awt/peer/gtk/CairoGraphics2D.java
	(setPaint): Implemented support for custom Paint classes.
	(setPaintPixels): Renamed from setTexturePixels, added repeat parameter.
	(setTexturePixels): Renamed to setPaintPixels, added repeat parameter.
	* include/gnu_java_awt_peer_gtk_CairoGraphics2D.h: Renamed setTexturePixels
	to setPaintPixels, and added repeat parameter.
	* native/jni/gtk-peer/gnu_java_awt_peer_gtk_CairoGraphics2D.c:
	 Renamed setTexturePixels to setPaintPixels, and added repeat parameter.

2006-09-12  Gary Benson  <gbenson@redhat.com>

	* java/net/NetworkInterface.java (getInetAddresses):
	Fix port used in security check.

2006-09-12  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/metal/DefaultMetalTheme.java
	(CONTROL_TEXT_FONT): Renamed 'controlTextFont',
	(MENU_TEXT_FONT): Renamed 'menuTextFont',
	(getControlTextFont): Check 'swing.boldMetal' setting before 
	initialising font,
	(getMenuTextFont): Likewise.

2006-09-12  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/metal/OceanTheme.java
	(addCustomEntriesToTable): Added 'List.focusCellHighlightBorder' entry.

2006-09-12  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/plaf/metal/MetalIconFactory.java
	(InternalFrameDefaultMenuIcon.paintIcon): Use theme colors.

2006-09-12  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/AbstractSpinnerModel.java: API doc updates.

2006-09-12  David Gilbert  <david.gilbert@object-refinery.com>

	* javax/swing/AbstractButton.java
	(AbstractButton): Initialise textIconGap field.

2006-09-11  Tom Tromey  <tromey@redhat.com>

	* tools/gnu/classpath/tools/javah/FieldHelper.java (print): Print
	"volatile" when needed.

2006-09-11  David Gilbert  <david.gilbert@object-refinery.com>

	* java/text/AttributedCharacterIterator.java
	(LANGUAGE): Initialise with lower case string,
	(INPUT_METHOD_SEGMENT): Likewise,
	(READING): Likewise,
	* java/text/AttributedStringIterator.java
	(getRunLimit): Check all attributes for changes.

2006-09-11  David Gilbert  <david.gilbert@object-refinery.com>

	* java/text/AttributedCharacterIterator.java: Added @since tag, 
	renamed some variables (no underscores) and removed some spaces to
	match the common style,
	* java/text/AttributedString.java: Likewise,
	* java/text/AttributedStringIterator.java: Likewise.

2006-09-11  Gary Benson  <gbenson@redhat.com>

	* java/net/Inet4Address.java
	(FAMILY): Renamed back to AF_INET.
	(<init>, writeReplace): Reflect the above.
	* java/net/Inet6Address.java
	(FAMILY): Renamed back to AF_INET6.
	(<init>): Reflect the above.

2006-09-11  Cameron McCormack  <cam-gcc-bugzilla@aka.mcc.id.au>

	Fixes PR29010
	* java/text/AttributedString.java
	(AttributedString(AttributedCharacterIterator, int, int, 
	AttributedCharacterIterator.Attribute[])): Fixed check for defined 
	attribute.

2006-09-11  Gary Benson  <gbenson@redhat.com>

	* java/net/Inet4Address.java
	(AF_INET): Renamed to FAMILY.
	(<init>, writeReplace): Reflect the above.
	* java/net/Inet6Address.java
	(AF_INET6): Renamed to FAMILY.
	(<init>): Reflect the above.

2006-09-10  Ito Kazumitsu  <kaz@maczuka.gcd.org>

	Fixes bug #28867
	Originally in Kaffe: 2004-04-16  Helmer Kraemer <hkraemer@freenet.de>
	* java/net/ServerSocket.java(implAccept): Deleted socket.implCreated.
	* java/net/Socket.java: Avoid creating a redundant file descriptor.
	(implCreated): Deleted, (getImpl): Don't check impleCreated,
	(bind): Call getImpl().create(true).

2006-09-09  Chris Burdess  <dog@gnu.org>

	* gnu/xml/xpath/Expr.java: Ensure that node-set evaluation returns
	  an instance of org.w3c.dom.NodeList.

2006-09-08  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* tools/gnu/classpath/tools/appletviewer/Main.java: Warn about
	missing security manager when run in standalone mode.

2006-09-08  Francis Kung  <fkung@redhat.com>

	* java/awt/image/AffineTransformOp.java: Updated documentation.
	(createCompatibleDestRaster): Updated formatting.
	(filter(BufferedImage, BufferedImage)): Updated formatting.
	(filter(Raster, WritableRaster)): Delegated processing to native peers for
	if colour model is compatible.
	(filterBicubic): Get entire pixel at once, and use appropriate array type.
	(filterBilinear): Get entire pixel at once, and use appropriate array type.

2006-09-08  Gary Benson  <gbenson@redhat.com>

	* java/net/InetAddress.java
	(family): Updated javadoc and made private.
	(<init>): Add an address family argument.
	(readObject): Don't overwrite family.
	* java/net/Inet4Address.java
	(AF_INET): New constant.
	(<init>): Use AF_INET as the family.
	(writeReplace): Likewise.
	* java/net/Inet6Address.java
	(AF_INET6): New constant.
	(<init>): Use AF_INET6 as the family.

2006-09-08  Gary Benson  <gbenson@redhat.com>

	* java/net/InetAddress.java
	(getHostName): Move lookup into getCanonicalHostName.
	(getCanonicalHostName): Move lookup from getHostName,
	Perform security check on canonical name (ie after lookup).

2006-09-08  Gary Benson  <gbenson@redhat.com>

	* java/net/Inet4Address.java (isMulticastAddress,
	isLoopbackAddress, isAnyLocalAddress, isLinkLocalAddress,
	isSiteLocalAddress, isMCGlobal, isMCNodeLocal, isMCLinkLocal,
	isMCSiteLocal, isMCOrgLocal, getHostAddress): Moved
	implementations from InetAddress.
	* java/net/InetAddress.java (isMulticastAddress,
	isLoopbackAddress, isAnyLocalAddress, isLinkLocalAddress,
	isSiteLocalAddress, isMCGlobal, isMCNodeLocal, isMCLinkLocal,
	isMCSiteLocal, isMCOrgLocal, getHostAddress): Replace
	implementations with UnsupportedOperationExceptions.
	
2006-09-08  Gary Benson  <gbenson@redhat.com>

	* java/net/InetAddress.java
	(inaddr_any): Removed.
	(ANY_IF, LOCALHOST): Create using getByAddress.
	(<init>): Updated javadoc.
	(getHostName): Cache hostname even if the lookup failed.
	(getByAddress): Create Inet4Address objects when passed
	IPv4-mapped IPv6 addresses.
	(aton): Removed.
	(getAllByName): Create address objects using getByAddress.
	Do not perform security checks unless actually required.
	Do not strip whitespace from the hostname.
	(getInaddrAny): Removed.
	(getLocalHost): Return the loopback address if getByName
	throws a SecurityException.
	(readResolve): Updated javadoc.
	* vm/reference/java/net/VMInetAddress.java (aton): Declared.
	* include/java_net_VMInetAddress.h
	(Java_java_net_VMInetAddress_aton): Likewise.
	* native/jni/java-net/java_net_VMInetAddress.c
	(Java_java_net_VMInetAddress_aton): New method.
	* native/jni/native-lib/cpnet.h (cpnet_aton): Declared.
